/*
 * IMPORTANT--READ CAREFULLY:
 *
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document")
 * are governed by a legal Agreement ("Agreement") between you (either an
 * individual or a single entity) and Intersil Americas Inc ("Intersil")
 * and/or its licensee (both hereinafter called Licensor).
 *
 * By reproducing, modifying, creating derivative works, accepting,
 * installing, viewing, accessing, transforming or otherwise using this
 * Document, you agree to be bound by the terms of the Agreement. If you
 * do not agree to the terms of the Agreement, Licensor is unwilling to
 * license rights to this Document to you.  In such event, you may not
 * use, reproduce, modify, create derivative works, install, view, access,
 * transport, transform or circulate this Document, and you should promptly
 * contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION: This Document
 * contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 *
 * Unauthorized use, reproduction, modification, creation of derivative
 * works or circulation is strictly prohibited.
 *
 * Intersil is a registered trademark of Intersil Americas Inc.
 *
 * Copyright (c) 2003 Intersil Americas Inc. All Rights Reserved.
 */


/* 
 * AES routines. These routines are based on the code produced by 
 *
 * Dr. B. R. Gladman (brian.gladman@btinternet.com). 25th January 2000.
 * 
 * They were downloaded from:
 * http://fp.gladman.plus.com/cryptography_technology/aes2/index.htm
 *
 * Be aware: These routines were dedicated for speed testing, however,
 * they match perfectly the CKIP usage of AES. In both cases the AES
 * engine is to be used with a 16 byte key, 16 byte input, and 16 byte
 * output. This made these (optimized) routines ideal for CKIP usage.
 * Do not use (without altering) for any other purpose. The code has 
 * been modified slightly to be more compliant to souce code style and
 * cplusplus parts have been removed. 
 */


#ifndef __aes_h__
#define __aes_h__

//typedef signed char 		int8_t;
typedef unsigned char 		uint8_t;

//typedef short int 		int16_t;
typedef unsigned short int 	uint16_t;

//typedef int 			int32_t;
typedef unsigned int 		uint32_t;

//#if defined(LINUX)
//typedef long long int 		int64_t;
typedef unsigned long long int 	uint64_t;
//#endif

typedef int 			int_t;


enum dir_flag 
{ 
    enc = 1, 
    dec = 2, 
    both = 3 
};

/* key_len is in bits (valid values: 128, 192 or 256) */
extern void aes_set_key(const uint8_t in_key[], const uint32_t key_len, const enum dir_flag f);
extern void aes_encrypt(const uint8_t in_blk[16], uint8_t out_blk[16]);
extern void aes_decrypt(const uint8_t in_blk[16], uint8_t out_blk[16]);


#endif /* __aes_h__ */
