/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */
#ifndef _BLOBSTUFF_H_
#define _BLOBSTUFF_H_

#include "../../kernel/drivers/net/prismeth.h"
#include "bloboid.h"

#include "client.h"


enum portstatus_t {
        UNAUTHORIZED,
        AUTHORIZED
};


int blob_portstatus_set_global(enum portstatus_t state);
int blob_portstatus_set(struct client_t *client, enum portstatus_t state);
int blob_get_client_age(struct client_t *client);
int blob_get_client_state(struct client_t *client);
int blob_authenticate_client(struct obj_mlmeex *mlmeex);
int blob_deauthenticate_all(void);
int blob_deauthenticate_client(struct client_t *client);
int blob_subscribe_assoc_trap(void);
int blob_subscribe_micfailure_trap(void);
int blob_get_mlmeex(struct obj_mlmeex *mlmeex);
int blob_get_sta(struct obj_sta *sta);
int blob_get_privacy_invoked(void);
int blob_set_privacy_invoked(long value);
int blob_set_persta_key(struct client_t *client, int keyid);
int blob_get_mcast_packets(void);
int blob_get_bcast_key(int keyid, char *keybuf, int keylen);
int blob_set_bcast_key(char *key, int keylen, int keyid);
int blob_set_attachment(struct obj_attachment *oa, int len);
int blob_get_stastat(struct obj_stastat *stat);
#endif
