/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */
#ifndef _CONFIG_H_
#define _CONFIG_H_

#include <netinet/in.h>

#include "paed.h"
#include "client.h"
#include "ie.h"
#include "rac.h"
#define CONF_WEP_40_SIZE        5
#define CONF_WEP_104_SIZE       13

/* Compile time flag for MSSID feature. Default value is True(1).
 * Set to 0 to compile out.
 */
#define PAED_MSSID		1	

#define PAED_ON_UAP		0	

struct cfg_opt_t {
        int *varptr;
        int dfltval;
        char *keyword;
};

struct radius_serv_t {
        in_addr_t address;
        int port;
        char secret[MAX_RADIUS_SECRET_LEN];
        int secret_len;
#if (RAC_SUPPORT == RAC_TRUE)
    	int acct_port;
#endif
	struct radius_serv_t *next;
};

#if (PAED_MSSID == 1) 

/* Node for list of clients in the VSS (config structure)
 * Contains a pointer to the concerned client node in the global 
 * client list, and a next pointer.
 */
typedef struct client_ptr_node{
   struct client_t *client_ptr;         /* pointer to the client node */
   struct client_ptr_node *next;
}client_ptr_node_t;

#endif

struct config_t {

        // .1X related configuration

        int suppTimeout;
        int serverTimeout;
        int txPeriod;
        int reAuthPeriod;
        int reAuthMax;
        int quietPeriod;
        int idleTimeout;

        int dot1XRekeying;
        int dot1XRekeySeconds;
        int dot1XRekeyPackets;

        int ssnRekeying;
        int ssnRekeyPackets;
        int ssnRekeySeconds;

        int strictUpdate;

        int enableOS;           // open system
        int enableWEP;          // pre-shared-key (plainoldwep)
        int enableACL;          // Accesslist for OS and PSK
        int enable1X;           // 802.1x enabled
        int enableSSN;          // SSN enabled
        int enableSSNPSK;       // SSN uses pre-shared-key
        char ssnpskASCIIkey[64];  // Input for Password-phrase algoritm
        char ssnpsk256key[32];    // 256 bits hex key for SSN-PSK
        int ssnpsk256keyfiled;
        int Dot1XWEPKeySize;
        int WEPKeySize;
        int WEPexunencrypt;
        
        int wpa_cipher;		// bitmap, 1=tkip 2=aes

        char ssid[32];
        int  ssidlength;

        char ifname[16];
        char ifhwaddr[6];
	unsigned int devid;
        struct gtkmachine_t *cgtk;
        ie_ap wpa_ie;		/* Contains the WPA IE announced in 
                                  		  * the Beacon message.
                                            */
        int DefaultKeyId;
        struct sockaddr eapol_salocal;

#if (PAED_MSSID == 1) 
     int vssid;				  		 /* Virtual service set Id for this VSS*/
     client_ptr_node_t *client_ptr_list; /* List of pointers to clients 
				                               * associated with this VSS
                            				   */ 
	int vlan_tag;			   		 /* the vlan tag associated with the 
			                                     * service set
                     			                */
     int exclusivelimit;         		/* exclusive member limit */  
     int totallimit;                			/* total member limit */   
     int unicastcipher;             		/* The unicast cipher for this VSS */
     int multicastcipher;           		/* The multicast cipher for this VSS */
     char vss_ifname[32];                       /* Name of the VSS. Maximum length is actually 10 */

     char keystable[4][128];                    /* Table of WEP keys */
     int  mixedsecurity;                        /* mixed security enable or disable flag */

#endif

};

struct radius_t {
        // radius servers
        struct radius_serv_t *radius_serv_list;
        struct radius_serv_t *current_radius_serv;
#if (RAC_SUPPORT == RAC_TRUE)
    	struct radius_serv_t *current_rac_serv;
#endif
	int nofRadiusServers;
};

int config_read(void);
int skip_white(char *ptr);



#endif
