/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */
#ifndef _EAP_H_
#define _EAP_H_

#include "client.h"

struct eaphdr {
        unsigned char code;
        unsigned char id;
        unsigned short length;
        unsigned char type;
        unsigned char type_data[1];
} __attribute__ ((__packed__));


/* Header sizes */
#define EAP_HDR_SIZE            4

/* EAPOL Ethertype - not defined in <linux/if_ether.h> */
#define ETH_P_EAP               0x888E

/* EAP Codes */
#define EAP_CODE_REQUEST        0x01
#define EAP_CODE_RESPONSE       0x02
#define EAP_CODE_SUCCESS        0x03
#define EAP_CODE_FAILURE        0x04

/* EAP Types */
#define EAP_TYPE_IDENTITY       0x01
#define EAP_TYPE_NOTIFICATION   0x02
#define EAP_TYPE_NAK            0x03
#define EAP_TYPE_MD5            0x04
#define EAP_TYPE_TLS            0x0d


//protos

void eap_process(struct client_t *client);
int eap_tx(struct client_t *client, unsigned char code, unsigned char type);
int eap_tx_notification(struct client_t *client, char *msg);

#endif
