/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */
#ifndef _IE_H_
#define _IE_H_

#if (!RAC_UT)
#include "prismoids.h"
#endif /*(!RAC_UT)*/
#include "config.h"

#define IEEE_802_11_FRM_TYPE_BEACON	0x80
#define IEEE_802_11_FRM_TYPE_PROBE_RES	0x50

#define WPA_IE_TAG			221
#define WPA_OUI_TYPE			0x01
#define WPA_IE_VERSION 1


/* OUI, TYPE    	=  		 4
 * WPA VERSION		=  		 2
 * OUI, MCAST SUITE	=  		 4
 * NUMBER OF UNICAST    =  		 2
 * NUMBER OF AUTH ALGOR =  		 2
 * OUI, AUTH ALGOR	=  		 4
 * CAPABILITY FIELD	=  		 2
 *                        	       ---+ */
#define WPA_IE_LENGTH			20	/* Unicast suites not included, those are added dynamic */


/* Definition of MULTICAST CIPHERS */
#define MCAST_CIPHER_WEP_40 		0x01
#define MCAST_CIPHER_TKIP		0x02
#define MCAST_CIPHER_AES_VAR_1		0x03
#define MCAST_CIPHER_AES_VAR_2		0x04
#define MCAST_CIPHER_WEP_104		0x05

/* Definition of UNICAST CIPHERS */
#define UCAST_CIPHER_TKIP		0x02
#define UCAST_CIPHER_AES_VAR_1		0x03
#define UCAST_CIPHER_AES_VAR_2		0x04

/* Definition of AUTHENTICATION SUITES */
#define AUTH_UNSPECIFIED_OVER_802_1X 	0x01
#define AUTH_WPA_PSK			0x02

/* Capability Bit mask values */
#define WAP_CAP_UCAST_USING_GROUP	0x02
#define WPA_CAP_1_REPLAY_COUNTER 	0x00
#define WPA_CAP_2_REPLAY_COUNTER 	0x04
#define WPA_CAP_4_REPLAY_COUNTER 	0x08
#define WPA_CAP_16_REPLAY_COUNTER 	0x0C


extern unsigned char *ie;

typedef struct
{
    unsigned int mcast;
    int ucast_count;
    unsigned int ucast[3];
    int auth_count;
    unsigned int auth[3];
    
    char *raw_ie[64];	/* The 'raw' IE as sent in the beacon */
    int raw_ie_length;	/* Size of the raw IE */
} ie_ap;

#if (!RAC_UT)
int ie_set(struct config_t *config);
int ie_check_ellement(unsigned char* p, unsigned int len, struct client_t *client);
#ifdef SMAC
int ie_parse_assocreq(struct obj_mlme *mlmeex, struct client_t *client, int reassoc);
#else
int ie_parse_assocreq(struct obj_mlmeex *mlmeex, struct client_t *client, int reassoc);
#endif	/* SMAC */
#endif /*(!RAC_UT)*/

#endif
