/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */
#ifndef _KEYSTUFF_H_
#define _KEYSTUFF_H_

#include "client.h"

struct key_t {
	char *data;
	int len;
};

void init_bcast_key(struct config_t *config);
int decode_mppe_keys(struct client_t *client, char *mppestr, int len);
int keying_do_client_oldstyle(struct client_t *client);
int update_dot1x_bcast_key(struct client_t *client);

void MIC(u_char *data, int data_len, u_char *key, int key_len, u_char *out);
void MIC_AES(u_char * data, int data_len, u_char * key, int key_len, u_char * out);

void calc_PTK(struct client_t *client, char *ANonce, char *SNonce, char *out, int out_len);
void calc_GTK(struct config_t *configp, char *GMK, int GMK_len, char *GNonce, char *out, int out_len);
void prf(char *secret, int secret_len, char *label, int label_len, char *seed, int seed_len, char *out, int out_len);

void keystuff_setup_key_material(struct config_t *config);
void HashGenerator(char *password, unsigned char *ssid, int ssidlength, int iterations, int count, unsigned char *output);
int PasswordHash (char *password, unsigned char *ssid, int ssidlength, unsigned char *output);

#endif
