/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */

int aplog( unsigned long eventid, ... );

/************ Priorities */

#define PR_EMERG                0x01
#define PR_ALERT                0x02
#define PR_CRIT                 0x03
#define PR_ERR                  0x04
#define PR_WARNING              0x05
#define PR_NOTICE               0x06
#define PR_INFO                 0x07
#define PR_DEBUG                0x08

/************  Facilities */

#define FA_KERNEL               0x01
#define FA_USER                 0x02
#define FA_SECURITY             0x05
#define FA_CLOCK                0x0A
#define FA_LOGAUDIT             0x0E
#define FA_LOGALERT             0x0F
#define FA_SYSTEM               0x11
#define FA_NETWORK              0x12
#define FA_WLAN                 0x13
#define FA_MANAGEMENT           0x14

/************  Events */


/* KERNEL */

#define EV_SYS_BOOT_START       0x06110100
#define EV_SYS_BOOT_COMPLETE    0x07110101
#define EV_SYS_SUBSYS_START     0x07110102
#define EV_SYS_SUBSYS_FAIL      0x04110103
#define EV_SYS_SUBSYS_STOP      0x07110104
#define EV_SYS_SUBSYS_DISABLED  0x07110106
#define EV_SYS_RSPWN_REBOOT     0x01110107
#define EV_SYS_RSPWN_TERM       0x07110108
#define EV_SYS_RSPWN_RESPAWNING 0x06110109
#define EV_SYS_JFFS_MOUNT_FAIL  0x0311010A
#define EV_SYS_UAPFW_MOUNT_FAIL 0x0411010B
#define EV_SYS_KLOG_MSG_EMERG   0x01010105
#define EV_SYS_KLOG_MSG_ALERT   0x0201010C
#define EV_SYS_KLOG_MSG_CRIT    0x0301010D
#define EV_SYS_KLOG_MSG_ERR     0x0401010E

/* USER */

#define EV_NET_IFACE_STATUS     0x07120204
#define EV_NET_IPADDR_START     0x07120205
#define EV_NET_IPADDR_FAIL      0x04120206
#define EV_NET_IPADDR_SUCC      0x06120207
#define EV_NET_IPADDR_INUSE     0x02120208
#define EV_NET_PPP_PAP_FAIL     0x04120209
#define EV_NET_PPP_PAP_SUCC     0x0612020A
#define EV_NET_PPP_CHAP_FAIL    0x0412020B
#define EV_NET_PPP_CHAP_SUCC    0x0612020C
#define EV_NET_SHAREETH_STATUS  0x0712020D
#define EV_NET_NAPT_STATUS      0x0712020E
#define EV_NET_WAN_STATUS       0x0712020F
#define EV_NET_LAN_STATUS       0x07120210
#define EV_NET_PPPOE_TIMEOUT    0x05120211
#define EV_NET_FIREWALL_USER    0x07120212
#define EV_NET_FIREWALL_DFLT    0x07120213
#define EV_NET_PPP_IPCP_FAIL    0x04120214
#define EV_NET_IFACE_FAILED     0x03120215
#define EV_NET_FIREWALL_PR1     0x01120216
#define EV_NET_FIREWALL_PR2     0x02120217
#define EV_NET_FIREWALL_PR3     0x03120218
#define EV_NET_FIREWALL_PR4     0x04120219
#define EV_NET_FIREWALL_PR5     0x05120220
#define EV_NET_FIREWALL_PR6     0x06120221
#define EV_NET_FIREWALL_PR7     0x07120222
#define EV_NET_FIREWALL_PR8     0x08120223
#define EV_NET_PPTP_FAIL        0x04120224
#define EV_NET_PPTP_ERR         0x04120225
#define EV_NET_PPPOE_FAIL       0x04120226
#define EV_NET_PPP_UPTIME       0x07120227
#define EV_NET_PPP_STAT         0x07120228

/*  */

#define EV_EAP_AUTH_START       0x06050300
#define EV_EAP_AUTH_FAIL        0x05050301
#define EV_EAP_AUTH_SUCCESS     0x06050302
#define EV_EAP_AUTH_ABORTED     0x05050303
#define EV_EAP_NO_RADIUS_SRV    0x03050304
#define EV_EAP_RADIUS_TIMEOUT   0x05050305
#define EV_EAP_RADIUS_SRV_ADD   0x07050306
#define EV_EAP_RADIUS_SRV_DEL   0x07050307
#define EV_EAP_MICFAIL_STA      0x02050308
#define EV_EAP_MICFAIL_BROAD    0x02050309
#define EV_EAP_SSNAUTH_FAIL     0x05050310
#define EV_EAP_SSNAUTH_SUCCESS  0x06050311
#define EV_EAP_SSNPSKAUTH_FAIL  0x05050312
#define EV_EAP_SSNPSKAUTH_SUCC  0x06050313
#define EV_EAP_GROUP_KEY_FAIL   0x06030314
#define EV_EAP_GROUP_KEY_SUCC   0x06030315

/*  */

#define EV_NO_USER_CONFIG       0x06140400
#define EV_MERGE_NEW_DEFAULTS   0x06140401
#define EV_MERGE_FAILED         0x05140402
#define EV_NO_USER_CONFIGFILE   0x06140403
#define EV_CONFPARSE_FAILED     0x04140404

/* SECURITY */

#define EV_SNMP_CONFIG_ERROR    0x05140500
#define EV_SNMP_GENERAL_ERROR   0x04140501
#define EV_SNMP_INFO            0x07140502
#define EV_SNMP_SIDED           0x07140503
#define EV_SNMP_DEBUG           0x08140504
#define EV_SNMP_CONFIGFILE_ERROR 0x02140505
#define EV_SNMP_INFO_UPGRADE    0x07140506

/*  */

#define EV_BOA_AUTH_FAILED      0x03140600
#define EV_BOA_GENERAL_ERROR    0x04140601
#define EV_BOA_MOUNT_WFS_FAIL   0x04140602
#define EV_BOA_NO_WEB_FILESET   0x06140603

/*  */

#define EV_DHCPS_SOCK_FAILED    0x04120700
#define EV_DHCPS_NO_CONF_FILE   0x05120701
#define EV_DHCPS_CONFIG_FAILED  0x04120702
#define EV_DHCPS_NO_IP_ADDR     0x07120703
#define EV_DHCPS_POOL_FULL      0x07120704
#define EV_DHCPS_RES_ERROR      0x04120705

/*  */

#define EV_DHCPC_SOCK_FAILED    0x04120800
#define EV_DHCPC_NAK_RECV       0x07120801
#define EV_DHCPC_INF_TIME       0x07120802
#define EV_DHCPC_ADDR_IN_USE    0x07120803
#define EV_DHCPC_NO_IP_ADDR     0x07120804
#define EV_DHCPC_NO_CONF_FILE   0x05120805
#define EV_DHCPC_EXEC_ERROR     0x04120806
#define EV_DHCPC_GENERAL_ERROR  0x04120807

/*  */

#define EV_TFTP_ACCESS_VIOLATION 0x05120900
#define EV_TFTP_ERROR           0x05120901
#define EV_TFTP_INFO            0x07120902
 
