/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <syslog.h>
#include <stdlib.h>

#include "paed.h"
#include "log.h"

static char *levelstr[16] = { 	"???",
				"ftl",
				"err",
				"wrn",
				"inf",
				"dbg" };

static char *ansistr[16] = { 	"",
				"\x1b[01;31m",
				"\x1b[31m",
				"\x1b[01;33m",
				"\x1b[37m",
				"\x1b[01;30m" };

// Show msg from debuglevel and higher.

int loglevel = LG_WRN;
int log_to = 0;
int log_ansicolors = 0;

void log_init(int to, int level, int color)
{
	log_to = to;
	loglevel = level;
	log_ansicolors = color;

	if(log_to & LG_SYSLOG) {
		openlog(PROGNAME, 0, LOG_DAEMON);
	}
}


void log_entry(int flag, char *file, char *func, int line, char *fmt, ...)
{
	va_list ap;
	char buf[256]={0};
	char *p;

	if(flag <= loglevel) {
		if( line )
			// use the detailled presentation
			sprintf( buf, "(%s, %s, %d) ", file, func, line );
		else
			// use the simple presentation
			sprintf( buf, "(%s) ", func );
			
		va_start(ap, fmt);
		vsnprintf(&buf[strlen(buf)], sizeof(buf), fmt, ap);
		va_end(ap);
		
		p=strchr(buf, '\n'); if(p) *p=0;

		if(log_to & LG_SYSLOG) {
			syslog(LOG_DAEMON | LOG_INFO, buf);
		}

		if(log_to & LG_STDERR) {
			if(log_ansicolors) {
				fprintf(stderr, "%s: %s%s %s\x1b[0m\n", PROGNAME, ansistr[flag], levelstr[flag], buf);
			} else {
				fprintf(stderr, "%s: %s %s\n", PROGNAME, levelstr[flag], buf);
			}
		}
	}

	if(flag == LG_FTL) {
//		log(LG_INF, "LOG_FATAL: Aborting program");
		exit(1);
	}
}
