/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */

// set this if you want sourcefile, function and linenumber
// in the logging output

///#define DETAILED_LOGGING



#define DBG log(LG_DBG, "DBG %s.%s line %d\n", __FILE__, __FUNCTION__, __LINE__);


#define LG_STDERR 1
#define LG_SYSLOG 2

// Loglevels. These are a bit like syslog levels, but have nothing
// to do with syslog namespace...

#define LG_DBG 5
#define LG_INF 4
#define LG_WRN 3
#define LG_ERR 2
#define LG_FTL 1	// FATAL aborts the program with exit(1)

void log_init(int to, int level, int color);
void log_entry(int flag, char *file, char *func, int line, char *fmt, ...);

#ifdef DETAILED_LOGGING

#define log(a,args...)	log_entry( a, __FILE__,__FUNCTION__,__LINE__, args );
		
#else

#define log(a,args...)	log_entry( a, NULL, __FUNCTION__, 0, args );

#endif

