/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */
#ifndef _BLOBSTUFF_H_
#define _BLOBSTUFF_H_

#if (!RAC_UT)
#include "prismoids.h"
#endif /*(!RAC_UT)*/


#include "client.h"


enum portstatus_t {
        UNAUTHORIZED,
        AUTHORIZED
};


#if (!RAC_UT)
int open_netlink( struct netlink_handle *blobtrap_h );
void close_netlink( struct netlink_handle *blobtrap_h );
int handle_traps( struct netlink_handle *blobtrap_h );
int blob_set_mlme_mode(long mode, struct config_t *config);
int blob_portstatus_set_global(enum portstatus_t state, struct config_t *config);
int blob_portstatus_set(struct client_t *client, enum portstatus_t state);
int blob_get_client_by_aid(struct config_t *config, int aid, struct obj_sta* sta);
int blob_get_client_age(struct client_t *client);
int blob_get_client_state(struct client_t *client);
#ifdef SMAC
int blob_authenticate_client(struct obj_mlme *mlmeex, struct config_t *config);
int blob_associate_client(struct obj_mlme *mlmeex, struct config_t *config, int reassoc);
#else
int blob_authenticate_client(struct obj_mlmeex *mlmeex, struct config_t *config);
int blob_associate_client(struct obj_mlmeex *mlmeex, struct config_t *config, int reassoc);
#endif
int blob_deauthenticate_all(struct config_t *config);
int blob_deauthenticate_client(struct client_t *client);
int blob_get_privacy_invoked(struct config_t *config);
int blob_set_privacy_invoked(long value, struct config_t *config);
int blob_get_exclude_unencrypted(struct config_t *config);
int blob_set_exclude_unencrypted(long value, struct config_t *config);
int blob_set_persta_key(struct client_t *client, int keyid);
int blob_get_mcast_packets(struct config_t *config);
int blob_get_bcast_key(int keyid, char *keybuf, int keylen, struct config_t *config);
int blob_set_bcast_key(char *key, int keylen, int keyid, char *ifname);
int blob_set_bcast_keyid(int keyid, char *ifname);
int blob_set_attachment(struct obj_attachment *oa, int len, struct config_t *config);
#ifdef BLOB_V1
int blob_get_stastat(struct obj_stastat *stat, struct config_t *config);
#endif
#ifdef BLOB_V2
int blob_get_stasc(struct obj_stasc *stat, struct config_t *config);
#endif
#ifdef SMAC
int blob_set_mlme_policies(int policies, char *ifname);
int blob_get_mlme_policies(int *policies, char *ifname);
int blob_commit_settings(struct config_t *config);
#ifdef LINUX
int blob_set_ssid(struct config_t *config);
#endif	// LINUX
#endif  // SMAC
#if (RAC_SUPPORT == RAC_TRUE)
#ifdef SMAC

int blob_get_stastats(struct client_t *client, struct obj_stastats *stastats, struct config_t *config);
	
long blob_get_input_octet_count(struct client_t *client);
	        
long blob_get_output_octet_count(struct client_t *client);
	       
long blob_get_output_acct_packet_count(struct client_t *client);
	     
long blob_get_input_acct_packet_count(struct client_t *client);

int blob_send_null_data_request(struct obj_mlme *mlmeex, struct config_t *config);
	
#endif //SMAC
#endif//RAC_SUPPORT

#endif /*(!RAC_UT)*/




#if (PAED_MSSID == 1)

int blob_mssid_configure_service_set(struct config_t *configp, obj_serviceset *servicesetp);

int blob_mssid_set_sta_vss(struct config_t *configp, char *sta_addr, int vssid);

int blob_mssid_deauth_vss(struct config_t *configp, int vssid);

int blob_mssid_reset_softmac(char *ifname);

int blob_mssid_reset_service_set(char *ifname, int vssid, obj_serviceset *servicesetp);

int blob_mssid_set_bcast_key(struct config_t *configp, char *keybuf, int keylen, int keyid);

int blob_mssid_commit_settings(char *ifname);

int blob_mssid_wireless_interface(char *iface);

#endif /* #if (PAED_MSSID == 1) */


#endif  // _BLOBSTUFF_H_


