/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */
#ifndef __EAPD_H__
#define __EAPD_H__

#include "version_info.h"

// Global program info

#define PROGNAME                "paed"
//#define VERSION                 "4.00"
#define VERSION			VERSIONID

// Define this to enable debug-printing of key-info
// when the -d argument is given.

#define DEBUG_PRINTKEYS

#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

// Key-ID's that are used in the MVC.

#define PERSTA_KEYID            0       // Used for per-station key
#define PERSTA_KEYID_STATIC     1       // Used for per-station key when legacy WEP is on.
#define BCAST_KEYID_STATIC      0       // Used for static broadcast keys for legacy WEP
#define BCAST_KEYID             2       // Used for broadcast key

#ifndef LINUX
// Interfaces
#define MAX_INTERFACES          2
#define IF_CONF_FIRST           "eth1"
//#define IF_WIRELESS             "eth3"
#define IF_NAS                  "br0:0"

// Various filenames
#define PATH_CMD_SOCKET         "/var/run/paed.sock"
#define PATH_LOCKFILE           "/var/run/paed.pid"
#define PATH_RESPAWND_FILE      "/var/respawnd/fatal/paed"
#define PATH_URANDOM            "/dev/urandom"

#define PATH_RADIUS_CONF        "/var/etc/radius.conf"
#define PATH_ACL_CONF           "/var/etc/acl.conf"
#define PATH_ETH_CONF           "/var/etc"

#else
// Interfaces
#define MAX_INTERFACES          4
#define IF_CONF_FIRST           "eth0"
//#define IF_WIRELESS             "eth1"
#define IF_NAS                  "br0"

// Various filenames
#define PATH_CMD_SOCKET         "/var/run/paed.sock"
#define PATH_LOCKFILE           "/var/run/paed.pid"
#define PATH_URANDOM            "/dev/urandom"

#define PATH_RADIUS_CONF        "/etc/paed/radius.conf"
#define PATH_ACL_CONF           "/etc/paed/acl.conf"
#define PATH_ETH_CONF           "/etc/paed"

#endif

// Some hardcoded values

#define SESSION_KEY_LEN         32
#define MAX_RADIUS_SECRET_LEN   32
#define MAX_RADIUS_STATE_LEN    64
#define MAX_EAP_IDENTITY_LEN    128

#define MS_VENDOR_STRING        "\x00\x00\x01\x37"

#define PTK_LEN                 32
#define PMK_LEN                 32
#define PSK_LEN                 32
#define GTK_LEN                 32
#define GMK_LEN                 32
#define NONCE_LEN               32
#define MIC_LEN                 16

inline int paed_get_nof_interfaces(void);


#endif /* __EAPD_H__ */
