/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */
#ifndef _RADIUS_H_
#define _RADIUS_H_

#include <netinet/in.h>
#include "client.h"
#include "mssid.h"


// Radius phases

#define RP_IDENT 0
#define RP_CHALLENGE 1

// radius codes

#define RC_ACCESS_REQUEST	1
#define RC_ACCESS_ACCEPT	2
#define RC_ACCESS_REJECT	3
#define RC_ACCESS_CHALLENGE	11

// radius types

#define RT_STRING	1
#define RT_ADDRESS	2
#define RT_INTEGER	3
#define RT_TIME		4

// radius attributes

#define RA_USERNAME			1
#define RA_NAS_IP_ADDRESS		4
#define RA_FRAMED_MTU			12
#define RA_REPLY_MESSAGE		18
#define RA_STATE			24
#define RA_VENDOR_SPECIFIC		26
#define RA_SESSION_TIMEOUT		27
#define RA_IDLE_TIMEOUT			28
#define RA_CALLED_STATION_ID		30
#define RA_CALLING_STATION_ID		31
#define RA_NAS_IDENTIFIER		32
#define RA_NAS_PORT_TYPE		61
#define RA_CONNECT_INFO			77
#define RA_EAP_MESSAGE			79
#define RA_MESSAGE_AUTHENTICATOR	80


#if (PAED_MSSID == 1)

/* #defines for VLAN assignment support */
#define RA_TUNNEL_TYPE				64	
#define RA_TUNNEL_MEDIUM_TYPE		        65
#define RA_TUNNEL_PRIVATE_GROUP_ID		81

/* Value of Tunnel type for VLAN support */
#define RADIUS_TUNNEL_TYPE_VLAN			13

/* value for tunnel medium type attribute*/
#define  RA_TUNNEL_MEDIUM_TYPE_VAL_802          6

#endif /* #if (PAED_MSSID == 1) */

struct radius_hdr_t {
	char 	code;
	char 	ident;
	unsigned short	len;
	char	auth[16];
} __attribute__ ((__packed__));


/* radius.c */
int radius_rx(struct client_t *client);
int radius_tx(struct client_t *client);
int radius_open(struct client_t *client);
int radius_close(struct client_t *client);

#endif



