/*
 *
 *
 * IMPORTANT--READ CAREFULLY:
 * Right, including without limitation, use, reproduction, modification, and
 * creation of derivative works, pertaining to this Source Code ("Document") are
 * governed by a legal Agreement ("Agreement") between you (either an individual or
 * a single entity) and Intersil Americas Inc ("Intersil") and/or its licensee
 * (both hereinafter called Licensor).
 * By reproducing, modifying, creating derivative works, accepting, installing,
 * viewing, accessing, transforming or otherwise using this Document, you agree
 * to be bound by the terms of the Agreement. If you do not agree to the terms of
 * the Agreement, Licensor is unwilling to license rights to this Document to you.
 * In such event, you may not use, reproduce, modify, create derivative works, install,
 * view, access, transport, transform or circulate this Document, and you should
 * promptly contact Licensor from which you acquired this Document for instructions
 * on returning or destroying this Document.
 *
 * CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 * This Document contains confidential, proprietary and trade secret information of
 * Intersil Americas Inc. and should be treated in a confidential manner.
 * Furthermore, this Document is protected by national copyright laws and
 * international treaties.
 * Unauthorized use, reproduction, modification, creation of derivative works or
 * circulation is strictly prohibited.
 *
 * Intersil  is a registered trademark of Intersil Americas Inc.
 *
 * Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 *
 *
 */

/*
 * Revision Control System Keywords:
 * $Header   : $
 * $DateTime : $
 * $Change   : $
 * $Author   : $
 */

enum gtkstate_t {
	GTK_INITIALIZE,
	GTK_SETKEYS,
	GTK_SETKEYSDONE
};


struct gtkmachine_t {

	enum gtkstate_t state;

	int 	GNoStations;
	int 	GKeyReady;
	int 	GKeyDoneStations;
	int 	GTKKeyActive;        // If the current key is already set in MVC
	int 	GInitDone;
	int 	GUpdateStationKeys;
	int 	GM;
	int 	GN;
	u_char	GMK[GMK_LEN];
	u_char 	Counter[32];
	u_char	GNonce[NONCE_LEN];
	u_char	GTK[4][GTK_LEN];
	int 	gtk_len;

	int 	reKeyTime;
	int 	reKeyPackets;

	long	lastRekeySeconds;
	long 	lastRekeyPackets;
	int 	intFailWhile;
};

// protos

void gtk_check_states(struct config_t *config);
int gtk_initialize(struct config_t *config);
int gtk_setkeys(struct config_t *config);
int gtk_setkeysdone(struct config_t *config);
int gtk_integrityfailure(struct config_t *config);

// helper protos

char *gtk_inc_counter(struct config_t *config);
