/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the ememntity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, w;hether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *;
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#define __KERNEL_SYSCALLS__

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/pci.h>
#include <linux/string.h>
#include <linux/poll.h>
#include <asm/uaccess.h>

#include "sm_drv.h"

#ifdef PCIUART
#include "sm_drv_uartpci.h"
#endif

#ifdef UMAC_PROFILER
#include "sm_drv_prof.h"
#endif

#ifdef NETLINK_SUPPORT
#include "sm_drv_netlink.h"
#endif

#ifdef WDS_SUPPORT
#include "sm_drv_wds.h"
#endif

#ifdef VSSDEV_SUPPORT
#include "sm_drv_vss.h"
#endif

#ifdef CONFIG_8827_DEBUG
#include "sm_drv_8827.h"
#endif

#ifdef MEMORY_TRACER
#include "sm_drv_memuse.h"
#endif

extern char driver_name[64];

#ifdef NETLINK_SUPPORT
extern int src_seq;
#endif


/* for linux/unistd.h */
int errno;

unsigned int driver_debug = DEBUG_LEVEL;
unsigned int boot_mode = SM_MODE_AP;
struct net_device *root_sm_drv_device = NULL;

#ifdef MODULE
MODULE_PARM( boot_mode, "i" );
#endif

/******************************************************************************
 *   Static Functions
 ******************************************************************************/
static struct s_sm_frame *frame_alloc(struct net_device *dev);
static void frame_free(struct net_device *dev, struct s_sm_frame *framep);

static int sm_drv_reset(struct net_device *dev, uint8_t sm_mode);


/******************************************************************************
 *   Helper Functions
 ******************************************************************************/
static char *sprint_ic_msg(struct s_ic_msg *ic_msg)
{
    static char icmsg_string[50];
    if(ic_msg) {
        snprintf(icmsg_string, 50, "ic_msg %p, data %p addr %x frm %p len %d flg 0x%x channel %d",
                 ic_msg, ic_msg->data, ic_msg->address, ic_msg->frame, ic_msg->length,
                 ic_msg->flags, ic_msg->channel);
    } else {
        sprintf(icmsg_string, "NULL");
    }

    return icmsg_string;
}

static inline void sm_drv_schedule_bh(struct net_device *dev)
{
    struct net_local *lp = dev->priv;

    queue_task( &lp->tqueue, &tq_immediate );
    mark_bh(IMMEDIATE_BH);
}


static struct s_sm_frame *frame_alloc(struct net_device *dev)
{
    int size;
    size = ALIGN(sizeof(struct s_sm_frame)) + sizeof(struct s_ic_msg);

#ifdef MEMORY_TRACER
    return mu_kmalloc(size, GFP_ATOMIC, 1);
#else
    return kmalloc(size, GFP_ATOMIC);
#endif
}

static void frame_free(struct net_device *dev, struct s_sm_frame *framep)
{
#ifdef MEMORY_TRACER
    mu_kfree(framep, 2);
#else
    kfree(framep);
#endif
}

#ifdef WDS_SUPPORT
struct s_sm_frame *skb_to_frame(struct net_device *dev, struct sk_buff *skb, int wds)
{
#else
struct s_sm_frame *skb_to_frame(struct net_device *dev, struct sk_buff *skb)
{
#endif
    struct net_local *lp = dev->priv;
    struct s_sm_frame *framep;
    int sm_trailer = lp->sm_descr.trailer;

    DEBUG(DBG_FRAME, "skb_to_frame\n   skb %p\n   data %p\n   len %d\n", skb, skb->data, skb->len);

#ifdef WDS_SUPPORT
    if( wds )
        /* update the required tailroom for WDS address */
        sm_trailer += 6;
#endif

    /* We need to copy the sk_buff when it is cloned because the UMAC may change
     * the payload of the sk_buff
     */
    if( skb_headroom(skb) < lp->sm_descr.header ||
        skb_tailroom(skb) < sm_trailer || skb_cloned  (skb) ) {
#ifdef WDS_SUPPORT
        DEBUG(DBG_FRAME, "skb_to_frame copying skb (head %d tail %d) wds %d\n",
              skb_headroom(skb), skb_tailroom(skb), wds);

        framep = frame_skb_alloc(dev, (wds ? skb->len+6 : skb->len), 0);

        if(!framep)
            goto err_out;

        memcpy( (wds ? framep->data+6 : framep->data), skb->data, skb->len);
#else
        DEBUG(DBG_FRAME, "skb_to_frame copying skb (head %d tail %d)\n",
              skb_headroom(skb), skb_tailroom(skb));

        framep = frame_skb_alloc(dev, skb->len, 0);

        if(!framep)
            goto err_out;

        memcpy(framep->data, skb->data, skb->len);
#endif

        DEBUG(DBG_FRAME, "skb_to_frame: New frame cause head %d tail %d or cloned %d len: %d\n",
                                skb_headroom(skb),
                                skb_tailroom(skb),
                                skb_cloned  (skb),
                                skb->len);

#ifdef MEMORY_TRACER
        mu_dev_kfree_skb(skb, 3);
#else
        dev_kfree_skb(skb);
#endif
    } else {
#ifdef WDS_SUPPORT
        /* wds requires an additional field of 6 bytes */
        if( wds )
        {
            skb_put( skb, 6 );
            memmove( skb->data+6, skb->data, skb->len-6 );
        }
#endif

        framep = frame_alloc(dev);
        if(!framep)
            goto err_out;

        memset(framep, 0, sizeof(struct s_sm_frame));
        framep->handle = (uint32_t)skb;
        framep->data = skb->data;
        framep->length = skb->len;
    }

    DEBUG(DBG_FRAME, "   frame %p\n   frame->data %p\n", framep, framep->data);

    return framep;

err_out:
    DEBUG(DBG_FRAME, " ...ERROR\n");

    return NULL;
}

struct sk_buff *frame_to_skb(struct net_device *dev, struct s_sm_frame *framep)
{
    struct sk_buff *skb = (struct sk_buff *)framep->handle;
    int offset;
    uint8_t *src;

    DEBUG(DBG_FRAME, "frame_to_skb:\n   frame %p\n   skb %p\n   data %p\n   len %d\n   flags 0x%x\n   prio %d\n\n",
          framep, skb, framep->data, framep->length,
          framep->flags, framep->priority);

    /* determine shift in framep->mpdu between add and rx */
    offset = framep->data - skb->data;

#if (DEBUG_LEVEL & DBG_FRAME)
    /* paranoia */
    if(framep->data < skb->head || (framep->data + framep->length) > skb->end) {
        printk(KERN_ERR "ERROR: frame not within skb\n");
        printk(KERN_ERR "  frame %p data %p len %d flags 0x%x prio %d annex %p\n",
            framep, framep->data, framep->length, framep->flags, framep->priority, framep->annex);
        printk(KERN_ERR "  skb %p head %p data %p tail %p end %p len %d\n",
            skb, skb->head, skb->data, skb->tail, skb->end, skb->len);
        BUG();
    }
#endif

    skb_reserve(skb, offset);
    skb_put(skb, (framep->length - skb->len));

    /* determine offset between IP header and a word boundary */
    offset = (int) (skb->data + 6 + 6 + 2) & 0x03;

    /* if there is any, shift the data */
    if (offset)
    {
        if (skb_headroom(skb) < offset)
        {
            if (skb_tailroom(skb) < (4 - offset))
                printk(KERN_NOTICE "Unaligned skb\n");
            else
                offset = 4 - offset;
        }
        else
            offset = -offset;
        src = skb->data;
        skb_reserve (skb, offset);

        DEBUG(DBG_FRAME, "frame_to_skb: unaligned RX source: %p dest: %p length: %d ", src, skb->data, skb->len);
        DEBUG(DBG_FRAME, "offset: %d\n", offset);

        memmove( skb->data, src, skb->len );
    }

    frame_free(dev, framep);

    return skb;
}

struct s_sm_frame *frame_skb_alloc(struct net_device *dev, uint32_t length,
                                          uint16_t data_offset)
{
    struct net_local *lp = dev->priv;
    struct s_sm_frame *framep;
    struct sk_buff *skb;
    unsigned int len;

    DEBUG(DBG_FRAME, "frame_skb_alloc: len %d\n", length);

#if (DEBUG_LEVEL & DBG_FRAME)
    /* paranoia? */
    if(!lp->sm_descr.mtu) {
        printk(KERN_ERR "frame_skb_alloc: SoftMAC not initialized\n");
        goto err_out;
    }
#endif

    len = length + lp->sm_descr.header + lp->sm_descr.trailer;
#ifdef MEMORY_TRACER
    skb = mu_dev_alloc_skb(len, 4);
#else
    skb = dev_alloc_skb(len);
#endif
    if(!skb)
        goto err_out;

    skb_reserve(skb, (lp->sm_descr.header - data_offset));
    skb_put(skb, length);

#ifdef WDS_SUPPORT
    framep = skb_to_frame(dev, skb, 0);
#else
    framep = skb_to_frame(dev, skb);
#endif
    if(!framep) {
#ifdef MEMORY_TRACER
        mu_dev_kfree_skb(skb, 5);
#else
        dev_kfree_skb(skb);
#endif
        goto err_out;
    }

    return framep;

err_out:
    return NULL;
}

void frame_skb_free(struct net_device *dev, struct s_sm_frame *framep)
{
    DEBUG(DBG_FRAME, "frame_skb_free: frame %p, skb %x\n", framep, framep->handle);

    if(framep->handle) {
        struct sk_buff *skb;

        skb = (struct sk_buff *)framep->handle;
#ifdef MEMORY_TRACER
        mu_dev_kfree_skb(skb, 6);
#else
        dev_kfree_skb(skb);
#endif
    }

    frame_free(dev, framep);
}


/******************************************************************************
 *   Driver API
 ******************************************************************************/
void *prism_driver_alloc( uint32_t *context, uint32_t size, uint8_t type )
{
#ifdef MEMORY_TRACER
    void *buffer = mu_kmalloc(size, GFP_ATOMIC, 7);
#else
    void *buffer = kmalloc(size, GFP_ATOMIC);
#endif

    DEBUG(DBG_CALLS, "prism_driver_alloc %d %d %p\n", size, type, buffer);
    return buffer;
}

void prism_driver_free( uint32_t *context, void *buffer )
{
    DEBUG(DBG_CALLS, "prism_driver_free %p\n", buffer);

#ifdef MEMORY_TRACER
    mu_kfree(buffer, 8);
#else
    kfree(buffer);
#endif
}


/* Frame management */
struct s_sm_frame *prism_driver_frame_alloc( uint32_t *context, uint32_t length )
{
    struct net_device *dev = sm_drv_get_device( context );

    DEBUG(DBG_CALLS, "prism_driver_frame_alloc %d\n", length);

    return frame_skb_alloc(dev, length, 0);
}

void prism_driver_frame_free( uint32_t *context, struct s_sm_frame *frame )
{
    struct net_device *dev = sm_drv_get_device( context );

    DEBUG(DBG_CALLS, "prism_driver_frame_free %p\n", frame);

    frame_skb_free(dev, frame);
}

/* Timers */
void driver_timer_expired(unsigned long handle)
{
    struct net_device *dev = (struct net_device *) handle;
    struct net_local *lp = dev->priv;
    int32_t callb_mask;

    spin_lock_bh(&lp->sm_lock);

    DEBUG(DBG_CALLS, "driver_timer_expired 0x%x\n", prism_driver_time(handle));

    callb_mask = prism_softmac_service(lp->sm_context);

    if(callb_mask < 0) {
        printk(KERN_INFO "timer_expired: sm_service returned error %d\n", callb_mask);
    } else {
        handle_sm_callback(dev, callb_mask);
    }

    spin_unlock_bh(&lp->sm_lock);
}


void prism_driver_timer_start( uint32_t *context, uint32_t usec )
{
    struct net_device *dev = sm_drv_get_device( context );
    struct net_local *lp = dev->priv;
    unsigned long expire;

    DEBUG(DBG_CALLS, "prism_driver_timer_start: expire 0x%x usec\n", usec);

    expire = (usec * HZ)/1000000;

    mod_timer(&lp->softmac_timer, jiffies + expire);
}

void prism_driver_timer_stop( uint32_t *context )
{
    struct net_device *dev = sm_drv_get_device( context );
    struct net_local *lp = dev->priv;

    DEBUG(DBG_CALLS, "prism_driver_timer_stop\n");

    del_timer_sync(&lp->softmac_timer);
}

/* Return current time in usec */
uint32_t prism_driver_time(uint32_t *context )
{
    struct timeval tv;

    do_gettimeofday(&tv);

    DEBUG(DBG_CALLS, "driver_time time 0x%lx us\n", (tv.tv_sec * 1000000) + tv.tv_usec);

    return ((tv.tv_sec * 1000000) + tv.tv_usec);
}


/* Debugging */
void prism_driver_printf( uint32_t *context, uint8_t level, uint8_t *format,
                    uint32_t arg0, uint32_t arg1, uint32_t arg2 )
{
    switch (level)
    {
        case SM_DFATAL:
        case SM_DERROR:
        case SM_DINFO:
                /* Always dbug these */
                DEBUG(driver_debug, format, arg0, arg1, arg2);
        break;
        case SM_DWARNING:
        case SM_DDEBUG:
            DEBUG(DBG_SMAC, format, arg0, arg1, arg2);
        break;
    }
}

void prism_driver_dump( uint32_t *context, uint8_t level, uint8_t *data, uint32_t size )
{
    uint32_t i;

    for( i = 0; i < size; i++ )
        DEBUG(DBG_SMAC, "%02x%c", data[i], !((i+1)&15) ? '\n':' ' );

    if( i & 15 )
        DEBUG(DBG_SMAC, "\n" );
}

void prism_driver_assert(uint8_t *error, uint8_t *file, uint32_t line )
{
    printk(KERN_ALERT "SoftMAC ASSERT: %s, file %s at line %d\n", error, file, line);
#ifdef CONFIG_8827_DEBUG
    DEBUG(DBG_SMAC, "SoftMAC ASSERT: %s, file %s at line %d\n", error, file, line);
    dbg_8827_poll(1);  // One means send frame(s) now....
#endif
    BUG();
}

/******************************************************************************
 *   SoftMAC Callback
 ******************************************************************************/

static int32_t handle_sm_trap( struct net_device *dev, struct s_sm_conf *trap )
{
    struct net_local *lp = dev->priv;
    int32_t result = SM_ENONE;
#ifdef AUTO_ACCESS
    struct obj_mlme *mlme = (struct obj_mlme*)trap->data;
    uint8_t state = DOT11_STATE_ASSOCING;
#endif

    switch( trap->oid )
    {
    case GEN_OID_MACADDRESS:
        DEBUG( DBG_ALL, "%s: MAC address %2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x\n",
            driver_name,
            trap->data[0], trap->data[1], trap->data[2],
            trap->data[3], trap->data[4], trap->data[5] );
        memcpy( dev->dev_addr, trap->data, ETH_ALEN );

        /* If we got the MAC address, this means the device has finished booting */
        wake_up(&lp->conf_waitq);
        sm_drv_psm_fsm(dev, PSMEVENT_IFUP);
        break;

    case GEN_OID_LINKSTATE:
        {
#if(DEBUG_LEVEL > DBG_NONE)
            uint32_t speed = *( (uint32_t*)trap->data );
            DEBUG( DBG_ALL, "%s: LINK SPEED %d.%d Mbps\n",
                driver_name, speed >> 1, ( speed & 1 ) * 5 );
#endif
        }
        break;

#ifdef AUTO_ACCESS
    case DOT11_OID_AUTHENTICATE:
        state = DOT11_STATE_AUTHING;

        /* Intended */

    case DOT11_OID_ASSOCIATE:
    case DOT11_OID_REASSOCIATE:
        if( lp->sm_mode == SM_MODE_AP )
        {
            DEBUG(DBG_TRACE, "Authenticate/(Re)Associate trap: state %d\n", mlme->state );
            if( mlme->state == state )
            {
                /* Always allow the associate */
                trap->flags = SM_CONF_OPSET;

                /* Reset attachment */
                mlme->size = 0;

                /* Confirm indication */
                result = prism_softmac_conf( lp->sm_context, trap );
            }
        }
        break;
#endif

    default:
        /* do nothing */
        break;
    }

#ifdef NETLINK_SUPPORT
    mgt_response( 0, src_seq++, DEV_NETWORK_WLAN, dev->ifindex, PIMFOR_OP_TRAP, trap->oid,
        trap->data, trap->length );
#endif

    return result;
}

/* called under sm_lock */
void handle_sm_callback(struct net_device *dev, int32_t mask)
{
    struct net_local *lp = dev->priv;
    struct s_sm_frame *frame;
    struct sk_buff *skb = NULL;
    int32_t new_mask;
#ifdef WDS_SUPPORT
    struct wds_priv *wdsp = lp->wdsp;
    struct net_device *wds_dev = NULL;
    struct wds_net_local *wnlp = NULL;
#endif
#ifdef VSSDEV_SUPPORT
    struct net_device *vss_dev = NULL;
    struct vss_dev_local *vss_lp = NULL;
    int vssid = 0;
#endif

    while( mask ) {
        DEBUG( DBG_TRACE, "%s: callback mask 0x%x\n", driver_name, mask );

        if( mask & SM_FRAMETXDONE ) {
            new_mask = prism_softmac_frame_tx_done( lp->sm_context, &frame );

            if( new_mask < 0 ) {
                printk(KERN_WARNING "handle_sm_callback: sm_frame_tx_done returned error %d\n", new_mask);
            } else {
                mask = new_mask;
            }

            if( frame != NULL ) {
#ifdef WDS_SUPPORT
                if( frame->flags & SM_FRAME_WDS ) {
                    struct sk_buff *skb = (struct sk_buff *)frame->handle;
                    /* get the corresponding WDS device and local structure */
                    wds_dev = wds_find_device( (unsigned char *) skb->data, wdsp );
                    if( wds_dev == NULL ) {
                        /*
                         * Bug: WDS frame done does not have wds address at the right place
                         *      Let's try one address location earlier in the data packet
                         */
                        wds_dev = wds_find_device( (unsigned char *) skb->data-6, wdsp );
                        DEBUG( DBG_WDS, "handle_sm_callback: WDS device find retry !\n" );
                    }

                    if( wds_dev != NULL ) {
                        wnlp = (struct wds_net_local *)wds_dev->priv;

                        if( frame->flags & SM_FRAME_TXDROPPED ) {
                            wnlp->stats.tx_errors++;
                            wnlp->stats.tx_dropped++;
                        } else if(frame->flags & SM_FRAME_TXFAILED) {
                            wnlp->stats.tx_errors++;
                        } else {
                            wnlp->stats.tx_packets++;
                            wnlp->stats.tx_bytes += frame->length;
                        }
                    }
                    else
                        DEBUG( DBG_WDS, "handle_sm_callback: WDS device NULL, statistics lost !\n" );
                } else
#endif
#ifdef VSSDEV_SUPPORT
                if ( frame->flags & SM_FRAME_VSS )
                {
                    struct s_sm_annex_tx *atx = &frame->annex.tx;

                    /* Extract the VSS Id from the frame */
                    vssid = atx->ssnr;

                    // find the VSS device from the table
                    if( vss_dev = vss_find_device( vssid, lp->vssdev ), vss_dev != NULL ) {

                        vss_lp = (struct vss_dev_local *) vss_dev->priv;

                        if( frame->flags & SM_FRAME_TXDROPPED ) {
                            vss_lp->stats.tx_errors++;
                            vss_lp->stats.tx_dropped++;
                        } else if(frame->flags & SM_FRAME_TXFAILED) {
                            vss_lp->stats.tx_errors++;
                        } else {
                            vss_lp->stats.tx_packets++;
                            vss_lp->stats.tx_bytes += frame->length;
                        }
                    }
                    else
                        DEBUG( DBG_VSS, "handle_sm_callback: VSS device NULL, statistics lost !\n" );
                }
                else
#endif /* #ifdef VSSDEV_SUPPORT */
                {
                    if( frame->flags & SM_FRAME_TXDROPPED ) {
                        lp->stats.tx_errors++;
                        lp->stats.tx_dropped++;
                     } else if(frame->flags & SM_FRAME_TXFAILED) {
                         lp->stats.tx_errors++;
                     } else {
                         lp->stats.tx_packets++;
                         lp->stats.tx_bytes += frame->length;
                     }
                }

                /* Free the frame and SKB frame in done */
                frame_skb_free(dev, frame);

                /* We have transmitted a frame, so we can wake the queue again */
                if( netif_queue_stopped(dev) )
                    netif_wake_queue(dev);
            } else {
                mask &= ~SM_FRAMETXDONE;
            }
        }

        if( mask & SM_FRAMERX ) {
            new_mask = prism_softmac_frame_rx( lp->sm_context, &frame );

            if( new_mask < 0 ) {
                printk(KERN_WARNING "handle_sm_callback: sm_frame_rx returned error %d\n", new_mask);
            } else {
                mask = new_mask;
            }

            if( frame != NULL ) {
#ifdef WDS_SUPPORT
                if( frame->flags & SM_FRAME_WDS ) {
                    // received frame is a WDS frame, get the skb from the frame
                    skb = frame_to_skb( dev, frame );

                    // find the WDS device in the list of WDS links
                    if( wds_dev = wds_find_device( skb->data, wdsp ), wds_dev == NULL ) {
                        printk( KERN_ERR "Received a frame from an unknown WDS links\n" );
#ifdef MEMORY_TRACER
                        mu_dev_kfree_skb(skb, 9);
#else
                        dev_kfree_skb(skb);
#endif
                        skb = NULL;
                    } else {
                        // remove the WDS link address from the buffer and update the statistics
                        memmove( skb->data, skb->data+6, skb->len-6 );
                        skb_trim( skb, skb->len-6 );
                        wnlp = (struct wds_net_local *) wds_dev->priv;

                        wnlp->stats.rx_packets++;
                        wnlp->stats.rx_bytes += skb->len;
                        skb->dev = wds_dev;

                        DEBUG( DBG_WDS, "WDS Frame RX: length %d\n", skb->len );
                        prism_driver_dump( 0, 0, (uint8_t *) skb->data, (uint32_t) skb->len );
                    }
                } else
#endif
#ifdef VSSDEV_SUPPORT
                if ( frame->flags & SM_FRAME_VSS )
                {
                    struct s_sm_annex_rx *arx = &frame->annex.rx;
                    /* Get the VSSID from the frame. */
                    vssid = arx->ssnr;

                    // received frame is a VSS frame, get the skb from the frame
                    skb = frame_to_skb( dev, frame );

                    // find the VSS device from the table
                    if( vss_dev = vss_find_device( vssid, lp->vssdev ), vss_dev == NULL ) {

                        printk( KERN_ERR "Received a frame from an unknown VSS device\n" );
#ifdef MEMORY_TRACER
                        mu_dev_kfree_skb(skb, 10);
#else
                        dev_kfree_skb(skb);
#endif
                        skb = NULL;

                    } else {
                        // remove the VSS device address from the buffer and update the statistics
                        vss_lp = (struct vss_dev_local *) vss_dev->priv;
                        vss_lp->stats.rx_packets++;
                        vss_lp->stats.rx_bytes += skb->len;
                        skb->dev = vss_dev;
                    }
                }
                else
#endif // #ifdef VSSDEV_SUPPORT
                {
                    if( frame->flags & SM_FRAME_RXFAILED ) {
                        lp->stats.rx_errors++;
                    } else {
                        lp->stats.rx_packets++;
                        lp->stats.rx_bytes += frame->length;
                    }

                    // get the skb from the frame
                    skb = frame_to_skb( dev, frame );
                    skb->dev = dev;
                }

                if( skb ) {
                    // set minimal skb parameters and deliver the network packet
                    skb->protocol = eth_type_trans( skb, dev );
                    skb->ip_summed = CHECKSUM_NONE;
#ifdef MEMORY_TRACER
					/* unregister the allocated skb to the tracer */
					mu_unregister_skb( skb, 11 );
#endif
                    netif_rx( skb );
                }

            } else {
                mask &= ~SM_FRAMERX;
            }
        }

        if( mask & SM_TRAP ) {
            struct s_sm_conf t;
            int32_t result;

            t.length = sizeof( long );
#ifdef MEMORY_TRACER
            t.data = mu_kmalloc( t.length, GFP_ATOMIC, 12 );
#else
            t.data = kmalloc( t.length, GFP_ATOMIC );
#endif
            result = prism_softmac_trap( lp->sm_context, &t );

            if( result == SM_EOVERFLOW ) {
#ifdef MEMORY_TRACER
                mu_kfree( t.data, 13 );
                t.data = mu_kmalloc( t.length, GFP_ATOMIC, 14 );
#else
                kfree( t.data );
                t.data = kmalloc( t.length, GFP_ATOMIC );
#endif
                if( t.data != NULL ) {
                    result = prism_softmac_trap( lp->sm_context, &t );
                } else {
                    printk( KERN_ERR "%s: could not allocate trap data\n", driver_name );
                    goto trap_error;
                }
            }

            if( result >= SM_ENONE ) {
                mask |= result;

                if( t.flags & SM_CONF_OPSET) {
                    /* This is a unsolicitated trap */
                    result = handle_sm_trap( dev, &t );
                    if( result >= SM_ENONE )
                        mask |= result;
#ifdef MEMORY_TRACER
        	        mu_kfree( t.data, 15 );
#else
	                kfree( t.data );
#endif
                } else {
                    /* This is a response to a GET operation */
                    memcpy( &lp->getresp, &t, sizeof(struct s_sm_conf) );

                    /* Wake up the app that requested this info.
                     * This will also free t.data. */
                    wake_up( &lp->getresp_waitq );
                }
            } else {
                mask &= ~SM_TRAP;
#ifdef MEMORY_TRACER
                mu_kfree( t.data, 16 );
#else
                kfree( t.data );
#endif
            }

        }

trap_error:
        if( mask & SM_IC ) {
            sm_drv_psm_fsm( dev, PSMEVENT_RUN_BH );
            mask &= ~SM_IC;
        }
    }
}

/******************************************************************************
 *   Kernel API functions
 ******************************************************************************/

/* Create the net device instance that will be associated to the host interface */
struct net_device *sm_drv_netdev_create(struct net_device *netdev, int ioaddr, int irq)
{
    struct net_local *lp;

    DEBUG(DBG_CALLS, "sm_drv_netdev_create\n");

    netdev = init_etherdev(netdev, 0);

    netdev->base_addr          = ioaddr;
    netdev->irq                = irq;

    netdev->open               = &sm_drv_open;
    netdev->stop               = &sm_drv_close;
    netdev->hard_start_xmit    = &sm_drv_transmit;
    netdev->get_stats          = &sm_drv_statistics;
    netdev->do_ioctl           = &sm_drv_ioctl;

#ifdef HAVE_TX_TIMEOUT
    netdev->watchdog_timeo         = SM_DRV_TX_TIMEOUT;
    netdev->tx_timeout             = &sm_drv_tx_timeout;
#endif

    /* add a private device structure to the network device for private
     * definitions needed by the driver */
    netdev->priv = kmalloc(sizeof(struct net_local), GFP_ATOMIC | GFP_DMA);
    if (!netdev->priv) {
        printk("ERROR: Could not allocate private data\n");
        kfree(netdev);
        return NULL;;
    }
    lp = netdev->priv;
    memset(lp, 0, sizeof(struct net_local));

#ifdef VSSDEV_SUPPORT
    lp->vssdev = kmalloc(sizeof(struct vss_priv), GFP_KERNEL);
    if ( lp->vssdev == NULL)
    {
        printk("ERROR: Could not allocate private data for VSS\n");
        kfree(lp);
        kfree(netdev);
        return NULL;
    }
    memset(lp->vssdev, 0, sizeof(struct vss_priv));
#endif

    spin_lock_init(&lp->sm_lock);

    init_waitqueue_head(&lp->conf_waitq);
    init_waitqueue_head(&lp->getresp_waitq);

    /* Init the timer */
    init_timer(&lp->softmac_timer);
    lp->softmac_timer.function = driver_timer_expired;
    lp->softmac_timer.data = (unsigned long)netdev;

    /*
     * Used in Linux bridge to sent packets back on own port.
     * Use only when it's defined in linux/if.h header file.
     */
#ifdef IFF_802_11_WLAN
    netdev->priv_flags |= IFF_802_11_WLAN;
#endif
    return netdev;
}

struct net_device *sm_drv_get_device( uint32_t *context )
{
    struct net_device *dev = root_sm_drv_device;
    struct net_local *lp;

	/* parse all devices for the context handle */
	while( dev )
    {
		/* check the device context handle and return dev if equal */
        lp = dev->priv;
		if( lp->sm_context == context )
			return dev;
		
		/* go to the next driver instance */
		dev = lp->next_module;
    }

	/* Oops, could not find the device holding the context */
	BUG(); 
	
	return NULL;	
}

int sm_drv_open(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
#ifdef WDS_SUPPORT
    struct wds_priv *wdsp = lp->wdsp;
#endif

    DEBUG(DBG_CALLS, "sm_drv_open \n");

    if(!lp->sm_descr.mtu) {
        printk("sm_drv_open: SoftMAC not initialized\n");
        return -ENXIO;
    }

    MOD_INC_USE_COUNT;

#ifdef WDS_SUPPORT
    open_wds_links(wdsp);
#endif

#ifdef VSSDEV_SUPPORT
    open_vss_devices (lp->vssdev);
#endif

    netif_start_queue(dev);

    return 0;
}

int sm_drv_close(struct net_device *dev)
{
#ifdef WDS_SUPPORT
    struct net_local *lp = dev->priv;
    struct wds_priv *wdsp = lp->wdsp;
#endif

    DEBUG(DBG_CALLS, "sm_drv_close \n");

#ifdef WDS_SUPPORT
    close_wds_links(wdsp);
#endif

#ifdef VSSDEV_SUPPORT
    close_vss_devices (lp->vssdev);
#endif

    netif_stop_queue(dev);
    MOD_DEC_USE_COUNT;

    return 0;
}

int sm_drv_transmit(struct sk_buff *skb, struct net_device *dev)
{
    struct s_sm_frame *frame;
    struct net_local *lp = dev->priv;
    int32_t callb_mask;
#ifdef VSSDEV_SUPPORT
    int vss;
    uint8_t vssid;
#endif
#ifdef WDS_SUPPORT
    unsigned char wds_mac[6];
    int wds = 0;

    // get the wds mac address
    memset (wds_mac, 0, 6);
    wds = check_skb_for_wds( skb, &wds_mac[0] );
#endif
#ifdef VSSDEV_SUPPORT
    /* get the vssid. */
    vss = check_skb_for_vss( skb, &vssid );
#endif
#ifdef MEMORY_TRACER
	/* register the already allocated skb to the tracer */
	mu_register_skb( skb, 17 );
#endif

    spin_lock_bh(&lp->sm_lock);

    DEBUG(DBG_CALLS, "sm_drv_transmit\n");

again:
    if(lp->queued_tx_frame) {
        frame = lp->queued_tx_frame;
    } else {
#ifdef WDS_SUPPORT
        frame = skb_to_frame(dev, skb, wds);
#else
        frame = skb_to_frame(dev, skb);
#endif
        if(!frame) {
            printk(KERN_ERR "sm_drv_transmit: Could not allocate frame for skb\n");
#ifdef MEMORY_TRACER
            mu_dev_kfree_skb(skb, 18);
#else
            dev_kfree_skb(skb);
#endif
            lp->stats.tx_errors++;
            goto out;
        }

#ifdef WDS_SUPPORT
        if( wds )
        {
            // add the wds mac address on the first 6 reserved bytes
            memcpy( frame->data, &wds_mac[0], 6 );

            // mark the frame as WDS
            frame->flags |= SM_FRAME_WDS;
        }
#endif
#ifdef VSSDEV_SUPPORT
        if( vss )
        {
            struct s_sm_annex_tx *atx = &frame->annex.tx;

            /* Set the ssnr in the annex. */
            atx->ssnr = vssid;

            /* mark the frame as VSS */
            frame->flags |= SM_FRAME_VSS;
        }
#endif

    }
    callb_mask = prism_softmac_frame_tx( lp->sm_context, frame );
    if(callb_mask < 0) {
        if(callb_mask == SM_EOVERFLOW) {
            DEBUG(DBG_TRACE, "sm_drv_transmit: Overflow, stopping TX queue\n");

            /* We have to accept the packet, otherwise it gets lost. So we
             * temporarily store it and stop the queue. We retry this packet
             * once we have a sm_frame_tx_done
             */
            lp->queued_tx_frame = frame;
            netif_stop_queue(dev);
        } else {
            printk(KERN_WARNING "sm_drv_transmit: sm_frame_tx returned error %d\n", callb_mask);

#ifdef WDS_SUPPORT
            /* check whether the failed frame is a WDS frame */
            if( frame->flags & SM_FRAME_WDS )
            {
                struct wds_priv *wdsp = lp->wdsp;
                struct net_device *wds_dev = NULL;
                struct wds_net_local *wnlp;

                /* search for the corresponding WDS device entry */
                wds_dev = wds_find_device( (unsigned char *) frame->data, wdsp );
                wnlp = (struct wds_net_local *)dev->priv;

                /* increment the WDS device error counter */
                wnlp->stats.tx_errors++;
            }
            else
#endif
#ifdef VSSDEV_SUPPORT
            /* check whether the failed frame is a VSS frame */
            if( frame->flags & SM_FRAME_VSS )
            {
                struct net_device *vss_dev;
                struct s_sm_annex_tx *atx = &frame->annex.tx;
                /* Extract the VSS ID from the frame */
                int vssid = atx->ssnr;

                if( vss_dev = vss_find_device( vssid, lp->vssdev ), vss_dev != NULL )
                {
                    struct vss_dev_local *vss_lp = (struct vss_dev_local *) vss_dev->priv;
                    vss_lp->stats.tx_errors++;
                }
            }
            else
#endif
            {
                /* a normal frame failed, increment the parents device error counter */
                lp->stats.tx_errors++;
            }

            /* Free the frame and the sk_buff */
            frame_skb_free(dev, frame);
            if(lp->queued_tx_frame)
            {
                lp->queued_tx_frame = NULL;
            }
        }
        goto out;
    }

    dev->trans_start = jiffies;
    handle_sm_callback(dev, callb_mask);

    /* If we transmitted a queued frame, now try to transmit the current frame */
    if(lp->queued_tx_frame) {
        lp->queued_tx_frame = NULL;
        goto again;
    }

out:
    spin_unlock_bh(&lp->sm_lock);
    return 0;
}

void sm_drv_tx_timeout(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    struct net_device_stats *statistics = &lp->stats;

    DEBUG(DBG_CALLS, "sm_drv_tx_timeout \n");

    /* increment the transmit error counter */
    statistics->tx_errors++;

    return;
}

struct net_device_stats *sm_drv_statistics(struct net_device *dev)
{
    struct net_local *lp = dev->priv;

    DEBUG(DBG_CALLS, "sm_drv_statistics \n");

    return &lp->stats;
}

int sm_drv_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)
{
    struct net_local *lp = dev->priv;
    int err;
    struct s_softmac_ioctl req;
    struct s_sm_conf smconf;
    int32_t callb_mask;
    uint32_t sm_mode;

    if (!capable (CAP_NET_ADMIN))
        return -EPERM;

    if (dev == NULL)
        return -ENODEV;

    if (cmd != SOFTMACIOCTL)
        return -ENOTTY;

    /* Sleep until UMAC and LMAC are completely initialized */
    if(lp->device_state != DEVSTATE_ACTIVE )
        interruptible_sleep_on(&lp->conf_waitq);

    /* Check if we were woken by a signal */
    if(lp->device_state != DEVSTATE_ACTIVE )
        return -EINTR;

    err = copy_from_user(&req, ifr->ifr_data, sizeof(struct s_softmac_ioctl));
    if (err)
        return -EFAULT;

    switch (req.cmd) {
        case SMIOC_SETMODE:
            if (!access_ok(VERIFY_READ, req.data, req.len))
                return -EFAULT;

            sm_mode = *(uint32_t *)req.data;
            if(sm_mode < SM_MODE_CLIENT || sm_mode > SM_MODE_PROMISCUOUS)
                return -EINVAL;

            DEBUG(DBG_IOCTL, "sm_drv_ioctl: Setting Mode to %d\n", sm_mode);
            err = sm_drv_reset(dev, sm_mode);
            if(err < 0)
                return -EINVAL;

            break;
        case SMIOC_IFRESET:
            DEBUG(DBG_IOCTL, "sm_drv_ioctl: Resetting the interface\n");
            /* Reset the device in the current mode */
            err = sm_drv_reset(dev, lp->sm_mode);

            if(err < 0)
                return -EINVAL;

            break;
        case SMIOC_SETOID:
            DEBUG(DBG_IOCTL, "sm_drv_ioctl: Set OID 0x%x: data %p, len %d\n", req.oid, req.data, req.len);

            if (!access_ok(VERIFY_READ, req.data, req.len))
                return -EFAULT;

            smconf.flags = SM_CONF_OPSET;
            smconf.length = req.len;
            smconf.oid = req.oid;
            smconf.data = req.data;

            spin_lock_bh(&lp->sm_lock);
            callb_mask = prism_softmac_conf( lp->sm_context, &smconf );

            if(callb_mask < 0) {
                printk(KERN_INFO "sm_drv_ioctl (SET): sm_conf returned error %d\n", callb_mask);
                spin_unlock_bh(&lp->sm_lock);

                return -EINVAL;
            }

            handle_sm_callback(dev, callb_mask);
            spin_unlock_bh(&lp->sm_lock);

            break;
        case SMIOC_GETOID:
            DEBUG(DBG_IOCTL, "sm_drv_ioctl: Get OID 0x%x, len %d\n", req.oid, req.len);

            if (!access_ok(VERIFY_WRITE, req.data, req.len))
                return -EFAULT;

            spin_lock_bh(&lp->sm_lock);
            smconf.flags = 0;
            smconf.length = req.len;
            smconf.oid = req.oid;
            smconf.data = req.data;

            callb_mask = prism_softmac_conf( lp->sm_context, &smconf );

            if(callb_mask == SM_EPENDING) {
                int ret = -EINVAL;

                /* Call the softmac so it can handle our request */
                handle_sm_callback(dev, SM_IC);
                spin_unlock_bh(&lp->sm_lock);

                /* Wait for the response.
                 * FIXME: There is a possible race condition here that we get a
                 * response from the LMAC before we go to sleep
                 */
                interruptible_sleep_on(&lp->getresp_waitq);

                /* We got woken with a response to our get request */
                if(!lp->getresp.data) {
                    printk(KERN_ERR "sm_drv_ioctl: Get response data NULL\n");
                    return ret;
                }
                if(lp->getresp.oid != req.oid) {
                    printk(KERN_ERR "sm_drv_ioctl: Get response invalid OID (0x%x, 0x%x)\n",
                            req.oid, lp->getresp.oid);
                    goto geterr_out;
                }
                if(lp->getresp.length > req.len) {
                    printk(KERN_ERR "sm_drv_ioctl: Get overflow (oid 0x%x, %d > %d)\n",
                            req.oid, lp->getresp.length, req.len);
                    goto geterr_out;
                }

                memcpy(req.data, lp->getresp.data, lp->getresp.length);
                ret = 0;

geterr_out:
                kfree(lp->getresp.data);
                lp->getresp.data = NULL;

                return ret;
            } else if(callb_mask < 0) {
                printk(KERN_INFO "sm_drv_ioctl (GET): sm_conf returned error %d\n", callb_mask);
                spin_unlock_bh(&lp->sm_lock);

                return -EINVAL;
            }

            handle_sm_callback(dev, callb_mask);
            spin_unlock_bh(&lp->sm_lock);

            break;
        case SMIOC_SET_DBGLEVEL:
            if (!access_ok(VERIFY_READ, req.data, req.len))
                return -EFAULT;

            driver_debug = *(unsigned int *)req.data;

            DEBUG(DBG_ALL, "sm_drv_ioctl: Setting Debug Level to 0x%x\n", driver_debug);

            break;
#ifdef UMAC_PROFILER
        case SMIOC_UMAC_PROFILER:
            return prof_ioctl(req);
#endif
#ifdef MEMORY_TRACER
        case SMIOC_UMAC_MEMTRACER:
            return mu_ioctl(req);
#endif

        default:
            return -EINVAL;
    }
    return 0;
}


static int sm_drv_reset(struct net_device *dev, uint8_t sm_mode)
{
    struct net_local *lp = dev->priv;
    int ret;

    if(lp->device_state == DEVSTATE_IDLE) {
        printk(KERN_INFO "sm_srv_reset: Cannot reset device in Idle state\n");
        return -1;
    }

    ret = sm_drv_down(dev);

    if(ret == 0)
        ret = sm_drv_up(dev, sm_mode);

    return ret;
}

int sm_drv_up(struct net_device *dev, uint8_t sm_mode)
{
    int ret = 0;
    struct net_local *lp = dev->priv;

    ret = lp->hif_up(dev);

    if(ret < 0)
        return ret;

    lp->sm_mode = sm_mode;

    return 0;
}

int sm_drv_down(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    int ret = 0;

    /* Disable all device interrupts */
    lp->hif_cli(dev);

    /* Run the bottom halve if is is scheduled */
    run_task_queue(&tq_immediate);

    spin_lock_bh(&lp->sm_lock);

    sm_drv_psm_fsm(dev, PSMEVENT_IFDOWN);

    DEBUG(DBG_ALL, "Shut down SoftMAC\n");
    /* shut down SoftMAC */
    if(lp->sm_descr.mtu) {
        lp->sm_descr.mtu = 0;
        prism_softmac_destroy(lp->sm_context);
    }

    ret = lp->hif_down(dev);

    spin_unlock_bh(&lp->sm_lock);

    return ret;
}

void sm_drv_psm_fsm(struct net_device *dev, int event)
{
    struct net_local *lp = dev->priv;

    if( lp->device_state == DEVSTATE_ACTIVE || lp->device_state == DEVSTATE_BOOTING )
    {
        switch(event) {
            case PSMEVENT_RUN_BH:
                /* schedule bottom halve */
                sm_drv_schedule_bh(dev);
                break;
            case PSMEVENT_IFUP:
                /* go back into the idle state */
                lp->device_state = DEVSTATE_ACTIVE;
                break;
            case PSMEVENT_IFDOWN:
                /* go back into the idle state */
                lp->device_state = DEVSTATE_IDLE;
                break;
            default:
                /* Unhandled event */
                break;
         }
    }
    else if( event == PSMEVENT_BOOT )
        lp->device_state = DEVSTATE_BOOTING;
}


/******************************************************************************
 *   Netlink Control Interface
 ******************************************************************************/
#ifdef NETLINK_SUPPORT

int sm_drv_set( struct net_device *dev, long oid, void *data, unsigned int len )
{
    struct net_local  *lp;
    struct s_sm_conf  smconf;
    int32_t callb_mask;
    int err = 0;

    DEBUG( DBG_CTRL, "sm_drv_set(%p, %lx, %p, %d)\n", dev, oid, data, len );

    if (dev==NULL) {
        return 1;
    }
    smconf.flags  = SM_CONF_OPSET;
    smconf.oid    = oid;
    smconf.data   = data;
    smconf.length = len;

    lp = dev->priv;
    spin_lock_bh(&lp->sm_lock);

    callb_mask = prism_softmac_conf( lp->sm_context, &smconf );
    if(callb_mask < 0) {
        DEBUG(DBG_CTRL, "sm_drv_set(%lx):error: %x\n", oid, callb_mask );
        err = -1;
    } else {
        handle_sm_callback(dev, callb_mask);
    }

    spin_unlock_bh(&lp->sm_lock);

    return err;
}

int sm_drv_get( struct net_device *dev, long oid, void *data, unsigned int len )
{
    struct net_local  *lp;
    struct s_sm_conf  smconf;
    int32_t callb_mask;
    int err = 0;

    DEBUG( DBG_CTRL, "sm_drv_get(%p, %lx, %p, %d)\n", dev, oid, data, len );

    if (dev==NULL) {
        return 1;
    }
    smconf.flags  = 0;
    smconf.oid    = oid;
    smconf.data   = data;
    smconf.length = len;

    lp = dev->priv;
    spin_lock_bh(&lp->sm_lock);

    callb_mask = prism_softmac_conf( lp->sm_context, &smconf );
    if(callb_mask < 0) {
        DEBUG(DBG_CTRL, "sm_drv_get(%lx):error: %x\n", oid, callb_mask );
        err = -1;
    } else {
        handle_sm_callback(dev, callb_mask);
    }

    spin_unlock_bh(&lp->sm_lock);

    return err;
}

#ifdef WDS_SUPPORT
int sm_drv_addwds( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    struct net_local *lp = dev->priv;
    struct wds_link_msg *wlmp = (struct wds_link_msg *) data;
    int retval;

    // check the data element by its size
    if ( len != sizeof(struct wds_link_msg))
    {
        printk( KERN_INFO "sm_drv_addwds: Error, length not size of struct wds_link_msg\n" );
        return -1;
    }

    DEBUG(DBG_WDS, "sm_drv_addwds: (%x:%x:%x:%x:%x:%x)\n", wlmp->mac[0], wlmp->mac[1],
        wlmp->mac[2], wlmp->mac[3], wlmp->mac[4], wlmp->mac[5] );

    if ( retval = add_wds_link(dev, lp->wdsp, wlmp->mac, wlmp->name), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: Error %d, add_wds_link failed\n", retval );
        return -1;
    }

    if( retval = sm_drv_set( dev, oid, &wlmp->mac, 6 ), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: Error %d, sm_drv_set failed\n", retval );
        return -1;
    }

    if( retval = sm_drv_set( dev, oid, &wlmp->mac, 6 ), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: Error %d, sm_drv_set failed\n", retval );
        return -1;
    }

    if( retval = sm_drv_set( dev, DOT11_OID_EAPAUTHSTA, &wlmp->mac, 6 ), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_addwds: Error %d, sm_drv_set failed\n", retval );
        return -1;
    }

    return 0;
}

int sm_drv_delwds( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    struct net_local *lp = dev->priv;
    struct wds_link_msg *wlmp = (struct wds_link_msg *) data;
    int retval;

    if ( len != sizeof(struct wds_link_msg))
    {
        printk( KERN_INFO "sm_drv_delwds: Error, length not size of struct wds_link_msg\n" );
        return -1;
    }

    DEBUG(DBG_WDS, "sm_drv_delwds: (%x:%x:%x:%x:%x:%x)\n", wlmp->mac[0], wlmp->mac[1],
        wlmp->mac[2], wlmp->mac[3], wlmp->mac[4], wlmp->mac[5] );

    if ( retval = del_wds_link(dev, lp->wdsp, wlmp->mac, wlmp->name), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_delwds: Error %d, del_wds_link failed\n", retval );
        return -1;
    }

    if( retval = sm_drv_set( dev, DOT11_OID_EAPUNAUTHSTA, &wlmp->mac, 6 ), retval < 0 )
    {
        DEBUG(DBG_WDS, "sm_drv_delwds: Error %d, sm_drv_set failed\n", retval );
        return -1;
    }

    return 0;
}
#endif

#ifdef VSSDEV_SUPPORT
int sm_drv_procvss( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    struct net_local *lp = dev->priv;
    struct obj_serviceset *vssobj = (struct obj_serviceset *) data;
    int retval;
    int vssid;

    // check the data element by its size
    if ( len != sizeof(struct obj_serviceset))
    {
        DEBUG(DBG_VSS, "sm_drv_procvss: Error, length not size of struct obj_serviceset\n");
        return -1;
    }

    /* Only do special things for OPSET. Let GET through unaltered. */
    if ( op != SM_CONF_OPSET )
        return 1;

    vssid = oid - DOT11_OID_SERVICESET0;

    if (vssobj->ssid.length != 0)
    {
        /* Add a VSS device */
        if ( retval = add_vss_device(dev, lp->vssdev, vssid), retval < 0 )

        {
            DEBUG(DBG_VSS, "sm_drv_procvss: Error %d, add_vss_device failed\n", retval );
            return -1;

        }
    }
    else
    {
        /* Remove a VSS device */
        if ( retval = del_vss_device (dev, lp->vssdev, vssid), retval < 0 )
        {
            DEBUG(DBG_VSS, "sm_drv_procvss: Error %d, del_vss_device failed\n", retval );
            return -1;
        }
    }

    if( retval = sm_drv_set( dev, oid, vssobj, sizeof (struct obj_serviceset)), retval < 0 )
    {
        DEBUG(DBG_VSS, "sm_drv_procvss: Error %d, sm_drv_set failed\n", retval );
        return -1;
    }

    return 0;
}
#endif

int sm_drv_skip( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    return 0;
}

#define SREAD                           0x01
#define SWRITE                          0x02

struct s_mgt_obj
{
    long oid;
    int (*fp)( struct net_device *dev, int op, long oid, void *data, unsigned int len );
    int  length;
    int  flags;
} sm_drv_mgt_objs[] =
{
#ifdef WDS_SUPPORT
    {DOT11_OID_WDSLINKADD,      sm_drv_addwds,  0,      SWRITE },
    {DOT11_OID_WDSLINKREMOVE,   sm_drv_delwds,  0,      SWRITE },
#endif
#ifdef VSSDEV_SUPPORT
    {DOT11_OID_SERVICESET0,        sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 1,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 2,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 3,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 4,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 5,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 6,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 7,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 8,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 9,    sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 10,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 11,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 12,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 13,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 14,   sm_drv_procvss, 0, SWRITE|SREAD},
    {DOT11_OID_SERVICESET0 + 15,   sm_drv_procvss, 0, SWRITE|SREAD},
#endif
};


#define SM_DRV_MGT_OBJS_SIZE     (sizeof(sm_drv_mgt_objs) / sizeof (struct s_mgt_obj))

int sm_drv_lookup_oid( struct net_device *dev, int op, long oid, void *data, unsigned int len )
{
    int i;
    struct s_mgt_obj *obj;
    int flags = ( op != 0 ) ? SWRITE : SREAD;

    for( i=0, obj=sm_drv_mgt_objs; i<SM_DRV_MGT_OBJS_SIZE; i++, obj++ ) {
        /* Find matching oid in table */
        if( obj->oid == oid ) {
            if ( obj->flags & flags ) {
                if ( obj->fp )
                    /* Found an function for this entry in the table. The
                     * function should do a better job in communicating with
                     * the softmac so call this function.
                     */
                    return ( obj->fp( dev, op, oid, data, len ) );
                else
                    /* Although there is an entry in the table there is no
                     * function defined for the entry so assume that we still
                     * want the regular treatment.
                     */
                    return 1;
            } else {
               /* Found an entry for this oid. If the requested operation (flags)
                * is not define in the table report an error.
                */
               return -1;
            }
        }
    }

    return 1; /* default:  apply regular treatment */
}

int sm_drv_mgt_indication( unsigned int dev_type, unsigned int dev_seq,
                          unsigned int src_id, unsigned int src_seq,
                          unsigned int op, unsigned int oid, void *data, unsigned long len)
{
    struct net_device *dev;
    struct net_local  *lp;
    struct s_sm_conf smconf;
    int32_t callb_mask;
    int ret = 0;

    DEBUG( DBG_NETLINK, "sm_drv_mgt_indication: dev_seq %d op %d len %ld oid %x\n", dev_seq, op, len, oid );

    op = ( op == PIMFOR_OP_SET) ? SM_CONF_OPSET : 0;

    if ( ! (dev = dev_get_by_index(dev_seq)) ) {
        return -1;
    }

    lp = dev->priv;

    ret = sm_drv_lookup_oid( dev, op, oid, data, len );
    if ( ret > 0 )
    {
        DEBUG( DBG_NETLINK, "sm_drv_mgt_indication:passed( %s, %d, %ld, %x )\n", dev->name, op, len, oid );

        smconf.flags  = op;
        smconf.oid    = oid;
        smconf.data   = data;
        smconf.length = len;

        spin_lock_bh(&lp->sm_lock);

        callb_mask = prism_softmac_conf( lp->sm_context, &smconf );

        if(callb_mask < 0) {
            DEBUG(DBG_NETLINK, "sm_drv_mgt_indication( %x ):error: %d\n", oid, callb_mask );

            spin_unlock_bh(&lp->sm_lock);

            ret = mgt_response( src_id, src_seq, dev_type, dev_seq, PIMFOR_OP_ERROR, oid, data, len);
        } else {
            handle_sm_callback(dev, callb_mask);

            spin_unlock_bh(&lp->sm_lock);

            ret = mgt_response( src_id, src_seq, dev_type, dev_seq, PIMFOR_OP_RESPONSE, oid, data, len);
        }
    } else if ( ret == 0 ) {

        DEBUG(DBG_NETLINK, "sm_drv_indication:filtered( %s, %d, %ld, %x )\n", dev->name, op, len, oid );
        ret = mgt_response( src_id, src_seq, dev_type, dev_seq, PIMFOR_OP_RESPONSE, oid, data, len);

    }else {

        DEBUG(DBG_NETLINK, "sm_drv_mgt_indication:ignored( %s, %d, %ld, %x )\n", dev->name, op, len, oid );
        ret = mgt_response( src_id, src_seq, dev_type, dev_seq, PIMFOR_OP_ERROR, oid, data, len);
    }

    dev_put( dev );

    return ret;
}
#endif
