/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM® wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, whether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 */


#ifndef _SM_DRV_H
#define _SM_DRV_H

/*
 * INCLUDES
 */
#include <linux/skbuff.h>
#include <linux/netdevice.h>
#include <linux/delay.h>
#include <asm/io.h>
#ifndef CONF_SHMEM
#include "softmac2.h"
#else
#include "sm_drv_shmem.h"
#endif

#include "smoid2.h"

#ifdef WDS_SUPPORT
#include "sm_drv_wds.h"
#endif


/*
 * FUNCTION PROTOTYPES
 */
#ifdef WDS_SUPPORT
struct s_sm_frame *skb_to_frame(struct net_device *dev, struct sk_buff *skb, int wds);
#else
struct s_sm_frame *skb_to_frame(struct net_device *dev, struct sk_buff *skb);
#endif
struct sk_buff *frame_to_skb(struct net_device *dev, struct s_sm_frame *framep);

int sm_drv_open(struct net_device *dev);
int sm_drv_close(struct net_device *dev);
int sm_drv_transmit(struct sk_buff *skb, struct net_device *dev);
void sm_drv_tx_timeout(struct net_device *dev);
struct net_device_stats *sm_drv_statistics(struct net_device *dev);
int sm_drv_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd);
int sm_drv_up(struct net_device *dev, uint8_t mode);
int sm_drv_down(struct net_device *dev);
struct net_device *sm_drv_netdev_create(struct net_device *netdev, int ioaddr, int irq);
struct net_device *sm_drv_get_device( uint32_t *context );
struct s_sm_frame *frame_skb_alloc(struct net_device *dev, uint32_t length,
                                          uint16_t data_offset);
void frame_skb_free(struct net_device *dev, struct s_sm_frame *framep);
void sm_drv_psm_fsm(struct net_device *dev, int event);
void handle_sm_callback(struct net_device *dev, int32_t callb_mask);
void driver_timer_expired(unsigned long sm_handle);

#ifdef NETLINK_SUPPORT
int sm_drv_mgt_indication( unsigned int dev_type, unsigned int dev_seq,
                           unsigned int src_id, unsigned int src_seq,
                           unsigned int op, unsigned int oid, void *data, unsigned long len);
#endif

extern struct net_device *root_sm_drv_device;


/*
 * MACROS
 */
#define ALIGN(value)    ((value + (sizeof(long) - 1)) & ~(sizeof(long) - 1))
#define FRAME_ICMSG(framep) ((struct s_ic_msg *)((char *)(framep) + ALIGN(sizeof(struct s_sm_frame))))

/*
 * DEFINES
 */

/* Configuration Items */
#define DEV_MAX_STA                             128
#define DEV_MAX_BSS                             16

/* Device State (lower halfword) and device actions (upper half word) */
#define DEVSTATE_IDLE                   0
#define DEVSTATE_BOOTING                1
#define DEVSTATE_ACTIVE                 2

/* Power save mode events */
#define PSMEVENT_RUN_BH                 1
#define PSMEVENT_UPDATE                 2
#define PSMEVENT_IFDOWN                 3
#define PSMEVENT_IFUP                   4
#define PSMEVENT_HOST_SLEEP             5
#define PSMEVENT_HOST_WAKEUP            6
#define PSMEVENT_BOOT                   7

/* ioctl interface */
#define SOFTMACIOCTL                    SIOCDEVPRIVATE

#define SMIOC_IFRESET                   1
#define SMIOC_CARDRESET                 2
#define SMIOC_GETOID                    3
#define SMIOC_SETOID                    4
#define SMIOC_SET_DBGLEVEL              5
#define SMIOC_SETMODE                   6
#define SMIOC_UMAC_PROFILER             7
#define SMIOC_UMAC_MEMTRACER            8

struct s_softmac_ioctl {
    uint32_t cmd;
    uint32_t oid;
    uint32_t len;
    uint8_t *data;
};

/* TX timeout */
#define SM_DRV_TX_TIMEOUT               (2*HZ)

/* Debug flag to get debug information for specific sections */
#define DBG_NONE    0x00000000
#define DBG_CALLS   0x00000001
#define DBG_TRACE   0x00000002
#define DBG_IRQ     0x00000004
#define DBG_BH      0x00000008
#define DBG_SMAC    0x00000010
#define DBG_FRAME   0x00000020
#define DBG_PWRSAVE 0x00000040
#define DBG_IOCTL   0x00000080
#define DBG_UARTPCI 0x00000100
#define DBG_NETLINK 0x00000200
#define DBG_IC      0x00000400
#define DBG_LMAC    0x00000800
#define DBG_CTRL    0x00001000
#define DBG_WDS     0x00002000
#define DBG_OFFLOAD 0x00004000
#define DBG_VSS     0x00008000

/* Use DBG_OFF to initially disable debugging but make it possible to enable it runtime.
 * use DBG_NONE to compile out all debugging for release builds
 */
#define DBG_OFF     0xF0000000
#define DBG_ALL     0xFFFFFFFF


/*
 * DEBUG STUFF. The Makefile should specify if debug should be on or off.
 * This is done using -DDEBUG_ON in this case the DEBUG_LEVEL will be set to DBG_OFF
 * which means that by default no debug will be shown, but this can be configured on
 * the fly using sm_conf or sm_dbg tool.
 * When a final built is made and no debug should be used (every insturction saved helps)
 * so when DEBUG_ON in undefined DEBUG_LEVEL will be undefined either.
 */
#ifdef DEBUG_ON
#define DEBUG_LEVEL ( DBG_SMAC )
#else
#define DEBUG_LEVEL (DBG_NONE)
#undef DEBUG_TIMESTAMP
#endif

extern unsigned int driver_debug;

#ifdef DEBUG_TIMESTAMP
#define K_DEBUG( f, m, args... )                            \
do{ if(( f & m )) {                                         \
        struct timeval tv;                                  \
        do_gettimeofday(&tv);                               \
        printk("[%.2d:%.6d] ", (int)tv.tv_sec, (int)tv.tv_usec); \
        printk( args );                                     \
    }                                                       \
}while(0)
#else /* DEBUG_TIMESTAMP */
#ifdef CONFIG_8827_DEBUG
#define K_DEBUG( f, m, args... )    do{ if(( f & m )) dbg_print_8827( args ); }while(0)
#else
#define K_DEBUG( f, m, args... )    do{ if(( f & m )) printk( args ); }while(0)
#endif
#endif /* DEBUG_TIMESTAMP */

#if DEBUG_LEVEL > DBG_NONE
#define DEBUG( f, args... )     K_DEBUG( f, driver_debug, args )
#else
#define DEBUG( f, args... )
#endif



struct net_local {
    void                *device_id;             /* unique ID for shared IRQ */
    void                *hif_local_data;        /* Pointer to the host interface specific data */

    spinlock_t          sm_lock;                /* SoftMAC lock */

    uint32_t            device_state;           /* Powersave/Active */

    struct tq_struct    tqueue;                 /* Our bottom halve (BH) handler */

    /*
     * Above the most frequently used variables are place we try to keep this
     * in one cache line
     */

    uint8_t             sm_mode;                /* SoftMAC mode: Client or AP */
    struct net_device   *next_module;
    struct s_sm_frame   *queued_tx_frame;       /* We can queue 1 TX frame if the SoftMAC queue is full */

    struct timer_list   softmac_timer;          /* Timer for SoftMAC */
        struct s_sm_initdata *sm_initdata;                      /* temporary init structure storage */
    struct s_sm_descr   sm_descr;               /* SoftMAC description */
        uint32_t                        *sm_context;                    /* handle to SoftMAC context */

    struct net_device_stats stats;              /* statistics */

    wait_queue_head_t   conf_waitq;             /* To wait for configuration to be allowed */
    wait_queue_head_t   getresp_waitq;          /* wait queue and buffer for response ...*/
    struct s_sm_conf    getresp;                /* ...to pending get request */

#ifdef WDS_SUPPORT
    int                 wds_link_count;         /* number of WDS links in table */
    struct wds_priv     *wdsp;                  /* WDS device links table */
#endif

#ifdef VSSDEV_SUPPORT
    struct vss_priv     *vssdev;                /* VSS device table */
#endif

    int                 (*hif_up) (struct net_device *dev);
    int                 (*hif_down) (struct net_device *dev);
    void                (*hif_cli) (struct net_device *dev);
};

#endif /* _SM_DRV_H */
