/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, whether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/pci.h>
#include <linux/string.h>
#include <linux/poll.h>
#include <asm/uaccess.h>

#include "sm_drv_memuse.h"
#include "sm_drv.h"

/*
 * Uncomment this define to check the queue intergrity when adding
 * or deleting queue entries
 */
//#define CHECK_QUEUE_INTEGRITY	


#define MAX_MEMUSE_ENTRIES			300
#define MEMUSE_ALLOC_TRIGGER		300	
#define MEMUSE_FREE_TRIGGER 		MAX_MEMUSE_ENTRIES - MEMUSE_ALLOC_TRIGGER


#define MEMUSE_TRACE_OFF			0
#define MEMUSE_TRACE_ALL			1
#define MEMUSE_TRACE_FREE			2
#define MEMUSE_TRACE_DONE			3

#define ENTRY_TYPE_SKB				0
#define ENTRY_TYPE_MALLOC			1

/* ioctl interface command */
#define UM_CMD_START_TRACE			1
#define UM_CMD_STOP_TRACE			2
#define UM_CMD_DUMP_ENTRY			3


struct s_memuse_info
{
	int number;
	struct s_memuse_info *next;
	struct timeval time_alloc;
	struct timeval time_freed;
	void *address;
	unsigned int size;
	int type;
	int open_tag;
	int close_tag;
};


struct s_memuse_info *mu_trace_buffer = NULL;
struct s_memuse_info *mu_address_alloc_head = NULL;
struct s_memuse_info *mu_address_alloc_tail = NULL;
struct s_memuse_info *mu_address_freed_head = NULL;
struct s_memuse_info *mu_address_freed_tail = NULL;
struct s_memuse_info *mu_address_dump_entry = NULL;
int mu_trace_state = MEMUSE_TRACE_OFF;
int mu_alloc_count;
int mu_freed_count;
int mu_max_in_use;
unsigned long irq_flags;
spinlock_t mu_irq_lock;
spinlock_t mu_lock;

/*
 * Memory Tracer init functions
 */
void mu_init( void )
{
	struct s_memuse_info *ptr, *ptr2;
	int counter;
	
	/*
	 * allocate a static buffer to store all traces 
	 */
	mu_trace_buffer = kmalloc( MAX_MEMUSE_ENTRIES * 
		sizeof(struct s_memuse_info), GFP_ATOMIC );
	
	if( mu_trace_buffer == NULL )
	{
		printk( KERN_ERR "Error: Memory Tracer could not allocate memory" );
		return;
	}

	spin_lock_init( &mu_irq_lock );
	spin_lock_init( &mu_lock );
		
	/* 
	 * reset buffer pointers, linked list & counters
	 */
	ptr=mu_trace_buffer;
	ptr2=mu_trace_buffer+1;
	for( counter=0; counter < MAX_MEMUSE_ENTRIES; counter++, ptr++, ptr2++ )
	{
		if( counter == MAX_MEMUSE_ENTRIES-1 )
			ptr->next = NULL;
		else
			ptr->next = ptr2;
		ptr->number = counter;
		ptr->address = NULL;
		ptr->open_tag = 0;
		ptr->close_tag = 0;
	}		

	mu_address_freed_head = mu_trace_buffer;
	mu_address_freed_tail = ptr-1;
	mu_alloc_count = 0;
	mu_freed_count = MAX_MEMUSE_ENTRIES;
	mu_max_in_use = 0;

	printk( KERN_INFO "Memory Tracer initialized, ready to go!" );
}

void mu_cleanup( void )
{
	if( mu_trace_buffer )
		kfree( mu_trace_buffer );
}

#ifdef CHECK_QUEUE_INTEGRITY
int mu_check_queue_integrity( void )
{
	struct s_memuse_info *ptr;
	int counter;

	ptr = mu_address_alloc_head;
	for( counter=0; counter < mu_alloc_count; counter++ )
	{
		if( ptr->next == NULL )
		{
			/* this might be the last entry which must be NULL */
			if( counter != mu_alloc_count-1 )
			{
				printk( KERN_ERR "mu_integrity: ERROR in alloc queue\n" );
				mu_trace_state = MEMUSE_TRACE_DONE;
				return -1;
			}
		}		
		else
			ptr=ptr->next;
	}
	if( ptr != mu_address_alloc_tail )
	{
		printk( KERN_ERR "mu_integrity: ERROR in alloc tail ptr %p tail %p\n",
			ptr, mu_address_alloc_tail );
		mu_trace_state = MEMUSE_TRACE_DONE;
		return -1;
	}

	ptr = mu_address_freed_head;
	for( counter=0; counter < mu_freed_count; counter++ )
	{
		if( ptr->next == NULL )
		{
			/* this might be the last entry which must be NULL */
			if( counter != mu_freed_count-1 )
			{
				printk( KERN_ERR "mu_integrity: ERROR in freed queue\n" );
				mu_trace_state = MEMUSE_TRACE_DONE;
				return -1;
			}
		}		
		else
			ptr=ptr->next;
	}
	if( ptr != mu_address_freed_tail )
	{
		printk( KERN_ERR "mu_integrity: ERROR in freed tail ptr %p tail %p\n",
			ptr, mu_address_freed_tail );
		mu_trace_state = MEMUSE_TRACE_DONE;
		return -1;
	}

	return 0;
}
#endif

void mu_alloc_entry( void *address, int size, int type, int tag )
{
	struct s_memuse_info *ptr;
	struct timeval time_current;
	int counter;
	
	/* lock the code allowing only one process at a time */
	spin_lock_irqsave( &mu_irq_lock, irq_flags );
	spin_lock( &mu_lock );
		
#ifdef CHECK_QUEUE_INTEGRITY
	/* check the integrity of both queues */
	if( mu_check_queue_integrity() )
	{
		spin_unlock( &mu_lock );
		spin_unlock_irqrestore( &mu_irq_lock, irq_flags );
		return;
	}
#endif

	/*
	 * Get a free trace entry from the freed queue
	 */
	if( mu_freed_count > MEMUSE_FREE_TRIGGER )
	{
		/* save the first free entry for storing new info */
		ptr = mu_address_freed_head;
			
		/* shift the freed pointer to the next free entry */
		mu_address_freed_head = mu_address_freed_head->next;
		mu_freed_count--;
		if( !mu_freed_count )
		{
			/* Freed queue is empty, reset its pointers */
			mu_address_freed_head = NULL;
			mu_address_freed_tail = NULL;
		}

		/* store the trace information */
		ptr->address = address;
		ptr->size = size;
		ptr->type = type;
		ptr->open_tag = tag;
	    do_gettimeofday(&ptr->time_alloc);
				
		/* add the trace entry to the opened queue tail */
		if( !mu_address_alloc_head )
		{
			/* opened queue still empty, add the first entry */
			mu_address_alloc_head = ptr;
			mu_address_alloc_tail = ptr;
		}
		else
		{
			mu_address_alloc_tail->next = ptr;
			mu_address_alloc_tail = mu_address_alloc_tail->next;
		}
		mu_address_alloc_tail->next = NULL;
		mu_alloc_count++;
		
		/*
		 * Check the in use count with the current alloc count
		 */
		if( mu_alloc_count > mu_max_in_use )
		{
			/* update the max in use counter register and print */
			mu_max_in_use = mu_alloc_count;
			printk( KERN_INFO "mu_alloc_entry: Max allocated increesed to %04d\n",
				mu_alloc_count );
		}		
	}
	else
	{
		/* triggered, allow only freeing traces which are not hanging */
		mu_trace_state = MEMUSE_TRACE_FREE;
		
		/* notify the results */
		printk( KERN_INFO "Trace Completed, Trigger has been set !\n" );

		/* get the current time to calculate the delta of all unreleased areas */
	    do_gettimeofday(&time_current);

		/* process the list of unreleased areas */
		ptr = mu_address_alloc_head;
		for( counter=0; counter < MEMUSE_ALLOC_TRIGGER; counter++, ptr=ptr->next )
		{
			/* save the time of completion in the allocated areas */
			ptr->time_freed = time_current;
		}

		/* memory tracer will continue allowing entries to be freed which are
		   not eaten by the driver or UMAC */
	}

	/* unlock the code allowing only one process at a time */
	spin_unlock( &mu_lock );
	spin_unlock_irqrestore( &mu_irq_lock, irq_flags );
}

void mu_free_entry( void *address, int tag )
{
	struct s_memuse_info *ptr, *prev;
	int counter;
	
	/* lock the code allowing only one process at a time */
	spin_lock_irqsave( &mu_irq_lock, irq_flags );
	spin_lock( &mu_lock );

#ifdef CHECK_QUEUE_INTEGRITY
	/* check the integrity of both queues */
	if( mu_check_queue_integrity() )
	{
		spin_unlock( &mu_lock );
		spin_unlock_irqrestore( &mu_irq_lock, irq_flags );
		return;
	}
#endif

	/*
	 *	Search for the corresponding entry in the opened queue
	 */
	ptr = mu_address_alloc_head;
	prev = NULL;
	for( counter=0; counter < mu_alloc_count; counter++ )
	{
		if( ptr->address == address )
		{
			/* found the entry, grab it from the queue */
			if( !prev )
			{
				/* entry is the head of the alloc queue */
				mu_address_alloc_head = mu_address_alloc_head->next;
			}
			else
			{
				/* entry is somewhere in the middle or the end */
				prev->next = ptr->next;
				
				/* check whether the alloc tail pointer needs update */
				if( !ptr->next )
					mu_address_alloc_tail = prev;
			}
			mu_alloc_count--;
			if( !mu_alloc_count )
			{
				/* alloc queue is empty, reset its pointers */
				mu_address_alloc_head = NULL;
				mu_address_alloc_tail = NULL;
			}
		
			/* store the trace information */
			ptr->close_tag = tag;
		    do_gettimeofday(&ptr->time_freed);
		
			/* move the trace entry to the free queue */
			if( !mu_address_freed_head )
			{
				/* free queue empty, add as first entry */
				mu_address_freed_head = ptr;
				mu_address_freed_tail = ptr;
			}
			else
			{
				mu_address_freed_tail->next = ptr;
				mu_address_freed_tail = mu_address_freed_tail->next;
			}
			mu_address_freed_tail->next = NULL;
			mu_freed_count++;

			if( mu_trace_state == MEMUSE_TRACE_FREE )
			{
				/* 
				 * freed an entry after the tracing is triggered
				 * log the removal of an allocated entry 
				 */
				printk( KERN_INFO "mu_free_entry: Freed after complete, alloc_count %d\n",
					mu_alloc_count );	   
			}
			
			/* unlock the code allowing only one process at a time */
			spin_unlock( &mu_lock );
			spin_unlock_irqrestore( &mu_irq_lock, irq_flags );

			return;
		}
		else
		{
			/* no match, update the entry pointers */
			prev = ptr;
			ptr = ptr->next;
		}
	}	
	
	/* found no matching address, do nothing */ 

	/* unlock the code allowing only one process at a time */
	spin_unlock( &mu_lock );
	spin_unlock_irqrestore( &mu_irq_lock, irq_flags );
}


void mu_dump_alloc_entry(void)
{
	unsigned char *rdptr, linebuffer[200];
	struct sk_buff *skb;
    unsigned int duration;
	int i, j;

	/* check whether dump pointer is already initialized */
	if( mu_address_dump_entry == NULL )
	{
		/* first entry dump request */
		mu_address_dump_entry = mu_address_alloc_head;
	}

	/* 
	 * dump the next entry in the system log 
	 */

	/* display the general information */	
	printk( KERN_INFO "%04d: type %d, address %p, size %04d, tag %02d\n", 
		mu_address_dump_entry->number, mu_address_dump_entry->type, 
		mu_address_dump_entry->address, mu_address_dump_entry->size, 
		mu_address_dump_entry->open_tag );

	/* calculate the time delta between allocation and trace completion */
    duration = (mu_address_dump_entry->time_freed.tv_sec - 
				mu_address_dump_entry->time_alloc.tv_sec) * 1000000 +
               (mu_address_dump_entry->time_freed.tv_usec - 
			    mu_address_dump_entry->time_alloc.tv_usec);
			
	printk( KERN_INFO "----: duration %08u allocated %06u:%06u\n", duration, 
		(unsigned int) mu_address_dump_entry->time_alloc.tv_sec, 
		(unsigned int) mu_address_dump_entry->time_alloc.tv_usec );

	/* dump the first 128 bytes of memory or skb data*/
	if( mu_address_dump_entry->type == ENTRY_TYPE_SKB )
	{
		skb = (struct sk_buff *) mu_address_dump_entry->address;
		rdptr = (unsigned char *) skb->data;
	}
	else
		rdptr = (unsigned char *) mu_address_dump_entry->address;
			
    for( i=0, j=0; (i < mu_address_dump_entry->size) && (i < 128); i++, j++, rdptr++ )
	{
		sprintf( &linebuffer[j*3], "%02x  ", *rdptr ); 

	    if( j == 15 )
		{
	  		printk( KERN_INFO "%s\n", linebuffer );
			j = 0;
		}	
	}
	
	/* display also the last line if it contains data */
	if( j )
	{
		linebuffer[(j+1)*3]='\0';
  		printk( KERN_INFO "%s\n", linebuffer );
	}

	/* increment the dump pointer */
	if( !mu_address_dump_entry->next )
	{
		/* at the end of the queue, restart */
		mu_address_dump_entry = mu_address_alloc_head;
	}
	else
	{
		mu_address_dump_entry = mu_address_dump_entry->next;
	}
}


int mu_ioctl(struct s_softmac_ioctl req)
{
    int mu_cmd;

    if (!access_ok(VERIFY_READ, req.data, req.len))
        return -EFAULT;

    mu_cmd = *(unsigned int *)req.data;

    switch(mu_cmd) {
		case UM_CMD_START_TRACE:
			/* enable tracing */
			mu_trace_state = MEMUSE_TRACE_ALL;
			break;
		case UM_CMD_STOP_TRACE:
			/* stop tracing except the freeing of allocated entries
			   which are not lost due to a leak */
			mu_trace_state = MEMUSE_TRACE_FREE;
			break;
        case UM_CMD_DUMP_ENTRY:
			/* dump one entry in the queue of allocated entries to 
			   system log facilities */
			mu_dump_alloc_entry();
            break;
        default:
            printk("Invalid Memory Tracer command %d\n", mu_cmd);
            return -EINVAL;
    }
    return 0;
}


/*
 * Memory Tracer (Un)Register functions for registering memory areas
 * which are already allocated outside the driver, but passed on as
 * a pointer. The unregister function is for memory areas which might
 * have been allocated by the driver (or registered) and are passed 
 * on to other processed using its memory address pointer.
 */
void mu_register_skb( struct sk_buff *skb, int tag )
{
	if( mu_trace_state == MEMUSE_TRACE_ALL )
		mu_alloc_entry( (void *) skb, (int) skb->len, ENTRY_TYPE_SKB, tag );
}

void mu_unregister_skb( struct sk_buff *skb, int tag )
{
	if( (mu_trace_state == MEMUSE_TRACE_ALL) ||
		(mu_trace_state == MEMUSE_TRACE_FREE))
		mu_free_entry( (void *) skb, tag );
}


/*
 * Memory Tracer Alloc/Free functions for tracing the
 * standard Linux allocation and free system calls.
 */
void * mu_kmalloc(size_t size, int flags, int tag )
{
	void *area=NULL;
	
	area = kmalloc( size, flags );

	if( mu_trace_state == MEMUSE_TRACE_ALL )
		mu_alloc_entry( area, (int) size, ENTRY_TYPE_MALLOC, tag );

	return area;
}

void mu_kfree(const void *objp, int tag )
{
	if( (mu_trace_state == MEMUSE_TRACE_ALL) ||
		(mu_trace_state == MEMUSE_TRACE_FREE))
		mu_free_entry( (void *) objp, tag );

	kfree( objp );
}

struct sk_buff *mu_dev_alloc_skb( unsigned int length, int tag )
{
	struct sk_buff *skb = NULL;
	
	skb = dev_alloc_skb( length );
	
	if( mu_trace_state == MEMUSE_TRACE_ALL )
		mu_alloc_entry( (void *) skb, length, ENTRY_TYPE_SKB, tag );

	return skb;
}

void mu_dev_kfree_skb( struct sk_buff *skb, int tag )
{
	if( (mu_trace_state == MEMUSE_TRACE_ALL) ||
		(mu_trace_state == MEMUSE_TRACE_FREE))
		mu_free_entry( (void *) skb, tag );

	dev_kfree_skb( skb );
}




