/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, whether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#include <linux/module.h>
#include <linux/skbuff.h>
#include <linux/rtnetlink.h>
#include <linux/isil_netlink.h>
#include <net/sock.h>

#include "sm_drv_netlink.h"

#define IND_TABLE_SZ    30
#define RESP_TABLE_SZ   30

#ifndef NULL
#   define  NULL ((void *)0)
#endif

//#define DRIVER_DEBUG 1

unsigned int src_seq = 0;

static struct ind_rec {
    unsigned int   dev_type;
    char           name[IFNAMSIZ];
    unsigned int   dev_seq;
    unsigned int   oid;
    mgt_indication_t ind;
} ind_table[IND_TABLE_SZ];

static struct resp_rec {
    unsigned int   src_id;
    char           name[IFNAMSIZ];
    unsigned int   src_seq;
    unsigned int   oid;
    mgt_response_t resp;
} resp_table[RESP_TABLE_SZ];

static mgt_confirm_t cnf_hndl = NULL;

static int mgt_initialised = 0;
static struct sock *nl_sock = NULL; /* netlink socket */

static int ntl_confirm( unsigned int src_id, unsigned int src_seq,
                        unsigned int dev_type, unsigned int dev_seq,
                        unsigned int op, unsigned int oid, void *data, unsigned long len);
static int ntl_transmit(pid_t pid, int seq, int operation,
                        int oid, long *data, unsigned long data_len,
                        int dev_type, int dev_id );
static void ntl_receive(struct sock *sk, int len);

static int pimfor_encode_header(int operation, unsigned long oid, int device_id,
                                int flags, int length, struct pimfor_hdr *header);
static int pimfor_decode_header(struct pimfor_hdr *header, int *version,
                                int *operation, unsigned long *oid,
                                int *device_id, int *flags, unsigned long *length);


/********************************************************************
*                      Management interfaces
*********************************************************************/

int mgt_ind_table_init = 0;

int mgt_request( unsigned int dev_type, unsigned int dev_seq,
                 unsigned int src_id,   unsigned int src_seq,
                 unsigned int op, int oid, void *data, unsigned long len)
{
    int i;
    int err = -EPFNOSUPPORT;
    struct net_device *dev;
    struct ind_rec *pi;
    mgt_indication_t ind_oid = NULL;
    mgt_indication_t ind_def = NULL;

#ifdef DRIVER_DEBUG
    char *data_buffer = data;

    printk (KERN_ERR "mgt_request(%d, %d, %d, %d, %d, %x, <data>, %d)\n",
            dev_type, dev_seq, src_id, src_seq, op, oid, (unsigned int)len );
    for(i = 0 ; i < len ; i++ )
    {
        printk("%2.2x ",data_buffer[i]);
    }
    printk("\n");
#endif

    if ( mgt_ind_table_init != -1 ) {

        if ( ! (dev = dev_get_by_index( dev_seq ) ) )
            return -1;

        for ( i = 0, pi = ind_table; ( pi->ind != NULL ) && ( i < IND_TABLE_SZ ); i++, pi++ ) {
           if ( ( pi->dev_seq == 0 ) && ( strncmp ( pi->name, dev->name, IFNAMSIZ ) == 0 ) ) {
               mgt_ind_table_init++;
               pi->dev_seq = dev_seq;
           }
        }

        if ( i == mgt_ind_table_init ) {
            mgt_ind_table_init = -1;
        }

        dev_put( dev );
    }

    for ( i = 0, pi = ind_table; i < IND_TABLE_SZ; i++, pi++ ) {
        if ( ( pi->dev_type == dev_type ) && ( pi->dev_seq == dev_seq ) && ( pi->ind != NULL ) ) {
            if ( pi->oid == oid ) {
                ind_oid = pi->ind;
                break;
            } else if ( pi->oid == 0 ) {
                ind_def = pi->ind;
            }
        }
    }

    /* only one request allowed (confirm); specific handlers have priority over default handler */
    if ( ind_oid ) {
        err = (*ind_oid)( dev_type, dev_seq, src_id, src_seq, op, oid, data, len );
    } else if ( ind_def ) {
        err = (*ind_def)( dev_type, dev_seq, src_id, src_seq, op, oid, data, len );
    }

    return err;
}

int mgt_resp_table_init = 0;

int mgt_response( unsigned int src_id, unsigned int src_seq,
                  unsigned int dev_type, unsigned int dev_seq,
                  unsigned int op, int oid, void *data, unsigned long len)
{
    int i;
    int err = 0;
    struct net_device *dev;
    struct resp_rec *pr;
    mgt_response_t resp_oid = NULL;
    mgt_response_t resp_def = NULL;

#ifdef DRIVER_DEBUG
    char *data_buffer = data;

    printk (KERN_ERR "mgt_response(%d, %d, %d, %d, %d, %x, <data>, %d)\n",
            src_id, src_seq, dev_type, dev_seq, op, oid, (unsigned int)len );
    for(i = 0 ; i < len ; i++ )
    {
        printk("%2.2x ",data_buffer[i]);
    }
    printk("\n");
#endif

    if ( mgt_resp_table_init != -1 ) {

        if ( ! (dev = dev_get_by_index( dev_seq ) ) )
            return -1;

        for ( i = 0, pr = resp_table; ( pr->resp != NULL ) && ( i < RESP_TABLE_SZ ); i++, pr++ ) {
           if ( ( pr->src_seq == 0 ) && ( strncmp ( pr->name, dev->name, IFNAMSIZ ) == 0 ) ) {
               mgt_resp_table_init++;
               pr->src_seq = dev_seq;
           }
        }

        if ( i == mgt_resp_table_init ) {
            mgt_resp_table_init = -1;
        }

        dev_put( dev );
    }

    for ( i = 0, pr = resp_table; i < RESP_TABLE_SZ; i++, pr++ ) {
        if ( ( pr->src_id == src_id ) && ( pr->src_seq == src_seq ) && ( pr->resp != NULL ) ) {
            if ( pr->oid == oid ) {
                resp_oid = pr->resp;
                break;
            } else if ( pr->oid == 0 ) {
                resp_def = pr->resp;
            }
        }
    }

    /* only one response allowed (indication); specific handlers have priority over default handler */
    if ( resp_oid ) {
        if ( (*resp_oid)( src_id, src_seq, dev_type, dev_seq, op, oid, data, len ) < 0)
            err = -EPFNOSUPPORT;
    } else if ( cnf_hndl ) {
        if ( ( *cnf_hndl )( src_id, src_seq, dev_type, dev_seq, op, oid, data, len ) < 0 )
            err = -EPFNOSUPPORT;
    }

    return err;
}

int mgt_confirm( unsigned int src_id, unsigned int src_seq,
                  unsigned int dev_type, unsigned int dev_seq,
                  unsigned int op, int oid, void *data, unsigned long len)
{
    return ntl_confirm( src_id, src_seq, dev_type, dev_seq, op, oid, data, len);
}

int mgt_indication_handler( unsigned int dev_type, char *dev_name,
                            unsigned int oid, mgt_indication_t ind )
{
    int i;
    struct ind_rec *pi;

    if ( ind ) {
        for ( i = 0, pi = ind_table; i < IND_TABLE_SZ; i++, pi++ ) {
           if ( pi->ind == 0 ) {
              pi->dev_type = dev_type;
              strncpy( pi->name, dev_name, IFNAMSIZ );
              pi->dev_seq  = 0;
              pi->oid      = oid;
              pi->ind      = ind;
              return 0;
           }
        }
    }

    return -1;
}

int mgt_response_handler( unsigned int src_id, char *dev_name,
                            unsigned int oid, mgt_response_t resp )
{
    int i;
    struct resp_rec *pr;

    if ( resp ) {
        for ( i = 0, pr = resp_table; i < RESP_TABLE_SZ; i++, pr++ ) {
           if ( pr->resp == 0 ) {
              pr->src_id   = src_id;
              strncpy( pr->name, dev_name, IFNAMSIZ );
              pr->src_seq  = 0;
              pr->oid      = oid;
              pr->resp     = resp;
              return 0;
           }
        }
    }

    return -1;
}

int mgt_confirm_handler( mgt_confirm_t cnf )
{
    if ( cnf ) {
        cnf_hndl = cnf;
        return 0;
    }

    return -EPFNOSUPPORT;
}

void mgt_ind_table_dump_hndl ( unsigned int dev_id,   unsigned int dev_seq,
                              unsigned int src_id,   unsigned int src_seq,
                              unsigned int op,       unsigned int oid, void *data, unsigned long len )
{
    int i;
    struct ind_rec *pi;

    printk (KERN_ERR "mgt_ind_table_dump_hndl(%d, %d, %d, %d, %d, %x, <data>, %d)\n",
            dev_id, dev_seq, src_id, src_seq, op, oid, (unsigned int)len );

    for ( i = 0, pi = ind_table; ( pi->ind != NULL ) && ( i < IND_TABLE_SZ ); i++, pi++ ) {
        printk ( KERN_ERR "%d - %s - %d - %x - %p\n",
                 pi->dev_type, pi->name, pi->dev_seq, pi->oid, pi->ind );
    }
}


int mgt_initialize( void )
{
    int i;
    struct ind_rec  *ip;
    struct resp_rec *pr;

#ifdef DRIVER_DEBUG
    printk ("mgt_initialize(%d)\n", mgt_initialised );
#endif

    if( mgt_initialised )
        return 0;

    mgt_initialised = 1;

    for ( i = 0, ip = ind_table; i < IND_TABLE_SZ; i++, ip++ ) {
        ip->dev_type = 0;
        ip->dev_seq  = 0;
        ip->oid      = 0;
        ip->ind      = NULL;
    }

    for ( i = 0, pr = resp_table; i < RESP_TABLE_SZ; i++, pr++ ) {
        pr->src_id   = 0;
        pr->src_seq  = 0;
        pr->oid      = 0;
        pr->resp     = NULL;
    }

    cnf_hndl = NULL;

    /* Open the netlink socket */
    if (nl_sock == NULL) {
        if ( (nl_sock = netlink_kernel_create(NETLINK_ISIL, ntl_receive)) == NULL )
            printk("netlink_kernel_create failed\n");
    }

    mgt_confirm_handler( ntl_confirm );

    return 0;
}

int mgt_cleanup( void )
{
    if ( nl_sock ) {
                sock_release( nl_sock->socket );
    }

    return 0;
}


/*********************************************************************
*                        Netlink interface
*********************************************************************/

static int ntl_confirm( unsigned int src_id, unsigned int src_seq,
                        unsigned int dev_type, unsigned int dev_seq,
                        unsigned int op, unsigned int oid, void *data, unsigned long len)
{
    return ntl_transmit(src_id, src_seq, op, oid, (long*)data, len, dev_type, dev_seq );
}

static int ntl_transmit(pid_t pid, int seq, int operation, int oid, long *data, unsigned long data_len,
                        int dev_type, int dev_id )
{
    unsigned char *old_tail;
    struct sk_buff *skb;
    struct nlmsghdr *nlh;
    struct pimfor_hdr *pimfor_hdr;
    size_t size;

    int err = 0;
    /* Trap group is mapped to dev_type. */
    unsigned int trapgrp = dev_type;

#ifdef DRIVER_DEBUG
    printk(KERN_INFO "ntl_transmit: pid %d, seq %d, oper %d, oid %d, data ptr %p, data_len %lu, dev_id %d \n",
                       pid, seq, operation, oid, data, data_len, dev_id);
#endif

    if ( nl_sock == NULL ) {
        printk(KERN_ERR "ntl_transmit: no nl_sock\n");
        return -EPFNOSUPPORT;
    }

    size = NLMSG_LENGTH(data_len + sizeof(struct pimfor_hdr));
    skb = alloc_skb(size, GFP_ATOMIC);

    if ( skb ) {

        old_tail = skb->tail;
        nlh = NLMSG_PUT(skb, pid, seq, NETLINK_TYPE_PIMFOR, size - NLMSG_ALIGN(sizeof(struct nlmsghdr)));
        pimfor_hdr = (struct pimfor_hdr *)NLMSG_DATA(nlh);

        pimfor_encode_header(operation, oid, dev_id, 0 /*flags*/, data_len, pimfor_hdr);
        /* Add data after the PIMFOR header */
        memcpy(PIMFOR_DATA(pimfor_hdr), data, data_len);

        nlh->nlmsg_len = skb->tail - old_tail;
        NETLINK_CB(skb).dst_groups = 0;
    } else {

        printk(KERN_ERR "ntl_transmit: alloc_skb failed\n");
        return -EPFNOSUPPORT;
    }

    if (pid != 0 ) {
        err = netlink_unicast(nl_sock, skb, pid, MSG_DONTWAIT);
    } else {
        if (trapgrp) {
            netlink_broadcast(nl_sock, skb, pid, trapgrp ,GFP_ATOMIC );
        }
        else {
            printk(KERN_WARNING "No trap group defined, drop packet.\n");
            kfree_skb(skb);
        }
    }

    return err;

nlmsg_failure:
    if ( skb )
            kfree_skb(skb);
    printk(KERN_ERR "ntl_transmit: NLMSG_PUT failed\n");
    return -EPFNOSUPPORT;
}

static void ntl_receive(struct sock *sk, int len)
{
    int err;
    struct sk_buff *skb;
    pid_t pid;
    struct nlmsghdr *nl_header;
    __u32 seq;
    struct pimfor_hdr *header;
    char *data;
    int version;
    int operation;
    unsigned long oid;
    int dev_id;
    int flags;
    unsigned long length;

#ifdef DRIVER_DEBUG
    printk(KERN_INFO "ntl_receive: sock %p, len %d \n", sk, len);
#endif

    do
    {
        if (rtnl_shlock_nowait())
                return;

        while ( (skb = skb_dequeue(&sk->receive_queue)) != NULL )
        {
            pid = NETLINK_CB(skb).pid;
            nl_header = (struct nlmsghdr*) skb->data;
            seq = nl_header->nlmsg_seq;
            header = (struct pimfor_hdr*)(skb->data+(sizeof(struct nlmsghdr)));
            data = PIMFOR_DATA(header);

            if ( nl_header->nlmsg_type == NETLINK_TYPE_PIMFOR )
            {
                pimfor_decode_header(header, &version, &operation, &oid, &dev_id, &flags, &length);

                if (version == PIMFOR_VERSION_1) {

                    err = mgt_request( DEV_NETWORK, dev_id, pid, seq, operation, oid, data, length );

                    if ( err < 0 ) {
                        printk(KERN_INFO "ntl_receive: mgt_request(%d, %d, %d, %x, %d, %lx, %ld) returned %d\n",
                               DEV_NETWORK, dev_id, pid, seq, operation, oid, length, err );
                        netlink_ack(skb, nl_header, -EOPNOTSUPP );
                    }

                } else {
                    printk(KERN_ERR "ntl_receive: version (%d) != PIMFOR_VERSION_1\n", version );
                    netlink_ack(skb, nl_header, -EOPNOTSUPP );
                }
            } else {
                printk(KERN_ERR "nl_header->nlmsg_type (%d) != NETLINK_TYPE_PIMFOR\n", nl_header->nlmsg_type );
                netlink_ack(skb, nl_header, -EOPNOTSUPP );
            }

            kfree_skb(skb);
        }
        up(&rtnl_sem);

    } while (nl_sock && nl_sock->receive_queue.qlen);
}


/*********************************************************************
*                        PIMFOR
*********************************************************************/

/*
 * PIMFOR (Proprietary Conexant Mechanism For Object Relay). PIMFOR is a simple
 * request-response protocol used to query and set items of management information
 * residing in the MVC. It is used to provide an object interface to device firmware.
 *
 * PIMFOR is also used for communication between applications and the driver.
 * For the uAP, PIMFOR is used for communication between the driver and the MVC.
 *
 */


/**********************************************************************
 *  pimfor_encode_header
 *
 *  DESCRIPTION: XXX
 *
 *  PARAMETERS:  XXX
 *
 *  RETURN:      XXX
 *
 **********************************************************************/
static int pimfor_encode_header(int operation, unsigned long oid, int device_id,
                                int flags, int length, struct pimfor_hdr *header)
{
    //printk(KERN_INFO "pimfor_encode_header: oper %d, oid %d, dev_id %d, flags %d, length %d header ptr %p \n",
    //                  operation, oid, device_id, flags, length, header);

    if( !header )
            return -EPFNOSUPPORT;

    memset(header, 0, sizeof(struct pimfor_hdr));

    /* byte oriented members */
    header->version = PIMFOR_VERSION_1;
    header->operation = operation;
    header->device_id = device_id;
    header->flags = flags;

    /* word oriented members with byte order depending on the flags */
    if (flags & PIMFOR_FLAG_LITTLE_ENDIAN) {
            header->oid = cpu_to_le32(oid);
            header->length = cpu_to_le32(length);
    } else {
            header->oid = cpu_to_be32(oid);
            header->length = cpu_to_be32(length);
    }
    return 0;
}

/**********************************************************************
 *  pimfor_decode_header
 *
 *  DESCRIPTION: XXX
 *
 *  PARAMETERS:  XXX
 *
 *  RETURN:      XXX
 *
 **********************************************************************/
static int pimfor_decode_header(struct pimfor_hdr *header, int *version,
                                int *operation, unsigned long *oid,
                                int *device_id, int *flags, unsigned long *length)
{
    //printk(KERN_INFO "pimfor_decode_header: header ptr %p, version %d, oper %d, oid %d, device_id %d, flags %d, length %d \n",
    //                      header, version, operation, oid, device_id, flags, length);

    if(!header)
            return -EPFNOSUPPORT;

    /* byte oriented members */
    *version   = header->version;
    *operation = header->operation;
    *device_id = header->device_id;
    *flags = header->flags;

    /* word oriented members with byte order depending on the flags */
    if (*flags & PIMFOR_FLAG_LITTLE_ENDIAN) {
            *oid = le32_to_cpu(header->oid);
            *length = le32_to_cpu(header->length);
    } else {
            *oid = be32_to_cpu(header->oid);
            *length = be32_to_cpu(header->length);
    }

    return 0;
}


EXPORT_SYMBOL(mgt_initialize);
EXPORT_SYMBOL(mgt_response);
EXPORT_SYMBOL(mgt_indication_handler);
