/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, w;hether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *;
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#define __KERNEL_SYSCALLS__

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/pci.h>
#include <linux/string.h>
#include <linux/poll.h>
#include <asm/uaccess.h>

#include "sm_drv.h"
#include "softmac.h"
#include "IxCryptoAcc.h"

#define CONF_ALIGN 4
#define ALIGN_VALUE(val) ( ( (val) + CONF_ALIGN - 1 ) & ~(CONF_ALIGN - 1) )

#ifdef CODELET
#include "IxQMgr.h"
#include "IxNpeDl.h"
#include "IxOsServices.h"
#include "IxOsCacheMMU.h"
#include "ix_ossl.h"
#endif

#define WEPRC4_ENCR_IDX 	0x1
#define WEPRC4_DECR_IDX 	0x2
#define CCMP_ENCR_IDX 		0x4
#define CCMP_DECR_IDX 		0x8
#define ACC_INIT 		0x10
#define WEP_XSCALE_ENGINE 	0x20


/******************************************************************************
 *   Global variables
 ******************************************************************************/

/* En/Decryption context indexes created for each supported operation */
static uint32_t weprc4_decr_idx = 0;
static uint32_t weprc4_encr_idx = 0;
static uint32_t ccmp_encr_idx = 0;
static uint32_t ccmp_decr_idx = 0;

/* driver offload state */
static uint8_t offload_state = 0;

/* Data passed by umac */
static cb_driver_offload umac_cb = NULL;
static struct s_driver_offload *data = NULL;
static uint32_t driver_handle = 0;
static IX_MBUF inbuf;
static IX_MBUF outbuf;


/******************************************************************************
 *   Static Functions
 ******************************************************************************/



/******************************************************************************
 *   Function definitions
 ******************************************************************************/

uint32_t init_crypto_acc()
{
    /* This function is called by the driver offload functionality
     * to initialise the Crypto Access functionality. It needs to
     * be called once to setup the configuration.
     */
    uint32_t retval;

    /* To initialise the crypto access functionality we first need to
     * specify the required configuration followed by a call to the
     * crypto access initialisation function.
     */
    /* TODO: Still need to check how to select another configuration
     * For now enable only the WEP Xscale engine
     */

    retval = ixCryptoAccConfig( IX_CRYPTO_ACC_CFG_WEP_XSCALE_ACC_EN );
    if ( retval != IX_CRYPTO_ACC_STATUS_SUCCESS ) {
        DEBUG( DBG_OFFLOAD, "init_crypto_acc():config failed = %d\n", retval);
        return( retval );
    }
    retval = ixCryptoAccInit();
    if ( retval != IX_CRYPTO_ACC_STATUS_SUCCESS ) {
        DEBUG( DBG_OFFLOAD, "init_crypto_acc():init failed= %d\n", retval);
    }
    else
    {
        DEBUG( DBG_OFFLOAD, "init_crypto_acc():init successfull\n");
    }
    offload_state |= WEP_XSCALE_ENGINE;
    return( retval );
}



void weprc4_encr_regcb( UINT32 cryptoCtxId, IX_MBUF *pMbuf, IxCryptoAccStatus status)
{
    /* This function is called by the Crypto Access functionality to indicate
     * that the registration of the WEP RC4 encryption context ID was successfull.
     * The crypto context id will be used for all future WEP RC4 encryption
     * requests and thus must be saved.
     */
    extern uint32_t weprc4_encr_idx;
    extern struct s_driver_offload *data;

    if ( status != IX_CRYPTO_ACC_STATUS_SUCCESS ) {
        /* Registration was not successfull. Set the data->flags field and return.
         * This flags field will be handled by the driver_offload function.
         */
        DEBUG( DBG_OFFLOAD, "weprc4_encr_regcb():registration failed(%d)\n", status);
        data->flags = DRIVER_OFFLOAD_FLAG_FAIL;
        return;
    }
    DEBUG( DBG_OFFLOAD, "weprc4_encr_regcb():registration success, id = %08x\n",
           cryptoCtxId);
    /* Save the crypto context ID and mark that we have a crypto context id */
    weprc4_encr_idx = cryptoCtxId;
    offload_state |= WEPRC4_ENCR_IDX;
    return;
}

void weprc4_decr_regcb( UINT32 cryptoCtxId, IX_MBUF *pMbuf, IxCryptoAccStatus status)
{
    /* This function is called by the Crypto Access functionality to indicate
     * that the registration of the WEP RC4 decryption context ID was successfull.
     * The crypto context id will be used for all future WEP RC4 decryption
     * requests and thus must be saved.
     */
    extern uint32_t weprc4_decr_idx;
    extern struct s_driver_offload *data;

    if ( status != IX_CRYPTO_ACC_STATUS_SUCCESS ) {
        /* Registration was not successfull. Set the data->flags field and return.
         * This dat->flags field will be handled by the driver_offload function.
         */
        DEBUG( DBG_OFFLOAD, "weprc4_decr_regcb():registration failed(%d)\n", status);
        data->flags = DRIVER_OFFLOAD_FLAG_FAIL;
        return;
    }
    DEBUG( DBG_OFFLOAD, "weprc4_decr_regcb():registration success, id = %08x\n",
           cryptoCtxId);
    /* Save the crypto context ID and mark that we have a crypto context id */
    weprc4_decr_idx = cryptoCtxId;
    offload_state |= WEPRC4_DECR_IDX;
    return;
}

void ccmp_encr_regcb( UINT32 cryptoCtxId, IX_MBUF *pMbuf, IxCryptoAccStatus status)
{
    /* This function is called by the Crypto Access functionality to indicate
     * that the registration of the CCMP encryption context ID was successfull.
     * The crypto context id will be used for all future CCMP encryption
     * requests with the same key and thus must be saved.
     */
    extern uint32_t ccmp_encr_idx;
    extern struct s_driver_offload *data;

    if ( status != IX_CRYPTO_ACC_STATUS_SUCCESS ) {
        /* Registration was not successfull. Set the data->flags field and return.
         * This dat->flags field will be handled by the driver_offload function.
         */
        DEBUG( DBG_OFFLOAD, "ccmp_encr_regcb():registration failed(%d)\n", status);
        data->flags = DRIVER_OFFLOAD_FLAG_FAIL;
        return;
    }
    DEBUG( DBG_OFFLOAD, "ccmp_encr_regcb():registration success, id = %08x\n",
           cryptoCtxId);
    /* Save the crypto context ID and mark that we have a crypto context id */
    ccmp_encr_idx = cryptoCtxId;
    offload_state |= CCMP_ENCR_IDX;
    return;
}

void ccmp_decr_regcb( UINT32 cryptoCtxId, IX_MBUF *pMbuf, IxCryptoAccStatus status)
{
    /* This function is called by the Crypto Access functionality to indicate
     * that the registration of the CCMP decryption context ID was successfull.
     * The crypto context id will be used for all future CCMP decryption
     * requests with the same key and thus must be saved.
     */
    extern uint32_t ccmp_decr_idx;
    extern struct s_driver_offload *data;

    if ( status != IX_CRYPTO_ACC_STATUS_SUCCESS ) {
        /* Registration was not successfull. Set the data->flags field and return.
         * This dat->flags field will be handled by the driver_offload function.
         */
        DEBUG( DBG_OFFLOAD, "ccmp_decr_regcb():registration failed(%d)\n", status);
        data->flags = DRIVER_OFFLOAD_FLAG_FAIL;
        return;
    }
    DEBUG( DBG_OFFLOAD, "ccmp_decr_regcb():registration success, id = %08x\n",
           cryptoCtxId);
    /* Save the crypto context ID and mark that we have a crypto context id */
    ccmp_decr_idx = cryptoCtxId;
    offload_state |= CCMP_DECR_IDX;
    return;
}

void crypto_cmpcb( UINT32 cryptoCtxId, IX_MBUF *pSrcMbuf, IX_MBUF *pDestMbuf, IxCryptoAccStatus status)
{
    /* This function is called by the Crypto Access functionality upon
     * completion of an asynchronous encryption or decryption request
     * that was initiated by the driver offload function.
     * The result of the request must be mapped to the flags field
     * of the s_driver_offload. A sanity check is done of the pDestMBuf
     * against the outBuf of the s_driver_offload.
     */
    extern cb_driver_offload umac_cb;
    extern uint32_t driver_handle;
    extern struct s_driver_offload *data;
    /* Encryption completed. Set the flags according the received status. */
    switch( status )
    {
    case IX_CRYPTO_ACC_STATUS_SUCCESS:
        /* encryption or decryption was successfull and if the operation
         * was decryption the ICV check passed.
         */
        DEBUG( DBG_OFFLOAD,
               "crypto_cmpcb():en/decrypt + authentication success\n");
        data->flags = 0;
        break;

    case IX_CRYPTO_ACC_STATUS_AUTH_FAIL:
        /* The authentication phase failed. Set flags accordingly */
        DEBUG( DBG_OFFLOAD, "crypto_cmpcb():en/decrypt success\n");
        data->flags = DRIVER_OFFLOAD_FLAG_MISMATCH + DRIVER_OFFLOAD_FLAG_FAIL;
        break;

    case IX_CRYPTO_ACC_STATUS_FAIL:
    default:
        /* Other failure */
        DEBUG( DBG_OFFLOAD, "crypto_cmpcb():en/decrypt failure\n");
        data->flags = DRIVER_OFFLOAD_FLAG_FAIL;
        break;
    } /* end of switch( retval ) */
    umac_cb( driver_handle, data );
    return;
}


uint32_t create_wep_encr_ctxid()
{
    /* Create a new WEP RC4 encryption context id for the Crypto Access
     * functionality. A WEP RC4 encryption context is needed before the
     * encryption function can be called.
     */
    uint32_t retval = 0;
    IxCryptoAccCtx accCtx; /* Access context */

    accCtx.operation = IX_CRYPTO_ACC_OP_ENCRYPT_AUTH;
    accCtx.cipherCtx.cipherAlgo = IX_CRYPTO_ACC_CIPHER_ARC4;
    accCtx.cipherCtx.cipherMode = IX_CRYPTO_ACC_MODE_NULL;
    accCtx.cipherCtx.cipherKeyLen = IX_CRYPTO_ACC_ARC4_KEY_128;
    accCtx.cipherCtx.cipherBlockLen = IX_CRYPTO_ACC_ARC4_BLOCK_8;
    accCtx.cipherCtx.cipherInitialVectorLen = 0;
    accCtx.authCtx.authAlgo = IX_CRYPTO_ACC_AUTH_WEP_CRC;
    accCtx.authCtx.authDigestLen = IX_CRYPTO_ACC_WEP_CRC_DIGEST_32;
    accCtx.authCtx.authKeyLen = 0;
    accCtx.authCtx.aadLen = 0;
    /* TODO: For some WEP configurations we probably want to use
     * separate source and destination buffers.
     */
    accCtx.useDifferentSrcAndDestMbufs = 0;

    /* The weprc4_encr_regcb function is called upon succesfull registration
     * The crypto_cmpcb function is called for an asynchronous completion
     * of the encryption/decryption request.
     */
    retval = ixCryptoAccCtxRegister( &accCtx, NULL, NULL, weprc4_encr_regcb,
                                     crypto_cmpcb, &weprc4_encr_idx);
    DEBUG( DBG_OFFLOAD, "create_wep_encr_ctxid(): completed with value %d\n",
           retval );
    return retval;
}

uint32_t create_wep_decr_ctxid()
{
    /* Create a new WEP RC4 decryption context id for the Crypto Access
     * functionality. A WEP RC4 decryption context is needed before the
     * encryption function can be called.
     */
    uint32_t retval = 0;
    IxCryptoAccCtx accCtx; /* Access context */

    accCtx.operation = IX_CRYPTO_ACC_OP_AUTH_DECRYPT;
    accCtx.cipherCtx.cipherAlgo = IX_CRYPTO_ACC_CIPHER_ARC4;
    accCtx.cipherCtx.cipherMode = IX_CRYPTO_ACC_MODE_NULL;
    accCtx.cipherCtx.cipherKeyLen = IX_CRYPTO_ACC_ARC4_KEY_128;
    accCtx.cipherCtx.cipherBlockLen = IX_CRYPTO_ACC_ARC4_BLOCK_8;
    accCtx.cipherCtx.cipherInitialVectorLen = 0;
    accCtx.authCtx.authAlgo = IX_CRYPTO_ACC_AUTH_WEP_CRC;
    accCtx.authCtx.authDigestLen = IX_CRYPTO_ACC_WEP_CRC_DIGEST_32;
    accCtx.authCtx.authKeyLen = 0;
    accCtx.authCtx.aadLen = 0;
    /* TODO: For some WEP configurations we probably want to use
     * separate source and destination buffers.
     */
    accCtx.useDifferentSrcAndDestMbufs = 0;

    /* The weprc4_decr_regcb function is called upon succesfull registration
     * The crypto_cmpcb function is called for an asynchronous completion
     * of the encryption/decryption request.
     */
    retval = ixCryptoAccCtxRegister( &accCtx, NULL, NULL, weprc4_decr_regcb,
                                     crypto_cmpcb, &weprc4_decr_idx);
    DEBUG( DBG_OFFLOAD, "create_wep_decr_ctxid(): completed with value %d\n",
           retval );
    return( retval );
}


uint32_t create_ccmp_encr_ctxid( struct s_driver_offload * data ) {
    IxCryptoAccCtx accCtx;
    uint32_t retval = 0;
    struct s_driver_offload_ccmp *ccmp_offload;

    ccmp_offload = ( struct s_driver_offload_ccmp *)
                   ( (uint32_t *)data + (sizeof(struct s_driver_offload)/4) );
    /* Create a CCPM encryption context */
    accCtx.operation = IX_CRYPTO_ACC_OP_ENCRYPT_AUTH;
    accCtx.cipherCtx.cipherAlgo = IX_CRYPTO_ACC_CIPHER_AES;
    accCtx.cipherCtx.cipherMode = IX_CRYPTO_ACC_MODE_CCM;
    accCtx.cipherCtx.cipherKeyLen = IX_CRYPTO_ACC_AES_KEY_128;
    memcpy( accCtx.cipherCtx.key.aesKey128, ccmp_offload->key, 16);
    /* For WEP the cipherCtx.key is not defined. */
    accCtx.cipherCtx.cipherBlockLen =   IX_CRYPTO_ACC_AES_BLOCK_128;
    accCtx.cipherCtx.cipherInitialVectorLen = IX_CRYPTO_ACC_AES_CCM_IV_512;
    accCtx.authCtx.authAlgo = IX_CRYPTO_ACC_AUTH_CBC_MAC;
    accCtx.authCtx.authDigestLen = IX_CRYPTO_ACC_CCM_DIGEST_64;
    accCtx.authCtx.authKeyLen = 0;
    accCtx.authCtx.aadLen = 48;
    /* For CCMP the authkey is not set */
    /* Seperate source and destination buffers are provided by the
     * umac to avoid unnecessary data copying in the driver.
     */
    accCtx.useDifferentSrcAndDestMbufs = 0;

    /* Create the context in the Crypto Access functionality */
    retval = ixCryptoAccCtxRegister( &accCtx, NULL, NULL, ccmp_encr_regcb,
                                     crypto_cmpcb, &ccmp_encr_idx);
    printk("create_ccmp_encr_ctxid(): create_ccmp_encr_ctxid: completed with return value %d\n", retval);
    return( retval );

} /* end of create_ccmp_encr_ctxid */

uint32_t create_ccmp_decr_ctxid(  struct s_driver_offload * data ) {
    IxCryptoAccCtx accCtx;
    struct s_driver_offload_ccmp *ccmp_offload;

    ccmp_offload = ( struct s_driver_offload_ccmp *)
                ( (uint32_t *)data + (sizeof(struct s_driver_offload)/4) );

    /* Create a CCMP decryption context identity */

    accCtx.operation = IX_CRYPTO_ACC_OP_AUTH_DECRYPT ;
    accCtx.cipherCtx.cipherAlgo = IX_CRYPTO_ACC_CIPHER_AES;
    accCtx.cipherCtx.cipherMode = IX_CRYPTO_ACC_MODE_CCM;
    accCtx.cipherCtx.cipherKeyLen = IX_CRYPTO_ACC_AES_KEY_128;
    memcpy( accCtx.cipherCtx.key.aesKey128, ccmp_offload->key, 16);
    /* For WEP the cipherCtx.key is not defined. */
    accCtx.cipherCtx.cipherBlockLen =   IX_CRYPTO_ACC_AES_BLOCK_128;
    accCtx.cipherCtx.cipherInitialVectorLen = IX_CRYPTO_ACC_AES_CCM_IV_512;
    accCtx.authCtx.authAlgo = IX_CRYPTO_ACC_AUTH_CBC_MAC;
    accCtx.authCtx.authDigestLen = IX_CRYPTO_ACC_CCM_DIGEST_64;
    accCtx.authCtx.authKeyLen = 0;
    accCtx.authCtx.aadLen = 48;
    /* For CCMP the authkey is not set */
    /* Seperate source and destination buffers are provided by the
     * umac to avoid unnecessary data copying in the driver.
     */
    accCtx.useDifferentSrcAndDestMbufs = 1;

    /* Create the context in the Crypto Access functionality */
    return( ixCryptoAccCtxRegister( &accCtx, NULL, NULL, ccmp_decr_regcb,
                                    crypto_cmpcb, &ccmp_decr_idx) );
} /* end of create_ccmp_decr_ctxid */

uint32_t wep_crypt()
{
    extern struct s_driver_offload *data;
    extern uint32_t weprc4_decr_idx;
    extern uint32_t weprc4_encr_idx;
    struct s_driver_offload_wep *wep_offload;
    extern IX_MBUF inbuf;
    uint32_t crypt_idx;
    uint8_t pkey[16];
    uint32_t retval;

    if ( data->operation == DRIVER_OFFLOAD_OPERATION_WEP_RC4_ENCRYPT )
    {
        crypt_idx = weprc4_encr_idx;
    }
    else
    {
        crypt_idx = weprc4_decr_idx;
    }
    wep_offload = (struct s_driver_offload_wep *)ALIGN_VALUE(
                          (uint32_t)data+sizeof( struct s_driver_offload ) );
    /* Copy the IV in the first three bytes of the crypto access key */
    memcpy(&pkey[0], wep_offload->iv, 3);
    if ( wep_offload->key_length == 13 )
    {
        /* For a 104 bit WEP key the key can be copied into the
         * remaining bytes of the crypto access key.
         */
        memcpy(&pkey[3], wep_offload->key, 13);
    }
    else
    {
        /* For a 40 bit WEP key the key can be appended to the IV to create
         * the first 64 bit of the crypto access key. Repeat the IV and the
         * 40 bit key to create the last 64 bit of the crypto access key.
         */
        memcpy(&pkey[3], wep_offload->key, 5);
        memcpy(&pkey[8], wep_offload->key, 3);
        memcpy(&pkey[13], wep_offload->key, 5);
    }
    /* Call the encryption function depending on whether
     * it is npe or xscale.
     */
    if ( offload_state & WEP_XSCALE_ENGINE )
    {
        memcpy( data->outBuf, data->inBuf, data->length );
        if ( data->operation == DRIVER_OFFLOAD_OPERATION_WEP_RC4_ENCRYPT )
        {
            inbuf.ix_len = data->length+4;
            inbuf.ix_data = data->outBuf;
            DEBUG( DBG_OFFLOAD, "wep_crypt(): xscale start wep perform\n");
            /* Using the WEP XScale engine which returns synchronously */

            /*TODO
             * Check what can be done with the copy
             * Check if we need to return retval here and pick it up later
             */
            retval = ixCryptoAccXScaleWepPerform( crypt_idx,
                     &inbuf, NULL, 0,
                     data->length, data->length, pkey);
            if ( retval != IX_CRYPTO_ACC_STATUS_SUCCESS )
            {
                return( SM_EUNSPEC );
            }
        }
        else
        {
            inbuf.ix_len = data->length;
            inbuf.ix_data = data->outBuf;
            DEBUG( DBG_OFFLOAD, "wep_crypt(): xscale start wep perform\n");
            /* Using the WEP XScale engine which returns synchronously */

            retval = ixCryptoAccXScaleWepPerform( crypt_idx,
                     &inbuf, NULL, 0,
                     data->length-4, data->length-4, pkey);
            if ( retval != IX_CRYPTO_ACC_STATUS_SUCCESS )
            {
                return( SM_EUNSPEC );
            }
        }

        DEBUG( DBG_OFFLOAD, "wep_crypt(): xscale wep perform returned with %d\n", retval);
        return SM_ENONE;

    }
    else
    {
        retval = ixCryptoAccNpeWepPerform( crypt_idx,
                    (IX_MBUF *) data->inBuf, (IX_MBUF *) data->outBuf, 0,
                    data->length, data->length, pkey);
        if ( retval == IX_CRYPTO_ACC_STATUS_SUCCESS )
        {
            /* The request has been passed to the NPE the result
             * is pending so return pending.
             */
            DEBUG( DBG_OFFLOAD, "wep_crypt(): async WEP encryption in progress\n");
            retval = SM_EPENDING;
        }
    }
    return( retval );
}

uint32_t ccmp_crypt()
{
    extern struct s_driver_offload *data;
    extern uint32_t ccmp_decr_idx;
    extern uint32_t ccmp_encr_idx;
    extern IX_MBUF inbuf;
    extern IX_MBUF outbuf;
    struct s_driver_offload_ccmp *ccmp_offload;
    uint8_t pkey[64];
    uint32_t crypt_idx;
    uint32_t retval;

    printk("ccmp_crypt() entered\n");
    if ( data->operation == DRIVER_OFFLOAD_OPERATION_CCMP_ENCRYPT )
        crypt_idx = ccmp_encr_idx;
    else
        crypt_idx = ccmp_decr_idx;

    ccmp_offload = ( struct s_driver_offload_ccmp *)
                      ((uint32_t *)data + (sizeof(struct s_driver_offload)/4));


    /* Copy the IV in first part of 128 bit key */
    pkey[0] = 0x59;
    memcpy(&pkey[1], ccmp_offload->nonce, 13);
    /* TODO: Bit 14 and 15 must be set to length. Also check the big/little endian req */
    pkey[14] = 0x00;
    pkey[15] = 0x00;
    pkey[16] = 0x01;
    memcpy(&pkey[17], ccmp_offload->nonce, 13);
    /* TODO: Bit 14 and 15 must be set to length. Also check the big/little endian req */
    pkey[30] = 0x00;
    pkey[31] = 0x00;
    memcpy(&pkey[32], ccmp_offload->aad, 32);
    inbuf.ix_len = data->length + 8;
    inbuf.ix_data = data->inBuf;
    outbuf.ix_len = data->length+8;
    outbuf.ix_data = data->outBuf;
    printk("inbuf.ix_len = %d\tinbuf.ix_data pointer = %p\n", inbuf.ix_len, inbuf.ix_data );
    printk("outbuf.ix_len = %d\toutbuf.ix_data pointer = %p\n", outbuf.ix_len, outbuf.ix_data );
    printk("Calling ixCryptoAccAuthCryptPerform ");
    retval = ixCryptoAccAuthCryptPerform( crypt_idx,
                    &inbuf, &outbuf,
                    0, data->length, 0,
                    data->length, data->length, pkey);
    printk("ixCryptoAccAuthCryptPerform returned %d\n", retval );
    return( retval );
}

/* Encryption offload */
int32_t driver_offload( uint32_t sm_handle,
        struct s_driver_offload *driver_offload_data, cb_driver_offload callback )
{
    extern uint32_t driver_handle;
    extern struct s_driver_offload *data;
    extern cb_driver_offload umac_cb;
    extern uint32_t     ccmp_encr_idx;
    uint32_t retval;

    /* Save some parameters for later usage */
    umac_cb = callback;
    driver_handle = sm_handle;
    data = (struct s_driver_offload *)ALIGN_VALUE( (uint32_t)driver_offload_data );

    switch( data->operation )
    {
    case DRIVER_OFFLOAD_OPERATION_WEP_RC4_ENCRYPT:
        /* Check if a WEP RC4 crypto context ID exists */
        if ( !( offload_state & WEPRC4_ENCR_IDX ) )
        {
            /* Check if the crypto access functionaly is initialized once */
            if ( !(offload_state & ACC_INIT) )
            {
                /* Initialise the Crypto Access functionality. */
                if ( (retval = init_crypto_acc()) != IX_CRYPTO_ACC_STATUS_SUCCESS)
                {
                    /* Initialisation of the crypto access functionality
                     * failed. Return an error to the caller.
                     */
                    return( SM_ENOTSUP );
                }
                offload_state |= ACC_INIT;
            }
            /* Create a Crypto Context ID for the WEP encryption */
            retval = create_wep_encr_ctxid();
        }
        /* If a failure occured in creation of the context notify the umac */
        if ( data->flags & DRIVER_OFFLOAD_FLAG_FAIL )
        {
            return( SM_EUNSPEC );
        }
        /* Perform the encryption */
        retval = wep_crypt();
        switch( retval )
        {
        case IX_CRYPTO_ACC_STATUS_SUCCESS:
            if ( offload_state & WEP_XSCALE_ENGINE )
            {
                /* encryption was successfull */
                DEBUG( DBG_OFFLOAD, "driver_offload():: sync WEP encryption request successfull\n");
                data->flags = 0;
                retval = SM_ENONE;
            }
            else
            {
                data->flags = 0;
                retval = SM_EPENDING;
            }
            break;
        case IX_CRYPTO_ACC_STATUS_AUTH_FAIL:
        case IX_CRYPTO_ACC_STATUS_FAIL:
        case IX_CRYPTO_ACC_STATUS_CRYPTO_CTX_NOT_VALID:
        default:
            /* Other failure */
            DEBUG( DBG_OFFLOAD, "driver_offload(): async WEP encryption request failed, retval = %d\n", retval);
            data->flags = DRIVER_OFFLOAD_FLAG_FAIL;
            retval = SM_EUNSPEC;
            break;
        } /* end of switch( retval ) */
        return( retval );
    case DRIVER_OFFLOAD_OPERATION_WEP_RC4_DECRYPT:
        /* Check if a WEP RC4 crypto context ID exists */
        if ( !( offload_state & WEPRC4_DECR_IDX ) )
        {
            /* Check if the crypto access functionaly is initialized once */
            if ( !(offload_state & ACC_INIT) )
            {
                /* Initialise the Crypto Access functionality. */
                if ( (retval = init_crypto_acc()) != IX_CRYPTO_ACC_STATUS_SUCCESS)
                {
                    /* Initialisation of the crypto access functionality
                     * failed. Return an error to the caller.
                     */
                    return( SM_ENOTSUP );
                }
                offload_state |= ACC_INIT;
            }
            /* Create a Crypto Context ID for the WEP encryption */
            retval = create_wep_decr_ctxid();
        }
        /* If a failure occured in creation of the context notify the umac */
        if ( data->flags & DRIVER_OFFLOAD_FLAG_FAIL )
        {
            return( SM_EUNSPEC );
        }
        /* Perform the encryption */
        retval = wep_crypt();
        switch( retval )
        {
        case IX_CRYPTO_ACC_STATUS_SUCCESS:
            if ( offload_state & WEP_XSCALE_ENGINE )
            {
                /* encryption was successfull */
                DEBUG( DBG_OFFLOAD, "driver_offload():: sync WEP encryption request successfull\n");
                data->flags = 0;
                retval = SM_ENONE;
            }
            else
            {
                data->flags = 0;
                retval = SM_EPENDING;
            }
            break;
        case IX_CRYPTO_ACC_STATUS_AUTH_FAIL:
        case IX_CRYPTO_ACC_STATUS_FAIL:
        case IX_CRYPTO_ACC_STATUS_CRYPTO_CTX_NOT_VALID:
        default:
            /* Other failure */
            DEBUG( DBG_OFFLOAD, "driver_offload(): async WEP decryption request failed, retval = %d\n", retval);
            data->flags = DRIVER_OFFLOAD_FLAG_FAIL;
            retval = SM_EUNSPEC;
            break;
        } /* end of switch( retval ) */
        return( retval );
    case DRIVER_OFFLOAD_OPERATION_CCMP_ENCRYPT:
        /* Check if a CCMP crypto context ID exists for encryption */
        printk("driver_offload(): CCMP encrypt: offload_state = 0x%08x\n", offload_state);

        if ( !( offload_state & CCMP_ENCR_IDX ) )
        {
            if ( !(offload_state & ACC_INIT) )
            {
                printk("Initialisation called from within DRIVER_OFFLOAD\n");
                /* Initialise the Crypto Access functionality. */
                if ( (retval = init_crypto_acc()) != IX_CRYPTO_ACC_STATUS_SUCCESS)
                {
                    /* Initialisation of the crypto access functionality
                     * failed. Return an error to the caller.
                     */
                    return( SM_ENOTSUP );
                }
                offload_state |= ACC_INIT;
            }
            /* Initialisation of the crypto access functionality successfull
             * Create a Crypto Context ID for the WEP encryption
             */
            printk("Call create_ccmp_encr_ctxid()\n");
            retval = create_ccmp_encr_ctxid( data );
            /* TODO: Handle the retval here correctly */
            printk("Retval from create_ccmp_encr_ctxid()\n");

        }
        /* Check if the key has changed */
        if ( data->flags & DRIVER_OFFLOAD_FLAG_CONTEXTCHANGE )
        {
            struct s_driver_offload_ccmp *ccmp_offload;

            ccmp_offload = ( struct s_driver_offload_ccmp *)
                             ( (uint32_t *)data + (sizeof(struct s_driver_offload)/4) );

            DEBUG( DBG_OFFLOAD, "driver_offload(): CCMP encryption key needs update\n");
            retval = ixCryptoAccCtxCipherKeyUpdate(     ccmp_encr_idx, ccmp_offload->key);
            if ( retval != IX_CRYPTO_ACC_STATUS_SUCCESS )
            {
                DEBUG( DBG_OFFLOAD, "driver_offload(): key update failed (%d)\n", retval );
                return( SM_ENOTSUP );
            }
            DEBUG( DBG_OFFLOAD, "driver_offload(): key update successfull\n");
        }
        printk("Call ccmp_crypt()\n");

        retval = ccmp_crypt();
        switch( retval )
        {
            case IX_CRYPTO_ACC_STATUS_SUCCESS:
                data->flags = 0;
                retval = SM_EPENDING;
                break;

            case IX_CRYPTO_ACC_STATUS_FAIL:
            case IX_CRYPTO_ACC_STATUS_QUEUE_FULL:
            case IX_CRYPTO_ACC_STATUS_CIPHER_INVALID_BLOCK_LEN:
            case IX_CRYPTO_ACC_STATUS_CRYPTO_CTX_NOT_VALID:
            default:
                /* Other failure */
                DEBUG( DBG_OFFLOAD, "driver_offload(): async CCMP encryption request failed, retval = %d\n", retval);
                data->flags = DRIVER_OFFLOAD_FLAG_FAIL;
                /* TODO: what should the retval be for unsuccessfull en/decryption */
                retval = SM_EUNSPEC;
               break;
        } /* end of switch( retval ) */
        return( retval );
    case DRIVER_OFFLOAD_OPERATION_CCMP_DECRYPT:
        /* Check if a CCMP crypto context ID exists for decryption */
        if ( !( offload_state & CCMP_DECR_IDX ) )
        {
            if ( !(offload_state & ACC_INIT) )
            {
                /* Initialise the Crypto Access functionality. */
                if ( (retval = init_crypto_acc()) != IX_CRYPTO_ACC_STATUS_SUCCESS)
                {
                    /* Initialisation of the crypto access functionality
                     * failed. Return an error to the caller.
                     */
                    return( SM_ENOTSUP );
                }
                offload_state |= ACC_INIT;
            }
            /* Initialisation of the crypto access functionality successfull
             * Create a Crypto Context ID for the CCMP decryption
             */
            /* TODO: Need to check the retval here */
            retval = create_ccmp_decr_ctxid( data );
        }
        /* Check if the key has changed */
        if ( data->flags & DRIVER_OFFLOAD_FLAG_CONTEXTCHANGE )
        {
            extern uint32_t     ccmp_decr_idx;
            struct s_driver_offload_ccmp *ccmp_offload;

            ccmp_offload = ( struct s_driver_offload_ccmp *)
                             ( (uint32_t *)data + (sizeof(struct s_driver_offload)/4) );

            DEBUG( DBG_OFFLOAD, "driver_offload(): CCMP encryption key needs update\n");
            retval = ixCryptoAccCtxCipherKeyUpdate(     ccmp_decr_idx, ccmp_offload->key);
            if ( retval != IX_CRYPTO_ACC_STATUS_SUCCESS )
            {
                DEBUG( DBG_OFFLOAD, "driver_offload(): key update failed (%d)\n", retval );
                return( SM_ENOTSUP );
            }
            DEBUG( DBG_OFFLOAD, "driver_offload(): key update successfull\n");
        }
        retval = ccmp_crypt();
        switch( retval )
        {
            case IX_CRYPTO_ACC_STATUS_SUCCESS:
                data->flags = 0;
                retval = SM_EPENDING;
                break;

            case IX_CRYPTO_ACC_STATUS_FAIL:
            case IX_CRYPTO_ACC_STATUS_QUEUE_FULL:
            case IX_CRYPTO_ACC_STATUS_CIPHER_INVALID_BLOCK_LEN:
            case IX_CRYPTO_ACC_STATUS_CRYPTO_CTX_NOT_VALID:
            default:
                /* Other failure */
                DEBUG( DBG_OFFLOAD, "driver_offload(): async CCMP encryption request failed, retval = %d\n", retval);
                data->flags = DRIVER_OFFLOAD_FLAG_FAIL;
                /* TODO: what should the retval be for unsuccessfull en/decryption */
                retval = SM_EUNSPEC;
                break;
        } /* end of switch( retval ) */
        return( retval );

    default:
        /* Offload operation is not supported. */
        return SM_ENOTSUP;
    } /* end of switch ( data->operation ) */
    return SM_ENOTSUP;
}
