/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM® wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, w;hether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *;
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#define __KERNEL_SYSCALLS__

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/pci.h>
#include <linux/string.h>
#include <linux/poll.h>
#include <asm/uaccess.h>

#ifdef SM_DRV_PCI_HP
#include <asm/io.h>
#endif

#include <pcmcia/driver_ops.h>

#include "sm_drv.h"
#include "sm_drv_pci.h"
#include "version_info.h"

#ifdef PCIUART
#include "sm_drv_uartpci.h"
#endif

#ifdef UMAC_PROFILER
#include "sm_drv_prof.h"
#endif

#ifdef NETLINK_SUPPORT
#include "sm_drv_netlink.h"
#endif

#ifdef WDS_SUPPORT
#include "sm_drv_wds.h"
#endif

#ifdef MEMORY_TRACER
#include "sm_drv_memuse.h"
#endif

void sm_drv_pci_cli(struct net_device *dev);
int sm_drv_hif_up(struct net_device *dev);
int sm_drv_hif_down(struct net_device *dev);
void sm_drv_lmac_update(struct net_device *dev);


struct net_device *sm_drv_pci_probe(struct net_device *dev, long ioaddr, int irq);



static void sm_drv_pci_free_rx_queue(struct net_device *dev, int queue);
static void sm_drv_pci_initialize(struct net_device *dev);
static void sm_drv_pci_frag_rx(struct net_device *dev, struct fragment *frag,
                           struct s_fragq_hdl *fragq_hdl, int32_t *callb_mask);
static void sm_drv_pci_ic_message_query(struct net_device *dev, int32_t *callb_mask);
static void sm_drv_pci_interface_reset(void *device_base, dma_addr_t host_address);
int sm_drv_pci_upload_firmware(struct net_device *dev, int load_fw);

#ifdef SM_DRV_PCI_CB
#define DRIVER_NAME             "sm_drv_cb"
#endif
#ifdef SM_DRV_PCI_HP
#define DRIVER_NAME             "sm_drv_hp"
#endif

extern unsigned int boot_mode;
char driver_name[64] = DRIVER_NAME;

#ifdef SM_DRV_PCI_CB
/*****************************************************************************/
/*    CARD BUS specific code                                                 */
/*****************************************************************************/


/******************************************************************************
 *   Module initialization functions
 ******************************************************************************/
static dev_node_t *sm_drv_pci_attach(dev_locator_t * loc)
{
    uint32_t        io;
    uint16_t        dev_id;
    uint8_t         bus,
                    devfn,
                    irq;
    struct pci_dev *pci_device;
    struct net_device *dev;
    dev_node_t     *node;
    struct net_local *lp;
    struct pci_hif_local_data *hif_lp;

    int             rvalue;
    int             dma_mask = 0xffffffff;

    if (loc->bus != LOC_PCI)
            return NULL;

    bus = loc->b.pci.bus;
    devfn = loc->b.pci.devfn;

    DEBUG(DBG_CALLS, "sm_drv_pci_attach(bus %d, function %d)\n", bus, devfn);
    
    /* Disable timeouts to prevent PCI Fatal Errors */
    pcibios_write_config_byte(bus, devfn, PCI_TRDY_TIMEOUT, 0);
    pcibios_write_config_byte(bus, devfn, PCI_RETRY_TIMEOUT, 0);

    /* get some pci settings for verification */
    pcibios_read_config_dword(bus, devfn, PCI_BASE_ADDRESS_0, &io);
    pcibios_read_config_byte(bus, devfn, PCI_INTERRUPT_LINE, &irq);
    pcibios_read_config_word(bus, devfn, PCI_DEVICE_ID, &dev_id);

    if (io &= ~3, io == 0 || irq == 0) {
        printk("ERROR: %s no %s.\n", DRIVER_NAME,
               io == 0 ? "I/O address" : "IRQ");
        return NULL;
    }

    /* get pci device information by loading the pci_dev structure */
    if (pci_device = pci_find_slot(bus, devfn), pci_device == NULL) {
        printk("ERROR: %s could not get PCI device information \n",
               DRIVER_NAME);
        return NULL;
    }
    /* determine what the supported DMA memory region is */
    while (pci_set_dma_mask(pci_device, dma_mask) != 0) {
        /* range not supported, shift the mask and check again */
        if (dma_mask >>= 1, dma_mask == 0) {
            printk("DMA Memory not supported\n");
            return NULL;
        }
    }

    DEBUG(DBG_TRACE, "DMA Memory support mask is 0x%x \n", dma_mask);

    /* setup the network device interface and its structure */
    dev = sm_drv_pci_probe(NULL, (long) io, (int) irq);
    if (dev == NULL) {
        printk("ERROR: %s could not configure network device \n",
               DRIVER_NAME);
        return NULL;
    }

    lp = dev->priv;
    hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    if (sm_drv_pci_config(pci_device, dev) < 0) {
        printk("ERROR: %s could not configure PCI device \n", DRIVER_NAME);
        kfree( hif_lp );
        kfree( dev->priv );
        kfree( dev );
        return NULL;
    }
    /* save the interrupt request line and use the remapped device base address
     * as the device identification both for uniqueness and parameter passing
     * to the interrupt handler */
    hif_lp->pci_irq = irq;
    hif_lp->pci_dev_id = dev_id;
    lp->device_id = hif_lp->remapped_device_base;
    hif_lp->pci_device = pci_device;

    /* request for the interrupt before uploading the firmware */
    rvalue = request_irq(irq, &sm_drv_pci_interrupt, SA_INTERRUPT | SA_SHIRQ,
             DRIVER_NAME, dev);
    if (rvalue) {
        printk("ERROR: %s could not install IRQ-handler \n", DRIVER_NAME);
        goto err_out;
    }

    /* By default we startup as client depending on the driver mode paramater */
    if (sm_drv_up(dev, boot_mode) < 0) {
        goto err_out;
    }
err_out:
    /* finally setup the node structure with the device information */
    node = kmalloc(sizeof(dev_node_t), GFP_ATOMIC);
    if(!node) {
        printk("Could not allocate node\n");
        goto err_out;
    }

#ifdef NETLINK_SUPPORT
    mgt_indication_handler ( DEV_NETWORK, dev->name, 0, sm_drv_mgt_indication );
#endif

    strcpy(node->dev_name, dev->name);
    node->major = 0;
    node->minor = 0;
    node->next = NULL;
    MOD_INC_USE_COUNT;
    return node;
}

static void sm_drv_pci_suspend(dev_node_t * node)
{
    struct net_device **devp,
                  **next;

    DEBUG(DBG_CALLS, "sm_drv_pci_suspend(%s)\n", node->dev_name);

    for (devp = &root_sm_drv_device; *devp; devp = next) {
        next = &((struct net_local *) (*devp)->priv)->next_module;
        if (strcmp((*devp)->name, node->dev_name) == 0)
            break;
    }

    if (*devp) {
        // long ioaddr = (*devp)->base_addr;
        // sm_drv_pci_pause(*devp);
    }
}

static void sm_drv_pci_resume(dev_node_t * node)
{
    struct net_device **devp, **next;

    DEBUG(DBG_CALLS, "sm_drv_pci_resume(%s)\n", node->dev_name);

    for (devp = &root_sm_drv_device; *devp; devp = next) {
        next = &((struct net_local *) (*devp)->priv)->next_module;
        if (strcmp((*devp)->name, node->dev_name) == 0)
            break;
    }

    if (*devp) {
        // sm_drv_pci_restart(*devp);
    }
}

static void sm_drv_pci_detach(dev_node_t * node)
{
    struct net_device **devp, **next;

    DEBUG(DBG_CALLS, "sm_drv_pci_detach(%s)\n", node->dev_name);

    for (devp = &root_sm_drv_device; *devp; devp = next) {
        next = &((struct net_local *) (*devp)->priv)->next_module;
        if (strcmp((*devp)->name, node->dev_name) == 0)
            break;
    }

    if (*devp) {
        struct net_local *lp = (*devp)->priv;
        struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

        /* free the interrupt request */
        writel(0, hif_lp->remapped_device_base + DEV38XX_INT_EN_REG);
        free_irq(hif_lp->pci_irq, *devp);

        /* free the node */
        kfree(node);
        MOD_DEC_USE_COUNT;
    }
}


struct driver_operations sm_drv_pci_ops = {
    DRIVER_NAME, sm_drv_pci_attach, sm_drv_pci_suspend, sm_drv_pci_resume,
    sm_drv_pci_detach
};

static int __init sm_drv_pci_init_module(void)
{
    DEBUG(DBG_ALL, "Loaded %s, version %s\n", DRIVER_NAME,
          VERSIONID);

#ifdef PCIUART
    uartpci_init_module();
#endif

#ifdef UMAC_PROFILER
    prof_init_module();
#endif

#ifdef NETLINK_SUPPORT
    mgt_initialize();
#endif

#ifdef MEMORY_TRACER
    mu_init();
#endif

    register_driver(&sm_drv_pci_ops);

    return 0;
}

static void __exit sm_drv_pci_cleanup_module(void)
{
    struct net_device *next_dev;
    struct net_local *lp;
    struct pci_hif_local_data *hif_lp;

#ifdef NETLINK_SUPPORT
    mgt_cleanup();
#endif

#ifdef MEMORY_TRACER
	mu_cleanup();
#endif

    unregister_driver(&sm_drv_pci_ops);

    /*
     * No need to check MOD_IN_USE, as sys_delete_module() checks.
     */
    while (root_sm_drv_device) {
        lp = root_sm_drv_device->priv;
        hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

        next_dev = lp->next_module;

        DEBUG(DBG_ALL, "Cleanup netdevice\n");

        sm_drv_down(root_sm_drv_device);

        /* unregister the network device */
        unregister_netdev(root_sm_drv_device);

        /* free the PCI memory and unmap the remapped page */
        pci_free_consistent(hif_lp->pci_device, DEV38XX_HOST_MEM_BLOCK,
                    hif_lp->driver_mem_address, hif_lp->device_host_address);
        iounmap(hif_lp->remapped_device_base);

        /* free the separately allocated areas */
#ifdef WDS_SUPPORT
        if(lp->wdsp)
            kfree(lp->wdsp);
#endif
#ifdef VSSDEV_SUPPORT
        del_all_vss_devices(lp->vssdev);
        if(lp->vssdev)
            kfree(lp->vssdev);
#endif
	if(lp->sm_context)
	    kfree(lp->sm_context);		
	kfree(lp->sm_initdata);
        kfree(hif_lp);
        kfree(lp);
        kfree(root_sm_drv_device);

        /* change the root device pointer to the next device for clearing */
        root_sm_drv_device = next_dev;
    }

#ifdef PCIUART
    uartpci_cleanup_module();
#endif

#ifdef UMAC_PROFILER
    prof_cleanup_module();
#endif

    DEBUG(DBG_ALL, "Unloaded %s\n", DRIVER_NAME);    
}

module_init(sm_drv_pci_init_module);
module_exit(sm_drv_pci_cleanup_module);


#endif //SM_DRV_PCI_CB

#ifdef SM_DRV_PCI_HP
/*****************************************************************************/
/*    HOT PLUG specific code                                                 */
/*****************************************************************************/

/******************************************************************************
 *   General Driver Functions
 ******************************************************************************/


int sm_drv_pci_probe_pci(struct pci_dev *pci_device, const struct pci_device_id *id);
void sm_drv_pci_remove_pci( struct pci_dev * );


/******************************************************************************
 *   Module initialization functions
 ******************************************************************************/
struct pci_device_id pci_id_table[] =
{
    {
        PCIVENDOR_CONEXANT, PCIDEVICE_PRISM3886,
        PCI_ANY_ID, PCI_ANY_ID, 0, 0,
        // Driver data, we just put the name here
        (unsigned long) "PRISM 3886 Wireless LAN adapter"
    },
    {
        PCIVENDOR_CONEXANT, PCIDEVICE_PRISMffff,
        PCI_ANY_ID, PCI_ANY_ID, 0, 0,
        // Driver data, we just put the name here
        (unsigned long) "PRISM 3886 Wireless LAN adapter"
    },
    {
        PCIVENDOR_CONEXANT, PCIDEVICE_PRISM3888,
        PCI_ANY_ID, PCI_ANY_ID, 0, 0,
        // Driver data, we just put the name here
        (unsigned long) "PRISM 3888 (Isotope) Wireless LAN adapter"
    },
    {
        PCIVENDOR_CONEXANT, PCIDEVICE_PRISM3890,
        PCI_ANY_ID, PCI_ANY_ID, 0, 0,
        // Driver data, we just put the name here
        (unsigned long) "PRISM 3890 Wireless LAN adapter"
    },
    {
        0, 0, 0, 0, 0, 0, 0
    }
};

// register the device with the Hotplug facilities of the kernel
#ifdef MODULE
MODULE_DEVICE_TABLE( pci, pci_id_table );
#endif

struct pci_driver sm_drv_pci_drv_id =
{
    {},
    DRIVER_NAME,                // Driver name
    pci_id_table,               // id table
    sm_drv_pci_probe_pci,           // probe function
    sm_drv_pci_remove_pci,          // remove function
    NULL,                       // save_state function
    NULL,                       // suspend function
    NULL,                       // resume function
    NULL,                       // enable_wake function
};

/******************************************************************************
    Module initialization functions
******************************************************************************/

int sm_drv_pci_probe_pci(struct pci_dev *pci_device, const struct pci_device_id *id)
{
    struct net_device *dev=NULL;
    struct net_local *lp;
    struct pci_hif_local_data *hif_lp;
    void *io;
    u16 irq;
    u8 bus, devfn; //, latency_tmr;
    int rvalue, dev_id;
    int dma_mask = 0xffffffff;

    DEBUG(DBG_CALLS, "%s: sm_drv_pci_probe_pci\n", DRIVER_NAME);

    // Enable the pci device
    if (pci_enable_device(pci_device))
    {
        printk("ERROR: %s pci_enable_device() failed.\n", DRIVER_NAME );
        return -EIO;
    }

    // Figure out our resources
    irq = pci_device->irq;
    bus = pci_device->bus->number;
    devfn = pci_device->devfn;
    dev_id = pci_device->device;

    /* Disable timeouts to prevent PCI Fatal Errors */
    pcibios_write_config_byte(bus, devfn, PCI_TRDY_TIMEOUT, 0 );
    pcibios_write_config_byte(bus, devfn, PCI_RETRY_TIMEOUT, 0 );

    // check whether the latency timer is set correctly
//    pcibios_read_config_byte(bus, devfn, PCI_LATENCY_TIMER, &latency_tmr);
//    if( latency_tmr < PCIDEVICE_LATENCY_TIMER_MIN )
//    {
        // set the latency timer
//      pcibios_write_config_byte(bus, devfn, PCI_LATENCY_TIMER,
//              PCIDEVICE_LATENCY_TIMER_VAL );
//    }

    // determine what the supported DMA memory region is
    while( pci_set_dma_mask( pci_device, dma_mask ) != 0 )
    {
        // range not supported, shift the mask and check again
        if( dma_mask >>=  1, dma_mask == 0 )
        {
            // mask is zero, DMA memory not supported by PCI
            printk("ERROR: DMA Memory not supported\n" );
            return -EIO;
        }
    }

    DEBUG(DBG_TRACE, "%s: DMA Memory support mask is 0x%x \n",
        DRIVER_NAME, dma_mask );

    // call for the physical address to address the PCI device
    io = (void *) pci_resource_start(pci_device, 0);

    // request the pci device for regions ???
    if (rvalue = pci_request_regions(pci_device, DRIVER_NAME ), rvalue)
    {
        printk("ERROR: pci_request_regions failure, rvalue %i\n", rvalue );
        return -EIO;
    }

    // enable PCI bus-mastering
    pci_set_master(pci_device);

    // Log the device resources information
    DEBUG(DBG_TRACE, "%s: io:0x%lx, irq:%d \n", DRIVER_NAME, (long) io, irq);

    // setup the network device interface and its structure
    if (dev = sm_drv_pci_probe(dev, (long) io, (int) irq), dev == NULL)
    {
        // error configuring the driver as a network device
        printk("ERROR: %s could not configure network device \n", DRIVER_NAME );
        return -EIO;
    }

    lp = dev->priv;
    hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    if (sm_drv_pci_config(pci_device, dev) < 0)
    {
        printk("ERROR: %s could not configure PCI device \n", DRIVER_NAME);
        kfree(hif_lp);
        kfree(dev->priv);
        kfree(dev);
        return -EIO;
    }

    // save the interrupt request line and use the remapped device base address
    // as the device identification both for uniqueness and parameter passing
    // to the interrupt handler
    hif_lp->pci_irq = irq;
    hif_lp->pci_dev_id = dev_id;
    lp->device_id = hif_lp->remapped_device_base;
    hif_lp->pci_device = pci_device;

    // request for the interrupt before uploading the firmware
    if (rvalue = request_irq(irq, &sm_drv_pci_interrupt, SA_INTERRUPT | SA_SHIRQ,
        DRIVER_NAME, dev), rvalue != 0)
    {
        // error, could not hook the handler to the irq
        printk("ERROR: %s could not install IRQ-handler \n", DRIVER_NAME );
        kfree(hif_lp);
        kfree(dev->priv);
        kfree(dev);
        return -EIO;
    }

    /* By default we startup as client depending on the driver mode paramater */
    if (sm_drv_up(dev, boot_mode) < 0)
    {
        // error, could not start SoftMAC
        printk("ERROR: %s could not start SoftMAC \n", DRIVER_NAME );
        kfree(hif_lp);
        kfree(dev->priv);
        kfree(dev);
        return -EIO;
    }

#ifdef NETLINK_SUPPORT
    mgt_indication_handler ( DEV_NETWORK, dev->name, 0, sm_drv_mgt_indication );
#endif

    return 0;
}

void sm_drv_pci_remove_pci( struct pci_dev *pci_device )
{
    struct net_device **devp, **next;
    struct net_local *lp;
    struct pci_hif_local_data *hif_lp;

    DEBUG(DBG_CALLS, "sm_drv_pci_remove_pci\n");
    
    for (devp = &root_sm_drv_device; *devp; devp = next)
    {
        next = &((struct net_local *) (*devp)->priv)->next_module;
        lp = (*devp)->priv;
        hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

        // free the interrupt request
        writel(0, hif_lp->remapped_device_base + DEV38XX_INT_EN_REG);
        free_irq(hif_lp->pci_irq, *devp);
    }
}

int init_module( void )
{
    DEBUG(DBG_ALL, "Loaded %s, version %s\n", DRIVER_NAME, VERSIONID);
    
#ifdef PCIUART
    uartpci_init_module();
#endif

#ifdef NETLINK_SUPPORT
    mgt_initialize();
#endif

#ifdef MEMORY_TRACER
	mu_init();
#endif

    if (pci_register_driver(&sm_drv_pci_drv_id) <= 0)
    {
        DEBUG(DBG_ALL, "%s: No devices found, driver not installed.\n",
            DRIVER_NAME);
        pci_unregister_driver(&sm_drv_pci_drv_id);
        return -ENODEV;
    }

    return 0;
}

void cleanup_module( void )
{
    struct net_device *next_dev;
    struct net_local *lp;
    struct pci_hif_local_data *hif_lp;

#ifdef NETLINK_SUPPORT
    mgt_cleanup();
#endif

#ifdef MEMORY_TRACER
    mu_cleanup();
#endif

    pci_unregister_driver(&sm_drv_pci_drv_id);

    // No need to check MOD_IN_USE, as sys_delete_module() checks
    while (root_sm_drv_device)
    {
        lp = root_sm_drv_device->priv;
        hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;
        next_dev = lp->next_module;

        DEBUG(DBG_ALL, "Cleanup netdevice\n");

        sm_drv_down(root_sm_drv_device);

        /* unregister the network device */
        unregister_netdev(root_sm_drv_device);

        /* free the PCI memory and unmap the remapped page */
        pci_free_consistent(hif_lp->pci_device, DEV38XX_HOST_MEM_BLOCK,
                    hif_lp->driver_mem_address, hif_lp->device_host_address);
        iounmap(hif_lp->remapped_device_base);
        pci_release_regions(hif_lp->pci_device);

        /* free the separately allocated areas */
#ifdef WDS_SUPPORT
        if(lp->wdsp)
            kfree(lp->wdsp);
#endif
#ifdef VSSDEV_SUPPORT
	del_all_vss_devices(lp->vssdev);        
	if(lp->vssdev)
            kfree(lp->vssdev);
#endif
	if(lp->sm_context)
	    kfree(lp->sm_context);		
	kfree(lp->sm_initdata);
        kfree(hif_lp);
        kfree(lp);
        kfree(root_sm_drv_device);

        /* change the root device pointer to the next device for clearing */
        root_sm_drv_device = next_dev;
    }

#ifdef PCIUART
    uartpci_cleanup_module();
#endif

    DEBUG(DBG_ALL, "Unloaded %s\n", DRIVER_NAME);    
}

#endif //SM_DRV_PCI_HP


struct net_device *sm_drv_pci_probe(struct net_device *dev, long ioaddr, int irq)
{
    struct net_local *lp;

    DEBUG(DBG_CALLS, "sm_drv_pci_probe\n");

    dev = sm_drv_netdev_create(dev, ioaddr, irq);

    lp = dev->priv;

    lp->hif_up          = &sm_drv_hif_up;
    lp->hif_down        = &sm_drv_hif_down;
    lp->hif_cli         = &sm_drv_pci_cli;

    /* add a private host interface spacific structure to the network device for private
     * hif definitions needed by the driver */
    lp->hif_local_data = kmalloc(sizeof(struct pci_hif_local_data), GFP_ATOMIC | GFP_DMA);
    if (!lp->hif_local_data) {
        printk("ERROR: Could not allocate host interface specific data\n");
        kfree(lp);
        kfree(dev);
        return NULL;;
    }
    memset(lp->hif_local_data, 0, sizeof(struct pci_hif_local_data));

    return dev;
}

void sm_drv_pci_cli(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    writel(0, hif_lp->remapped_device_base + DEV38XX_INT_EN_REG);
}

int sm_drv_hif_up(struct net_device *dev)
{
    int queue;
    /* Initialize the fragment queues. They are filled with empty
     * fragments in the bottom halve after the init interrupt
     */
    for (queue = 0; queue < CB_QCOUNT; queue++) {
        fragq_init(dev, queue);
    }

    if (sm_drv_pci_upload_firmware(dev, 1) < 0) {
        printk("ERROR: failed to upload the firmware \n");
        return -1;
    }

    return 0;
}

int sm_drv_hif_down(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    /* stop the LMAC now in order to prevent it writing to host memory anymore. */
    writel(DEV38XX_DEV_INT_ABORT, hif_lp->remapped_device_base + DEV38XX_DEV_INT_REG);
    mdelay(50);

    /* After SoftMAC shutdown, we can free the queues */
    sm_drv_pci_free_rx_queue(dev, CB_RX_CTRLQ);
    sm_drv_pci_free_rx_queue(dev, CB_RX_DATAQ);

    return 0;
}
/******************************************************************************
 *   Interconnect handling
 ******************************************************************************/
static void sm_drv_pci_add_rx_queue(struct net_device *dev, int queue)
{
    struct net_local *lp = dev->priv;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;
    struct s_fragq_hdl fragq_hdl;
    struct s_ic_msg *ic_msg;
    struct s_sm_frame *frame;
    struct fragment frag;

    frame = frame_skb_alloc(dev, lp->sm_descr.mtu, lp->sm_descr.rxoffset);
    if(!frame) {
        printk(KERN_ERR "Cannot allocate frame for RX Queue %d\n", queue);
        return;
    }

    /* Our ic_msg is embedded in the frame */
    ic_msg = FRAME_ICMSG(frame);
    ic_msg->frame = frame;

    fragq_hdl.ic_msg = ic_msg;
    fragq_hdl.dma_handle = pci_map_single(hif_lp->pci_device,
                                          frame->data, frame->length,
                                          PCI_DMA_FROMDEVICE);

    frag.host_address = cpu_to_le32(fragq_hdl.dma_handle);
    frag.lmac_address = cpu_to_le32(0);
    frag.size = cpu_to_le16(frame->length);
    frag.flags = cpu_to_le16(0);

    fragq_produce(lp, queue, &frag, &fragq_hdl);
    hif_lp->generate_update_interrupt = 1;
}

static void sm_drv_pci_free_rx_queue(struct net_device *dev, int queue)
{
    struct net_local *lp = dev->priv;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    DEBUG(DBG_CALLS, "sm_drv_pci_free_rx_queue: q %d\n", queue);

    /* Free up any frames that are still in the RX queues */
    while (fragq_drv_pspace(lp, queue) < frag_queue_size[queue]) {
        struct fragment *frag;
        struct s_fragq_hdl *fragq_hdl;
        struct s_ic_msg *ic_msg;

        frag = fragq_consume(lp, queue, &fragq_hdl);
        ic_msg = fragq_hdl->ic_msg;

        DEBUG(DBG_TRACE, "sm_drv_pci_free_rx_queue: Freeing frame at 0x%p (dma 0x%lx)\n",
              ic_msg->frame, (unsigned long)fragq_hdl->dma_handle);

        pci_unmap_single(hif_lp->pci_device, fragq_hdl->dma_handle,
                         ic_msg->frame->length, PCI_DMA_FROMDEVICE);

        frame_skb_free(dev, ic_msg->frame);
    }
}

static void sm_drv_pci_initialize(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    struct s_sm_setup setup;
    int32_t callb_mask;
    int i;

    spin_lock_bh(&lp->sm_lock);

    DEBUG(DBG_CALLS, "sm_drv_pci_initialize\n");
    
	if( prism_softmac_describe( &lp->sm_descr, lp->sm_initdata ) != SM_ENONE ) {
		printk(KERN_ERR "%s: Fatal Error: LMAC - UMAC incomptability\n", driver_name );
		return;
	}

    setup.mode = lp->sm_mode;
    setup.rx_align = 0;
    setup.max_sta = DEV_MAX_STA;
    setup.max_bss = DEV_MAX_BSS;
    for(i = 0; i < 8; i++)
        setup.depth[i] = 8;

	/* allocate a memory region for the UMAC context */ 
	lp->sm_context = (uint32_t *) kmalloc( lp->sm_descr.context_size, GFP_ATOMIC );
	if( !lp->sm_context	)
	{
		printk(KERN_ERR "%s: Fatal Error: UMAC Context Memory could not be allocated\n", driver_name );
		return;
	}

    callb_mask = prism_softmac_create( lp->sm_context, &setup, NULL, lp->sm_initdata);
    if(callb_mask < 0) {
        printk(KERN_ERR "%s: Fatal Error: could not create SoftMAC (%d)\n", driver_name, callb_mask);
        lp->sm_descr.mtu = 0;
    } else {
        sm_drv_psm_fsm(dev, PSMEVENT_BOOT);
    }

#ifdef PCIUART
    /* (Re)initialize the UART over PCI protocol */
    uartpci_prot_reinit();
#endif

    /* fill rx queues of control block */
    while(fragq_drv_pspace(lp, CB_RX_CTRLQ) > 0) {
        sm_drv_pci_add_rx_queue(dev, CB_RX_CTRLQ);
    }
    while(fragq_drv_pspace(lp, CB_RX_DATAQ) > 0) {
        sm_drv_pci_add_rx_queue(dev, CB_RX_DATAQ);
    }

    spin_unlock_bh(&lp->sm_lock);
}

/* NOT called under sm_lock. This function cleans frags which have */
/* tx-ed to LMAC and which have accepted by LMAC. We just release  */
/* those fragments if needed.                                      */
static void sm_drv_pci_frag_txed(struct net_device *dev, struct fragment *frag,
                           struct s_fragq_hdl *fragq_hdl)
{
    struct s_ic_msg *ic_msg = fragq_hdl->ic_msg;
    struct net_local *lp = dev->priv;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    DEBUG(DBG_IRQ, "sm_drv_pci_frag_txed\n");

    /* unmap the used memory fragment before freeing */
    pci_unmap_single(hif_lp->pci_device, fragq_hdl->dma_handle,
    	ic_msg->length, PCI_DMA_FROMDEVICE );
       
    /* fragq_hdl->ic_msg is only valid when the IC_FLAG_FREE flag was not set
     * on the original ic_msg. Otherwise, it may be freed already by the UMAC */
    if (fragq_hdl->ic_msg_flags & IC_FLAG_FREE) {
        struct s_ic_msg *ic_msg = fragq_hdl->ic_msg;
        if (ic_msg->frame)
            prism_driver_frame_free(lp->sm_context, ic_msg->frame);
        else
            prism_driver_free(lp->sm_context, ic_msg);
    }
}

/* NOT called under sm_lock. This function checks if frames have   */
/* been tx-ed to LMAC and which have been accepted by LMAC. We     */
/* just release  those fragments if needed. This function is to    */
/* be called from interrupt handler in case op an update interrupt */
/* and before any target DMA is started to make sure right         */
/* fragment is sent with targetDMA function.                       */
static void sm_drv_pci_check_txed(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    struct fragment *frag;
    struct s_fragq_hdl *fragq_hdl;

    /* check for any transmitted frames, first CTRL queue */
    while (fragq_drv_cspace(lp, CB_TX_CTRLQ)) {
        DEBUG(DBG_BH, "Control Frame Sent to LMAC\n");

        frag = fragq_consume(lp, CB_TX_CTRLQ, &fragq_hdl);
        sm_drv_pci_frag_txed(dev, frag, fragq_hdl);
    }
    /* now the data queue */
    while (fragq_drv_cspace(lp, CB_TX_DATAQ)) {
        DEBUG(DBG_BH, "Data Frame Sent to LMAC\n");

        frag = fragq_consume(lp, CB_TX_DATAQ, &fragq_hdl);
        sm_drv_pci_frag_txed(dev, frag, fragq_hdl);
    }
}


/* called under sm_lock */
static void sm_drv_pci_frag_rx(struct net_device *dev, struct fragment *frag,
                           struct s_fragq_hdl *fragq_hdl, int32_t *callb_mask)
{
    struct net_local *lp = dev->priv;
    struct s_ic_msg *ic_msg = fragq_hdl->ic_msg;
    uint32_t addr_offset;

    DEBUG(DBG_IRQ, "sm_drv_pci_frag_rx\n");

    pci_unmap_single( ((struct pci_hif_local_data*)lp->hif_local_data)->pci_device, fragq_hdl->dma_handle,
                      ic_msg->frame->length, PCI_DMA_FROMDEVICE);

    /*
     * Check if the LMAC has updated the host address pointer
     * We must account for this in or ic_msg data pointer
     */
    DEBUG(DBG_IC, "sm_drv_pci_frag_rx(%x, %x, %d, %x)\n",
       frag->host_address, fragq_hdl->dma_handle, frag->size, frag->lmac_address );

    addr_offset     = le32_to_cpu(frag->host_address) - fragq_hdl->dma_handle;

    ic_msg->data    = ic_msg->frame->data + addr_offset;
    ic_msg->address = le32_to_cpu(frag->lmac_address);
    ic_msg->length  = le16_to_cpu(frag->size);
    ic_msg->flags   = le16_to_cpu(0);

    DEBUG(DBG_IC, "prism_interconnect_message_handle(%d, %x, %d, %x, %p)\n",
       ic_msg->channel, ic_msg->flags, ic_msg->length, ic_msg->address, ic_msg->data );
    *callb_mask = prism_interconnect_message_handle(lp->sm_context, ic_msg);

    if(*callb_mask < 0) {
        printk(KERN_WARNING "sm_drv_pci_frag_rx: prism_interconnect_message_handle returned error %d\n", *callb_mask);
    }
}


/* called under sm_lock */
static void sm_drv_pci_ic_message_query(struct net_device *dev, int32_t *callb_mask)
{
    struct net_local *lp = dev->priv;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    uint32_t ic_mask;
    struct s_ic_msg *ic_msg;
    struct s_fragq_hdl fragq_hdl;
    struct fragment frag;

    DEBUG(DBG_TRACE, "sm_drv_pci_ic_message_query: callbmask 0x%x\n", *callb_mask);

    if(!(*callb_mask & SM_IC))
        return;

again:
    ic_mask = 0;
    if( fragq_drv_pspace(lp, CB_TX_DATAQ) > 0)
        ic_mask |= IC_MASK_FRAME;
    if( fragq_drv_pspace(lp, CB_TX_CTRLQ) > 0)
        ic_mask |= IC_MASK_CTRL;

    if((ic_mask) && (*callb_mask & SM_IC))
    {
        *callb_mask = prism_interconnect_message_query(lp->sm_context, ic_mask, &ic_msg);
        if(!ic_msg)
            goto out;

        DEBUG(DBG_IC, "prism_interconnect_message_query(%d, %x, %d, %x, %p)\n",
           ic_msg->channel, ic_msg->flags, ic_msg->length, ic_msg->address, ic_msg->data );

        fragq_hdl.ic_msg = ic_msg;
        /* We save the ic_msg flags here because we need to know if we
         * can free the ic_msg after the LMAC has received it (check on
         * IC_FLAG_FREE in sm_drv_pci_frag_rx).
         * It can happen that the frame/ic_msg is freed by the UMAC
         * before we can examine the ic_msg->flags in "sm_drv_pci_frag_rx".
         */
        fragq_hdl.ic_msg_flags = ic_msg->flags;
        fragq_hdl.dma_handle = pci_map_single(hif_lp->pci_device,
                                              ic_msg->data, ic_msg->length,
                                              PCI_DMA_TODEVICE);

        /* Multiple fragments are not supported */
        frag.host_address = cpu_to_le32(fragq_hdl.dma_handle);
        frag.lmac_address = cpu_to_le32(ic_msg->address);
        frag.size = cpu_to_le16(ic_msg->length);

        if(ic_msg->channel == IC_CHANNEL_CTRL) {
            frag.flags = cpu_to_le16(FRG_FLAG_CONTROL);
            fragq_produce(lp, CB_TX_CTRLQ, &frag, &fragq_hdl);
        } else {
            frag.flags = 0;
            fragq_produce(lp, CB_TX_DATAQ, &frag, &fragq_hdl);
        }
        hif_lp->generate_update_interrupt = 1;

        goto again;
    }
out:
    /* handle the callback requests */
    if(*callb_mask < 0) {
        printk(KERN_WARNING "sm_drv_pci_frag_rx: ic_message_handle returned error %d\n", *callb_mask);
    }
}


static void sm_drv_pci_bh(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;
    struct fragment *frag;
    struct s_fragq_hdl *fragq_hdl;
    int32_t callb_mask = SM_IC;

    /* This must be done outside the spin lock */
    if (lp->sm_descr.mtu == 0) {
        DEBUG(DBG_BH, "Bottom Halve: SoftMAC not initialized\n");
        sm_drv_down(dev);
        return;
    }
    /* Lets lock the SoftMAC since we cant have that one interferring */
    spin_lock_bh(&lp->sm_lock);

    DEBUG(DBG_BH, "Bottom Halve\n");

    /* check all queues in priority order */
    while(fragq_drv_cspace(lp, CB_RX_CTRLQ)) {
        DEBUG(DBG_BH, "Received frame in Control Queue\n");

        frag = fragq_consume(lp, CB_RX_CTRLQ, &fragq_hdl);
        fragq_hdl->ic_msg->channel = IC_CHANNEL_CTRL;

        sm_drv_pci_frag_rx(dev, frag, fragq_hdl, &callb_mask);

        while(fragq_drv_pspace(lp, CB_RX_CTRLQ) > 0) {
            sm_drv_pci_add_rx_queue(dev, CB_RX_CTRLQ);
        }
    }

    while (fragq_drv_cspace(lp, CB_RX_DATAQ)) {
        DEBUG(DBG_BH, "Received frame in Data Queue \n");

        frag = fragq_consume(lp, CB_RX_DATAQ, &fragq_hdl);
        if(le16_to_cpu(frag->flags) & FRG_FLAG_CONTROL)
            fragq_hdl->ic_msg->channel = IC_CHANNEL_CTRL;
        else
            fragq_hdl->ic_msg->channel = IC_CHANNEL_DATA;

        sm_drv_pci_frag_rx(dev, frag, fragq_hdl, &callb_mask);

        while(fragq_drv_pspace(lp, CB_RX_DATAQ) > 0) {
            sm_drv_pci_add_rx_queue(dev, CB_RX_DATAQ);
        }
    }

    /* refer to 555114 sec. 2.3.2.3 Callback Rules */
    sm_drv_pci_ic_message_query(dev, &callb_mask);

    handle_sm_callback(dev, callb_mask);

    spin_unlock_bh(&lp->sm_lock);

    if( hif_lp->generate_update_interrupt )
    {
        int irq;

        hif_lp->generate_update_interrupt = 0;
        irq = DEV38XX_DEV_INT_UPDATE;

        /* In AP mode, the LMAC should never go to sleep */
        if(lp->sm_mode != SM_MODE_AP)
            irq |= DEV38XX_DEV_INT_SLEEP;

        sm_drv_pci_trigger_device(hif_lp, irq);
    }

    DEBUG(DBG_BH, "EXIT Bottom Halve\n");
}

void sm_drv_pci_interrupt(int irq, void *config, struct pt_regs *regs)
{
    uint32_t reg;
    struct net_device *dev = config;
    struct net_local *lp = dev->priv;
    void *device = lp->device_id;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    /* check whether there is any source of interrupt on the device */
    reg = readl(device + DEV38XX_INT_IDENT_REG);

    /* also check the contents of the Interrupt Enable Register, because this
     * will filter out interrupt sources from other devices on the same irq ! */
    reg &= readl(device + DEV38XX_INT_EN_REG);

    reg &= DEV38XX_INT_SOURCES;
    if (reg) {
        /* reset the request bits in the Identification register */
        writel(reg, device + DEV38XX_INT_ACK_REG);

        DEBUG(DBG_IRQ, "IRQ: ID 0x%p 0x%x \n", device, reg);

        if (reg & DEV38XX_INT_IDENT_UPDATE)
        {
#if(DEBUG_LEVEL != DBG_NONE)
            struct control_block *cb = ((struct pci_hif_local_data*)lp->hif_local_data)->control_block;
#endif

            /* Queue has been updated */
            DEBUG(DBG_IRQ, "IRQ: Update flag \n");

            DEBUG(DBG_IRQ,
                "CB drv Qs: [%i][%i][%i][%i]\n",
                le32_to_cpu(cb->driver_curr_frag[0]),
                le32_to_cpu(cb->driver_curr_frag[1]),
                le32_to_cpu(cb->driver_curr_frag[2]),
                le32_to_cpu(cb->driver_curr_frag[3])
                );

            DEBUG(DBG_IRQ,
                "CB dev Qs: [%i][%i][%i][%i]\n",
                le32_to_cpu(cb->device_curr_frag[0]),
                le32_to_cpu(cb->device_curr_frag[1]),
                le32_to_cpu(cb->device_curr_frag[2]),
                le32_to_cpu(cb->device_curr_frag[3])
                );

            /* flush the Control Block in the d-cache */
            pci_map_single( ((struct pci_hif_local_data*)lp->hif_local_data)->pci_device,
                            ((struct pci_hif_local_data*)lp->hif_local_data)->driver_mem_address,
                            sizeof(struct control_block), PCI_DMA_FROMDEVICE );
            /* First handle all tx-ed frames in the interrupt handler */
            /* It does not require any spinlock to do that. Then set  */
            /* the bottom halve handler to run to check for any       */
            /* received frames.                                       */
            sm_drv_pci_check_txed(dev);
            sm_drv_psm_fsm(dev, PSMEVENT_RUN_BH);
	    
	    /* unmap the Control Block memory */
	    pci_unmap_single( hif_lp->pci_device, hif_lp->device_host_address, 
	    	sizeof(struct control_block), PCI_DMA_FROMDEVICE );
        }

        if (reg & DEV38XX_INT_IDENT_INIT) {
            /* Device has been initialized */
            DEBUG(DBG_IRQ, "IRQ: Init flag, device initialized \n");

            sm_drv_pci_initialize(dev);

            /* Run the bottom halve to fill the queues and query the softmac */
            sm_drv_psm_fsm(dev, PSMEVENT_RUN_BH);
        }

#ifdef PCIUART
        if (reg & DEV38XX_DEV_INT_PCIUART_CTS) {
            DEBUG(DBG_IRQ, "IRQ: UARTPCI CTS\n");
            uartpci_cts(dev);
        }

        if (reg & DEV38XX_DEV_INT_PCIUART_DR) {
            DEBUG(DBG_IRQ, "IRQ: UARTPCI DR\n");
            uartpci_dr(dev);
        }
#endif
    }

    return;
}


int sm_drv_pci_config(struct pci_dev *pci_device, struct net_device *dev)
{
    void                        *mapped_address;
    void                        *driver_address;
    dma_addr_t                  device_address;
    struct net_local            *lp = dev->priv;
    struct control_block        *cb;
    struct pci_hif_local_data   *hif_lp = ((struct pci_hif_local_data*)lp->hif_local_data);

    /* remap the PCI device base address to accessable */
    mapped_address = ioremap(dev->base_addr, DEV38XX_PCI_MEM_SIZE);
    if (!mapped_address) {
        /* error in remapping the PCI device memory address range */
        printk("ERROR: PCI memory remapping failed \n");
        return -1;
    }
    /* save the start and end address of the PCI memory area */
    dev->mem_start = (unsigned long) mapped_address;
    dev->mem_end = (unsigned long) mapped_address + DEV38XX_PCI_MEM_SIZE;

    DEBUG(DBG_TRACE, "PCI Memory remapped to 0x%p \n", mapped_address);

    /* allocate a block of memory on the host for the control block */
    driver_address = pci_alloc_consistent(pci_device, DEV38XX_HOST_MEM_BLOCK,
                                          &device_address);
    if (!driver_address) {
        /* error allocating the bblock of PCI memory */
        printk("%s: Error: Could not allocate DMA accessable memory \n", driver_name);
        iounmap(mapped_address);
        return -1;
    }
    DEBUG(DBG_TRACE, "Device memory block at 0x%x \n", device_address);
    DEBUG(DBG_TRACE, "Driver memory block at 0x%p \n", driver_address);
    DEBUG(DBG_TRACE, "Memory size 0x%x bytes\n", DEV38XX_HOST_MEM_BLOCK);

    lp->next_module = root_sm_drv_device;
    root_sm_drv_device = dev;

    spin_lock_init(&hif_lp->cb_lock);

    /* assign the Control Block pointer to the allocated area */
    ((struct pci_hif_local_data*)lp->hif_local_data)->control_block = (struct control_block *) driver_address;
    cb = ((struct pci_hif_local_data*)lp->hif_local_data)->control_block;

    /* Init the task queue */
    lp->tqueue.sync = 0;
    lp->tqueue.routine = (void *)(void*)sm_drv_pci_bh;
    lp->tqueue.data = dev;

    /* save the device configurations in the device private configuration */
    hif_lp->remapped_device_base = mapped_address;
    hif_lp->device_host_address = device_address;
    hif_lp->driver_mem_address = driver_address;

#ifdef WDS_SUPPORT
    lp->wdsp = kmalloc(sizeof(struct wds_priv), GFP_KERNEL );
	if( !lp->wdsp )
	{
        printk("%s: Error: Could not allocate WDS device memory \n", driver_name);
		pci_free_consistent(pci_device, DEV38XX_HOST_MEM_BLOCK,
    		driver_address, device_address);
    	iounmap(mapped_address);
    	return -1;
	}
    memset(lp->wdsp, 0, sizeof(struct wds_priv));
#endif

	lp->sm_initdata = (struct s_sm_initdata *) kmalloc(sizeof(struct s_sm_initdata), GFP_KERNEL );
	if( !lp->sm_initdata )
	{
        printk("%s: Error: Could not allocate UMAC initdata memory \n", driver_name);
		pci_free_consistent(pci_device, DEV38XX_HOST_MEM_BLOCK,
    		driver_address, device_address);
    	iounmap(mapped_address);
    	return -1;
	}
	
    return 0;
#if 0
err_out:
    pci_free_consistent(pci_device, DEV38XX_HOST_MEM_BLOCK,
                driver_address, device_address);
    iounmap(mapped_address);
    return -1;
#endif
}

static void sm_drv_pci_interface_reset( void *device_base, dma_addr_t host_address )
{
    uint32_t reg;

    DEBUG(DBG_CALLS, "sm_drv_pci_interface_reset \n");

    /* load the address of the control block in the device */
    writel( host_address, device_base + DEV38XX_CTRL_BLK_BASE_REG);
    udelay(DEV38XX_WRITEIO_DELAY);

   /* set the reset bit in the Device Interrupt Register */
    writel(DEV38XX_DEV_INT_RESET, device_base + DEV38XX_DEV_INT_REG);
    udelay(DEV38XX_WRITEIO_DELAY);

    /* enable the interrupt for detecting initialization */
    reg = DEV38XX_INT_IDENT_INIT | DEV38XX_INT_IDENT_UPDATE |
        DEV38XX_INT_IDENT_SLEEP | DEV38XX_INT_IDENT_WAKEUP;

    writel(reg, device_base + DEV38XX_INT_EN_REG);
    udelay(DEV38XX_WRITEIO_DELAY);
}

int sm_drv_pci_upload_firmware(struct net_device *dev, int load_fw)
{
    uint32_t reg;
	int32_t rvalue;
    int ifp, bra_parsed=0;
    long bcount, length, upload_addr=0;
    mm_segment_t fs;
    static char buffer[DEV38XX_MEMORY_WINDOW_SIZE];
    char filename[256];
    struct net_local *lp = dev->priv;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    if (hif_lp->pci_dev_id == PCIDEVICE_PRISM3886) {
        strcpy(filename, PRISM3886_IMAGE_FILE);
        upload_addr = DEV38XX_DEV_FIRMWARE_ADDRESS;
    } else if (hif_lp->pci_dev_id == PCIDEVICE_PRISM3890) {
        strcpy(filename, PRISM3886_IMAGE_FILE);
        upload_addr = DEV38XX_DEV_FIRMWARE_ADDRESS;
    } else if (hif_lp->pci_dev_id == PCIDEVICE_PRISMffff) {
        strcpy(filename, PRISM3886_IMAGE_FILE);
        upload_addr = DEV38XX_DEV_FIRMWARE_ADDRESS;
    } else if (hif_lp->pci_dev_id == PCIDEVICE_PRISM3888) {
        strcpy(filename, PRISM3888_IMAGE_FILE);
        upload_addr = DEV3888_DEV_FIRMWARE_ADDRESS;
    } else {
        printk("%s: Unsupported device %d\n", driver_name, hif_lp->pci_dev_id);
        goto out;
    }

    DEBUG(DBG_CALLS, "sm_drv_pci_upload_firmware: file %s, load %d\n", filename, load_fw);

    /* clear the RAMBoot and the Reset bit */
    reg = readl(hif_lp->remapped_device_base + DEV38XX_CTRL_STAT_REG);
    reg &= ~DEV38XX_CTRL_STAT_RESET;
    reg &= ~DEV38XX_CTRL_STAT_RAMBOOT;
    writel(reg, hif_lp->remapped_device_base + DEV38XX_CTRL_STAT_REG);
    udelay(DEV38XX_WRITEIO_DELAY);

    /* set the Reset bit without reading the register ! */
    reg |= DEV38XX_CTRL_STAT_RESET;
    writel(reg, hif_lp->remapped_device_base + DEV38XX_CTRL_STAT_REG);
    udelay(DEV38XX_WRITEIO_DELAY);

    /* clear the Reset bit */
    reg &= ~DEV38XX_CTRL_STAT_RESET;
    writel(reg, hif_lp->remapped_device_base + DEV38XX_CTRL_STAT_REG);

    /* wait a while for the device to reboot */
    mdelay(50);

    /* We only need to reset the device, so don't upload the FW */
    if(!load_fw)
        goto out_noupload;

    /* prepare the Direct Memory Base register */
    reg = upload_addr;

    /* for file opening temporarily tell the kernel I am not a user for
     * memory management segment access */
    fs = get_fs();
    set_fs(KERNEL_DS);

    if (ifp = open( filename, O_RDONLY, 0 ), ifp < 0)
    {
        printk("ERROR: %s failed to open file %s\n", driver_name, filename);
        set_fs(fs);
        return -1;
    }

    /* enter a loop which reads data blocks from the file and writes them
     * to the Direct Memory Windows */
    do {
        /* set the cards base address for writting the data */
        writel(reg, hif_lp->remapped_device_base + DEV38XX_DIR_MEM_BASE_REG);
        length = 0;

        /* read a block of data until buffer is full or end of file */
        do {
            bcount = read(ifp, &buffer[length], sizeof(buffer) - length);
            length += bcount;
        } while ((length != DEV38XX_MEMORY_WINDOW_SIZE) && (bcount != 0));

        /* find LMAC description (first block must contain LMAC descriptor) */
        if( !bra_parsed ) {
			/* add offset 20 to point to the bra directly */ 
        	rvalue = prism_softmac_parse_bra( (uint8_t*)buffer+20, lp->sm_initdata );
			if( rvalue != SM_ENONE ) {
                printk("ERROR: %s: Error %d: firmware image does not contain LMAC description\n",
					driver_name, rvalue );
                close(ifp);
                set_fs(fs);
                return -1;
            }

            bra_parsed = 1;
        }

        /* write the data to the Direct Memory Window */
        memcpy_toio(hif_lp->remapped_device_base + DEV38XX_DIRECT_MEM_WIN, buffer, length);

        /* increment the write address */
        reg += DEV38XX_MEMORY_WINDOW_SIZE;
    } while (bcount != 0);

    close(ifp);
    set_fs(fs);

    /* now reset the device. Clear the Reset & ClkRun bit, set the RAMBoot bit */
    reg = readl(hif_lp->remapped_device_base + DEV38XX_CTRL_STAT_REG);
    reg &= ~DEV38XX_CTRL_STAT_CLKRUN;
    reg &= ~DEV38XX_CTRL_STAT_RESET;
    reg |= DEV38XX_CTRL_STAT_RAMBOOT;
    writel(reg, hif_lp->remapped_device_base + DEV38XX_CTRL_STAT_REG);
    udelay(DEV38XX_WRITEIO_DELAY);

    /* set the reset bit latches the host override and RAMBoot bits
     * into the device for operation when the reset bit is reset */
    reg |= DEV38XX_CTRL_STAT_RESET;
    writel(reg, hif_lp->remapped_device_base + DEV38XX_CTRL_STAT_REG);
    udelay(DEV38XX_WRITEIO_DELAY);

    /* clear the reset bit should start the whole circus */
    reg &= ~DEV38XX_CTRL_STAT_RESET;
    writel(reg, hif_lp->remapped_device_base + DEV38XX_CTRL_STAT_REG);
    udelay(DEV38XX_WRITEIO_DELAY);

out:
    /* now the last step is to reset the interface */
    sm_drv_pci_interface_reset( hif_lp->remapped_device_base, hif_lp->device_host_address );

out_noupload:
    return 0;
}

