/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, whether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 */


#ifndef _SM_DRV_PCI_H
#define _SM_DRV_PCI_H

/*
 * INCLUDES
 */
#include <linux/skbuff.h>
#include <linux/netdevice.h>
#include <linux/delay.h>
#include <asm/io.h>
#include "softmac2.h"
#include "smoid2.h"

/*
 * FUNCTION PROTOTYPES
 */
struct net_device *sm_drv_pci_probe(struct net_device *dev, long ioaddr, int irq);
void sm_drv_pci_interrupt(int irq, void *config, struct pt_regs *regs);
int sm_drv_pci_config(struct pci_dev *pci_device, struct net_device *dev);

/*
 * DEFINES
 */

/* PCI Device Identification */
#define PCIVENDOR_CONEXANT                      0x1260UL
#define PCIDEVICE_PRISM3886                     0x3886UL
#define PCIDEVICE_PRISMffff                     0xffffUL
#define PCIDEVICE_PRISM3888                     0x3888UL
#define PCIDEVICE_PRISM3890                     0x3890UL

/* Vendor Specific PCI Config Space registers */
#define PCI_TRDY_TIMEOUT                        0x40
#define PCI_RETRY_TIMEOUT                       0x41

// 38XX Host Interface Definitions
#define DEV38XX_PCI_MEM_SIZE                    0x02000
#define DEV38XX_MEMORY_WINDOW_SIZE              0x01000
#define DEV38XX_DEV_FIRMWARE_ADDRESS            0x20000
#define DEV3888_DEV_FIRMWARE_ADDRESS            0x80000
#define DEV38XX_WRITEIO_DELAY                   10              // in us
#define DEV38XX_RESET_DELAY                     50              // in ms
#define DEV38XX_WAIT_CYCLE                      10              // in 10ms
#define DEV38XX_MAX_WAIT_CYCLES                 10
#define DEV38XX_HOST_MEM_BLOCK                  sizeof(struct control_block)

// PCI Memory Area
#define DEV38XX_HARDWARE_REG                    0x0000
#define DEV38XX_CARDBUS_CIS                     0x0800
#define DEV38XX_DIRECT_MEM_WIN                  0x1000

// Hardware registers
#define DEV38XX_DEV_INT_REG                     0x0000
#define DEV38XX_INT_IDENT_REG                   0x0010
#define DEV38XX_INT_ACK_REG                     0x0014
#define DEV38XX_INT_EN_REG                      0x0018
#define DEV38XX_CTRL_BLK_BASE_REG               0x0020    /* This is actually GenPurpComReg1 */
#define DEV38XX_GP_COM_REG_2                    0x0024
#define DEV38XX_DIR_MEM_BASE_REG                0x0030
#define DEV38XX_CTRL_STAT_REG                   0x0078

// Device Interrupt register bits
#define DEV38XX_DEV_INT_RESET                   (1 << 0)
#define DEV38XX_DEV_INT_UPDATE                  (1 << 1)
#define DEV38XX_DEV_INT_WAKEUP                  (1 << 3)
#define DEV38XX_DEV_INT_SLEEP                   (1 << 4)
#define DEV38XX_DEV_INT_ABORT                   (1 << 5)
#define DEV38XX_DEV_INT_PCIUART_CTS             (1 << 14)
#define DEV38XX_DEV_INT_PCIUART_DR              (1 << 15)

// Interrupt Identification/Acknowledge/Enable register bits
#define DEV38XX_INT_IDENT_UPDATE                (1 << 1)
#define DEV38XX_INT_IDENT_INIT                  (1 << 2)
#define DEV38XX_INT_IDENT_WAKEUP                (1 << 3)
#define DEV38XX_INT_IDENT_SLEEP                 (1 << 4)
#define DEV38XX_INT_IDENT_PCIUART_CTS           (1 << 14)
#define DEV38XX_INT_IDENT_PCIUART_DR            (1 << 15)
#define DEV38XX_INT_SOURCES                     (DEV38XX_INT_IDENT_UPDATE | \
                                                 DEV38XX_INT_IDENT_INIT | \
                                                 DEV38XX_INT_IDENT_WAKEUP | \
                                                 DEV38XX_INT_IDENT_SLEEP | \
                                                 DEV38XX_INT_IDENT_PCIUART_CTS | \
                                                 DEV38XX_INT_IDENT_PCIUART_DR)

// Control/Status register bits
#define DEV38XX_CTRL_STAT_SLEEPMODE             (1 << 9)
#define DEV38XX_CTRL_STAT_CLKRUN                (1 << 23)
#define DEV38XX_CTRL_STAT_RESET                 (1 << 28)
#define DEV38XX_CTRL_STAT_RAMBOOT               (1 << 29)
#define DEV38XX_CTRL_STAT_STARTHALTED           (1 << 30)
#define DEV38XX_CTRL_STAT_HOST_OVERRIDE         (1 << 31)

/* Control Block definitions */
#define CB_QCOUNT                       4

#define CB_RX_DATAQ                     0
#define CB_TX_DATAQ                     1
#define CB_RX_CTRLQ                     2
#define CB_TX_CTRLQ                     3

/* Must be multiples of 2 ! */
#define CB_RX_DATA_QSIZE                8
#define CB_TX_DATA_QSIZE                32
#define CB_RX_CTRL_QSIZE                4
#define CB_TX_CTRL_QSIZE                4

/* Firmware Filename */
#define PRISM3886_IMAGE_FILE      "/etc/pcmcia/prism3886.arm"
#define PRISM3888_IMAGE_FILE      "/etc/pcmcia/prism3888.arm"

/*
 * Structure definitions
 */
struct fragment
{
    uint32_t host_address;              // physical address on host
    uint32_t lmac_address;              // physical address in lmac
    uint16_t size;                      // packet size
    uint16_t flags;                     // set of bit-wise flags
};

#define FRG_FLAG_MF        0x0001
#define FRG_FLAG_CONTROL   0x0002

struct control_block
{
    uint32_t driver_curr_frag[CB_QCOUNT];
    uint32_t device_curr_frag[CB_QCOUNT];
    struct fragment rx_data[CB_RX_DATA_QSIZE];
    struct fragment tx_data[CB_TX_DATA_QSIZE];
    struct fragment rx_control[CB_RX_CTRL_QSIZE];
    struct fragment tx_control[CB_TX_CTRL_QSIZE];
};

struct s_fragq_hdl {
    struct s_ic_msg *ic_msg;
    uint32_t ic_msg_flags;
    dma_addr_t       dma_handle;
};

struct local_control_block
{
    struct s_fragq_hdl rx_data_hdl[CB_RX_DATA_QSIZE];
    struct s_fragq_hdl tx_data_hdl[CB_TX_DATA_QSIZE];
    struct s_fragq_hdl rx_control_hdl[CB_RX_CTRL_QSIZE];
    struct s_fragq_hdl tx_control_hdl[CB_TX_CTRL_QSIZE];
};

struct pci_hif_local_data
{
    struct pci_dev              *pci_device;            /* PCI structure information */
    spinlock_t                   cb_lock;               /* Control Block lock */

    struct control_block        *control_block;         /* device control block */
    uint32_t                     fragment_c[CB_QCOUNT]; /* fragment consume index (CPU Endianness!) */
    struct local_control_block   local_cb_handle;       /* local handles for each queue in the control block */

/* TODO: Optimize to bitmask shared with device state */
    uint32_t                     generate_update_interrupt;

    void                        *remapped_device_base;  /* remapped device base */
    dma_addr_t                   device_host_address;   /* host memory address for */
    void                        *driver_mem_address;    /* memory address for the driver */

    uint8_t                      pci_irq;               /* PCI irq line */
    uint16_t                     pci_dev_id;            /* PCI device id */


};

static const uint32_t frag_queue_size[CB_QCOUNT] = {CB_RX_DATA_QSIZE,
                                         CB_TX_DATA_QSIZE,
                                         CB_RX_CTRL_QSIZE,
                                         CB_TX_CTRL_QSIZE };

/*
 *    Fragment Queue Operation
 *
 * fragment_c       driver_curr_frag
 * ->|                  |<---------
 *   | drv_cspace       | drv_pspace
 *   |<------>|         |
 *   V                  V
 * XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
 *            ^
 *            |<------->|
 *            | dev_entries
 *        device_curr_frag
 */

static inline void fragq_init(struct net_device *dev, int queue)
{
    struct net_local *lp = dev->priv;
    struct control_block *cb = ((struct pci_hif_local_data*)lp->hif_local_data)->control_block;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;
    unsigned long flags;

    spin_lock_irqsave(&hif_lp->cb_lock, flags);
    cb->driver_curr_frag[queue] = cpu_to_le32(0);
    cb->device_curr_frag[queue] = cpu_to_le32(0);
    hif_lp->fragment_c[queue] = cpu_to_le32(0);
    spin_unlock_irqrestore(&hif_lp->cb_lock, flags);
}

/* Returns the number of entries that are not yet handled by the device */
static inline int fragq_dev_entries(struct net_local *lp, int queue)
{
    struct control_block *cb = ((struct pci_hif_local_data*)lp->hif_local_data)->control_block;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    int ret;
    unsigned long flags;

    spin_lock_irqsave(&hif_lp->cb_lock, flags);
    ret = (int)(le32_to_cpu(cb->driver_curr_frag[queue]) -
                le32_to_cpu(cb->device_curr_frag[queue]));
    spin_unlock_irqrestore(&hif_lp->cb_lock, flags);

    return ret;
}

/* Returns the number of entries that can be consumed by the driver */
static inline int fragq_drv_cspace(struct net_local *lp, int queue)
{
    struct control_block *cb = ((struct pci_hif_local_data*)lp->hif_local_data)->control_block;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;
    int ret;
    unsigned long flags;

    spin_lock_irqsave(&hif_lp->cb_lock, flags);
    ret = (int)(le32_to_cpu(cb->device_curr_frag[queue]) -
                hif_lp->fragment_c[queue]);
    spin_unlock_irqrestore(&hif_lp->cb_lock, flags);

    return ret;
}

/* Returns the number of entries that can be produced by the driver */
static inline int fragq_drv_pspace(struct net_local *lp, int queue)
{
    struct control_block *cb = ((struct pci_hif_local_data*)lp->hif_local_data)->control_block;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;
    int ret;
    unsigned long flags;

    spin_lock_irqsave(&hif_lp->cb_lock, flags);
    ret = (int)(frag_queue_size[queue] -
                (le32_to_cpu(cb->driver_curr_frag[queue]) -
                 hif_lp->fragment_c[queue]));
    spin_unlock_irqrestore(&hif_lp->cb_lock, flags);

    return ret;
}

/* Tell the device the fragment queues are updated. */
static inline void sm_drv_pci_trigger_device(struct pci_hif_local_data *hif_lp, int event)
{
    writel(event, (hif_lp->remapped_device_base + DEV38XX_DEV_INT_REG));
}

/* Produce a fragment and associated handle on a queue */
static void fragq_produce(struct net_local *lp, int queue,
                          struct fragment *frag, struct s_fragq_hdl *fragq_hdl)
{
    struct control_block *cb = ((struct pci_hif_local_data*)lp->hif_local_data)->control_block;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    struct s_fragq_hdl *handlep;
    int index;
    unsigned long flags;

    spin_lock_irqsave(&hif_lp->cb_lock, flags);

    index = le32_to_cpu(cb->driver_curr_frag[queue]) & (frag_queue_size[queue] - 1);
    switch(queue) {
        case CB_RX_DATAQ:
            handlep = &(hif_lp->local_cb_handle.rx_data_hdl[index]);
            cb->rx_data[index].host_address = frag->host_address;
            cb->rx_data[index].lmac_address = frag->lmac_address;
            cb->rx_data[index].size = frag->size;
            cb->rx_data[index].flags = frag->flags;
            break;
        case CB_TX_DATAQ:
            handlep = &(hif_lp->local_cb_handle.tx_data_hdl[index]);
            cb->tx_data[index].host_address = frag->host_address;
            cb->tx_data[index].lmac_address = frag->lmac_address;
            cb->tx_data[index].size = frag->size;
            cb->tx_data[index].flags = frag->flags;
            break;
        case CB_RX_CTRLQ:
            handlep = &(hif_lp->local_cb_handle.rx_control_hdl[index]);
            cb->rx_control[index].host_address = frag->host_address;
            cb->rx_control[index].lmac_address = frag->lmac_address;
            cb->rx_control[index].size = frag->size;
            cb->rx_control[index].flags = frag->flags;
            break;
        case CB_TX_CTRLQ:
            handlep = &(hif_lp->local_cb_handle.tx_control_hdl[index]);
            cb->tx_control[index].host_address = frag->host_address;
            cb->tx_control[index].lmac_address = frag->lmac_address;
            cb->tx_control[index].size = frag->size;
            cb->tx_control[index].flags = frag->flags;
            break;
        default:
            printk(KERN_ERR "frag_produce: Illegal queue %d\n", queue);
            spin_unlock_irqrestore(&hif_lp->cb_lock, flags);
            return;
    }
    memcpy(handlep, fragq_hdl, sizeof(struct s_fragq_hdl));
    cb->driver_curr_frag[queue] = cpu_to_le32(le32_to_cpu(cb->driver_curr_frag[queue]) + 1);

    spin_unlock_irqrestore(&hif_lp->cb_lock, flags);
}

/* Consume a fragment and associated handle from a queue */
static struct fragment *fragq_consume(struct net_local *lp, int queue,
                                      struct s_fragq_hdl **handlep)
{
    struct control_block *cb = ((struct pci_hif_local_data*)lp->hif_local_data)->control_block;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;

    int index;
    unsigned long flags;
    struct fragment *frag = NULL;
    void *handle;

    spin_lock_irqsave(&hif_lp->cb_lock, flags);

    index = hif_lp->fragment_c[queue] & (frag_queue_size[queue] - 1);
    switch(queue) {
        case CB_RX_DATAQ:
            frag = &(cb->rx_data[index]);
            handle = &(hif_lp->local_cb_handle.rx_data_hdl[index]);
            break;
        case CB_TX_DATAQ:
            frag = &(cb->tx_data[index]);
            handle = &(hif_lp->local_cb_handle.tx_data_hdl[index]);
            break;
        case CB_RX_CTRLQ:
            frag = &(cb->rx_control[index]);
            handle = &(hif_lp->local_cb_handle.rx_control_hdl[index]);
            break;
        case CB_TX_CTRLQ:
            frag = &(cb->tx_control[index]);
            handle = &(hif_lp->local_cb_handle.tx_control_hdl[index]);
            break;
        default:
            printk(KERN_ERR "frag_consume: Illegal queue %d\n", queue);
            goto err_out;
    }
    if(handlep)
        *handlep = handle;

    (hif_lp->fragment_c[queue])++;

err_out:
    spin_unlock_irqrestore(&hif_lp->cb_lock, flags);
    return frag;
}

/* Peek at an offset from the driver consume pointer and return the
 * fragment and the associated handle
 */
static struct fragment *fragq_peek(struct net_local *lp, int queue,
                                          int offset, void **handle)
{
    struct control_block *cb = ((struct pci_hif_local_data*)lp->hif_local_data)->control_block;
    struct pci_hif_local_data *hif_lp = (struct pci_hif_local_data*)lp->hif_local_data;
    struct fragment *ret = NULL;
    int index;
    unsigned long flags;

    spin_lock_irqsave(&hif_lp->cb_lock, flags);
    index = (((struct pci_hif_local_data*)lp->hif_local_data)->fragment_c[queue] + offset) &
                        (frag_queue_size[queue] - 1);
    switch(queue) {
        case CB_RX_DATAQ:
            ret = &(cb->rx_data[index]);
            break;
        case CB_TX_DATAQ:
            ret = &(cb->tx_data[index]);
            break;
        case CB_RX_CTRLQ:
            ret = &(cb->rx_control[index]);
            break;
        case CB_TX_CTRLQ:
            ret = &(cb->tx_control[index]);
            break;
        default:
            printk(KERN_ERR "frag_peek: Illegal queue %d\n", queue);
            break;
    }
    spin_unlock_irqrestore(&hif_lp->cb_lock, flags);

    return ret;
}

#endif /* _SM_DRV_PCI_H */
