/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, whether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/proc_fs.h>
#include <asm/uaccess.h>

#include "sm_drv.h"

/* ioctl interface commands */
#define PROF_CMD_START  1
#define PROF_CMD_STOP   2

#define MAX_PROFFUNC    128
#define MAX_FUNCNAME    20

struct s_prof_info {
    struct timeval tmp_start;
    uint32_t       nrcalls;
    uint32_t       sum_duration;    /* usec */
    uint32_t       min_duration;
    uint32_t       max_duration;
    uint32_t       active;
    char           funcname[MAX_FUNCNAME];
};

static struct s_prof_info prof_info[MAX_PROFFUNC];      /* profiling info */
static uint32_t prof_duration = 0;      /* duration of current profile run */
static int prof_init = 0;       /* prof_init == 1 if profiler is running */

static int sm_drv_prof_proc_info(char *buffer, char **start, off_t offset, int length);

/*
 * driver_prof_register: register function for profiling
 *   handle:    SoftMAC handle
 *   name:              function name
 *   returns:   profiling ID assigned to the function
 */
int32_t driver_prof_register( uint32_t handle, uint8_t *name )
{
    int32_t i;

    for( i = 0; i < MAX_PROFFUNC; i++ )
    {
        if( !prof_info[i].active )
        {
            strncpy(prof_info[i].funcname, name, MAX_FUNCNAME);
            prof_info[i].funcname[MAX_FUNCNAME - 1] = '\0';
            prof_info[i].active = 1;
            return i;
        }
    }

    printk(KERN_WARNING "SoftMAC Profiler: Exceeded maximum number of functions (%d)\n", MAX_PROFFUNC);
    return -1;
}

/*
 * driver_prof_register: deregister function for profiling
 *   handle:    SoftMAC handle
 *   id:                profiling ID of function
 *   returns:   -
 */
void driver_prof_deregister( uint32_t handle, int32_t id )
{
    if( id >= 0 && id < MAX_PROFFUNC )
        prof_info[id].active = 0;
}

/*
 * driver_prof_reset: reset profiling statistics
 *   handle:    SoftMAC handle
 *   id:                profiling ID of the function that is profiled
 *   returns:   -
 */
void driver_prof_reset( uint32_t handle, int32_t id )
{
}

/*
 * driver_prof_dump: dumps all profiling statistics
 *   handle:    SoftMAC handle
 *   returns:   -
 */
void driver_prof_dump( uint32_t handle )
{
}

/*
 * driver_prof_enter: start profiling timer
 *   handle:    SoftMAC handle
 *   id:                profiling ID of the function that is profiled
 *   returns:   -
 */
void driver_prof_enter( uint32_t handle, int32_t id )
{
    if(!prof_init)
        return;

    do_gettimeofday(&(prof_info[id].tmp_start));
    prof_info[id].nrcalls++;
}

/*
 * driver_prof_exit: stop profiling timer
 *   handle:    SoftMAC handle
 *   id:                id of the function that is profiled
 *   returns:   duration of function
 */

uint32_t driver_prof_exit( uint32_t handle, int32_t id )
{
    struct timeval tv_stop;
    uint32_t duration;

    if(!prof_init)
        return 0;

    if(!prof_info[id].nrcalls)
        return 0;

    do_gettimeofday(&tv_stop);
    duration = (tv_stop.tv_sec - prof_info[id].tmp_start.tv_sec) * 1000000 +
               (tv_stop.tv_usec - prof_info[id].tmp_start.tv_usec);
    prof_info[id].sum_duration += duration;

        if(duration < prof_info[id].min_duration)
                prof_info[id].min_duration = duration;

        if(duration > prof_info[id].max_duration)
                prof_info[id].max_duration = duration;

        return duration;
}

static void prof_log_init(void)
{
    int i;
    struct timeval tv_log_init;

    for(i = 0; i < MAX_PROFFUNC; i++) {
        prof_info[i].nrcalls = 0;
        prof_info[i].sum_duration = 0;
        prof_info[i].min_duration = (uint32_t) -1;
        prof_info[i].max_duration = 0;
        memset(prof_info[i].funcname, 0, MAX_FUNCNAME);
    }

    do_gettimeofday(&tv_log_init);
    prof_duration = tv_log_init.tv_sec * 1000000 + tv_log_init.tv_usec;

    prof_init = 1;
}

static void prof_log_exit(void)
{
    struct timeval tv_log_exit;
    uint32_t new_duration;

    do_gettimeofday(&tv_log_exit);
    new_duration = (tv_log_exit.tv_sec * 1000000 + tv_log_exit.tv_usec) - prof_duration;
    prof_duration = new_duration;

    prof_init = 0;
}


static int sm_drv_prof_proc_info(char *buffer, char **start, off_t offset, int length)
{
    int len;
    off_t pos   = 0;
    off_t begin = 0;
    uint32_t sum = 0;
    int i;

    for(i = 0; i < MAX_PROFFUNC; i++) {
        if(!prof_info[i].active)
            continue;

        sum += prof_info[i].sum_duration;
    }

    if(prof_duration == 0 || sum == 0) {
        len = sprintf(buffer, "No UMAC profiling statistics available\n");
        return len;
    }

    if(prof_init == 0) {
        len = sprintf(buffer, "UMAC profiling statistics (Ready)\n");
        len += sprintf(buffer + len, "Duration total: %u us, UMAC: %u us\n",
                prof_duration, sum);
    } else {
        len = sprintf(buffer, "UMAC profiling statistics (Running)\n");
        len += sprintf(buffer + len, "Duration total: N.A. us, UMAC: %u us\n",
                sum);
    }

    len += sprintf(buffer + len, " ID         Function Name  Nr.Calls Time[us] Time/Call Min Time  Max Time\n");
    for(i = 0; i < MAX_PROFFUNC; i++) {
        if(!prof_info[i].active)
            continue;

        if(prof_info[i].nrcalls) {
            len += sprintf(buffer + len, "[%2d, %20s] %8u %8u %8u %8u %8u\n",
                    i, prof_info[i].funcname, prof_info[i].nrcalls, prof_info[i].sum_duration,
                    prof_info[i].sum_duration / prof_info[i].nrcalls,
                    prof_info[i].min_duration, prof_info[i].max_duration);
        } else {
            len += sprintf(buffer + len, "[%2d, %20s] %8u %8u %8u %8u %8u\n",
                    i, prof_info[i].funcname, prof_info[i].nrcalls, prof_info[i].sum_duration,
                    0, 0, 0);
        }

        pos = begin + len;

        if (pos < offset) {
            len = 0;
            begin = pos;
        }

        if (pos > offset+length) break;
    }

    *start = buffer + (offset - begin);
    len -= (offset - begin);

    if (len > length) len = length;

    return len;
}


int prof_ioctl(struct s_softmac_ioctl req)
{
    int prof_cmd;

    if (!access_ok(VERIFY_READ, req.data, req.len))
        return -EFAULT;

    prof_cmd = *(unsigned int *)req.data;

    switch(prof_cmd) {
        case PROF_CMD_START:
            prof_log_init();
            break;
        case PROF_CMD_STOP:
            prof_log_exit();
            break;
        default:
            printk("Invalid Profiler command %d\n", prof_cmd);
            return -EINVAL;
    }
    return 0;
}

void __init prof_init_module(void)
{
    proc_net_create("sm_drv_prof", 0, sm_drv_prof_proc_info);
}

void __exit prof_cleanup_module(void)
{
    proc_net_remove("sm_drv_prof");
}
