/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, whether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#ifndef _SM_DRV_PROF_H
#define _SM_DRV_PROF_H

#include "sm_drv.h"

extern void __init prof_init_module(void);
extern void __exit prof_cleanup_module(void);
extern int prof_ioctl(struct s_softmac_ioctl req);

#endif /* _SM_DRV_PROF_H */
