/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, whether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#define __KERNEL_SYSCALLS__

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/delay.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/pci.h>
#include <linux/string.h>
#include <linux/poll.h>
#include <asm/uaccess.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/arch/intctl.h> /* for uIRQ */
#include <asm/arch/hardware.h>
#include <pcmcia/driver_ops.h>

#include "sm_drv.h"
#include "sm_drv_shmem.h"
#include "sm_drv_shmem_pda.h"
#include "version_info.h"

#ifdef PCIUART
#include "sm_drv_uartpci.h"
#endif

#ifdef NETLINK_SUPPORT
#include "sm_drv_netlink.h"
#endif

#ifdef WDS_SUPPORT
#include "sm_drv_wds.h"
#endif

#ifdef VSSDEV_SUPPORT
#include "sm_drv_vss.h"
#endif

#ifdef CONFIG_8827_DEBUG
#include "sm_drv_8827.h"
#endif

#include <smlink.h>

#define DRIVER_NAME             "sm_drv_shmem"
#undef HAVE_SET_MAC_ADDR

extern struct net_device *root_sm_drv_device;
int nr_registered_irq = 0;
spinlock_t module_sm_lock;

char driver_name[64] = DRIVER_NAME;

extern unsigned int boot_mode;
extern unsigned int driver_debug;

/******************************************************************************
 *   General Driver Functions
 ******************************************************************************/
extern struct net_device *sm_drv_pci_probe(struct net_device *dev, long ioaddr, int irq);
extern int sm_drv_pci_config(struct pci_dev *pci_device, struct net_device *dev);
extern void sm_drv_pci_interrupt(int irq, void *config, struct pt_regs *regs);
extern int sm_drv_up(struct net_device *dev, uint8_t mode);
extern int sm_drv_mgt_indication( unsigned int dev_type, unsigned int dev_seq,
                          unsigned int src_id, unsigned int src_seq,
                          unsigned int op, unsigned int oid, void *data,
                          unsigned long len);

int sm_drv_shmem_probe_pci(struct pci_dev *pci_device, const struct pci_device_id *id);
void sm_drv_shmem_remove_pci( struct pci_dev * );


static int sm_drv_shmem_init(void);
static int sm_drv_shmem_open(struct net_device *dev);
static int sm_drv_shmem_close(struct net_device *dev);
static int sm_drv_shmem_transmit(struct sk_buff *skb, struct net_device *dev);
static void sm_drv_shmem_interrupt(int irq, void *dev_id, struct pt_regs *regs);
static void sm_drv_shmem_handle_requests(struct net_device *dev);
static void sm_drv_shmem_bh(struct net_device *dev);
__inline void sm_shmem_lmac_debug(void);
static void sm_drv_shmem_receive(struct net_device *dev, struct s_sm_frame *framep);
static void sm_drv_shmem_return(struct net_device *dev, struct s_sm_frame *framep);

/******************************************************************************
 *   Module initialization functions
 ******************************************************************************/
struct pci_device_id pci_id_table[] =
{
    {
        PCIVENDOR_CONEXANT, PCIDEVICE_3886,
        PCI_ANY_ID, PCI_ANY_ID, 0, 0,
        // Driver data, we just put the name here
        (unsigned long) "Conexant PRISM Xbow Wireless LAN adapter"
    },
    {
        PCIVENDOR_CONEXANT, 0x0FFFF,
        PCI_ANY_ID, PCI_ANY_ID, 0, 0,
        // Driver data, we just put the name here
        (unsigned long) "Conexant PRISM Xbow Wireless LAN adapter"
    },
    {
        0, 0, 0, 0, 0, 0, 0
    }
};

// register the device with the Hotplug facilities of the kernel
#ifdef MODULE
MODULE_DEVICE_TABLE( pci, pci_id_table );
#endif

struct pci_driver sm_drv_pci_drv_id =
{
    {},
    DRIVER_NAME,                // Driver name
    pci_id_table,               // id table
    sm_drv_shmem_probe_pci,           // probe function
    sm_drv_shmem_remove_pci,          // remove function
    NULL,                       // save_state function
    NULL,                       // suspend function
    NULL,                       // resume function
    NULL,                       // enable_wake function
};

int sm_drv_shmem_probe_pci(struct pci_dev *pci_device, const struct pci_device_id *id)
{
    printk("sm_drv_shmem_probe_pci:\n");
    return -1;
}

void sm_drv_shmem_remove_pci( struct pci_dev *pci_device )
{
    printk("sm_drv_shmem_remove_pci:\n");
}


/******************************************************************************
 *   Helper functions                                                         *
 ******************************************************************************/

/*
 * Returns a pointer to the human-readable hardware address of
 * the client. Buffer is static from function and overwritten
 * with each call
 */
char *hwaddr2string(unsigned char *a)
{
    static unsigned char buf[18];

    snprintf(buf, 18, "%2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x",
            a[0], a[1], a[2], a[3], a[4], a[5]);

    return(buf);
}

/******************************************************************************
    Module initialization functions
******************************************************************************/

int init_module( void )
{
    int ret = 0;

    DEBUG(DBG_ALL, "Loaded %s, version %s\n", DRIVER_NAME, VERSIONID);

    spin_lock_init(&module_sm_lock);
#ifdef PCIUART
    uartpci_init_module();
#endif

#ifdef NETLINK_SUPPORT
    mgt_initialize();
#endif

    if (pci_register_driver(&sm_drv_pci_drv_id) <= 0)
    {
        DEBUG(DBG_ALL, "%s: No PCI devices found, driver not installed.\n",
            DRIVER_NAME);
        pci_unregister_driver(&sm_drv_pci_drv_id);
    }

#ifdef CONFIG_8827_DEBUG
    dbg_8827_queue_init();
#endif

    if( (ret = sm_drv_shmem_init()) <= 0)
        printk(KERN_ALERT "No interconnect devices found!!!\n");
    else
    {
        printk(KERN_INFO "Added %d interconnect devices\n", ret);
    }

    return 0;
}

void sm_drv_shmem_lock(struct net_local *lp, unsigned long *flags)
{
    spin_lock_irqsave(&((struct shmem_hif_local_data*)lp->hif_local_data)->shmem_lock, *flags);
}

void sm_drv_shmem_unlock(struct net_local *lp, unsigned long *flags)
{
    spin_unlock_irqrestore(&((struct shmem_hif_local_data*)lp->hif_local_data)->shmem_lock, *flags);
}

static void sm_drv_trigger( struct net_device *dev )
{
    struct net_local *lp = dev->priv;
	int32_t callb_mask;

    callb_mask = prism_interconnect_trigger( lp->sm_context );

    if(callb_mask < 0) {
        printk(KERN_INFO "timer_expired: sm_service returned error %d\n", callb_mask);
    } else {
        handle_sm_callback(dev, callb_mask);
    }
}

/* init_probe: list of device types to init */
static int init_types[] =
{
    LMAC_DEVTYPE_LAN,
    LMAC_DEVTYPE_WLAN,
    LMAC_DEVTYPE_WAN,
    -1                  // must be last
};

static int sm_drv_shmem_init(void)
{
    const struct s_lmac_link *lm = *(const struct s_lmac_link **)0x14;
    struct net_device *dev, *temp = NULL;
    struct net_local  *lp  = NULL;
    struct shmem_hif_local_data *hif_lp;
    unsigned char *mac_address;
    int t, i, rvalue;
	struct s_sm_initdata sm_initdata;
    struct s_sm_descr sm_descr;				/* SoftMAC description */

    if (pda_get() < 0)
    {
        printk("Fatal error couldn't find PDA\n");
        return -1;
    }
    /*
     * So we now "probe" all exported devices in the lmac magic link structure.
     */
#ifdef DEBUG
    printk(KERN_INFO "===================================================================\n");
#endif
    if (lm == NULL)
    {
        /* not very useful..? */
        printk(KERN_ALERT "No Lmac link structure found!!!\n");
        return -ENODEV;
    }
#ifdef DEBUG
    printk(KERN_INFO "Located lm_link: %p lm_link->version: %x lm->devices: %d\n",
                      lm, lm->version, lm->devices);
    printk(KERN_INFO " lm->bra pointer: %p\n", lm->bra);
#endif

    if (lm->version != SM_LINK_VERSION)
    {
        printk(KERN_ALERT "Lmac link structure version (%d) doesn't match (%d) aborting.!!!\n", lm->version, SM_LINK_VERSION);
        return -ENODEV;
    }

    /* Since our system wants kind of static ethernet interface scheme
     * we try to create this.
     * eth0 - LAN
     * eth1 - WLAN
     * eth2 - WAN
     */

	/* bra pointer needs offset -20 for parsing the boot record area properly */
   	rvalue = prism_softmac_parse_bra( (const uint8_t*)lm->bra, &sm_initdata );
	if( rvalue != SM_ENONE ) {
        printk(KERN_ALERT "Lmac bra parse error (%d) aborting.!!!\n", rvalue );
        return -ENODEV;
	}

	if( prism_softmac_describe( &sm_descr, &sm_initdata ) != SM_ENONE ) {
		printk(KERN_ALERT "Fatal Error: LMAC - UMAC incomptability\n" );
		return -ENODEV;
	}

    for( t=0; init_types[t] != -1; t++ )
    {
        /* Lets probe all devices in a loop */
        for( i=0; i<lm->devices; i++ )
        {
            if( lm->dev[i].devtype != init_types[t] )
                continue;

            /*
             * Don't allocate the private data here, it is done later
             * This makes it easier to free the memory when this driver
             * is used as a module.
             */
            dev = init_etherdev(0,0);
            if (dev == NULL)
                return -ENOMEM;

            /* Build a list with all devices */
            if (root_sm_drv_device == NULL)
                root_sm_drv_device = dev;
            else
            {
                /* Lets find the last device in list to add this */
                temp = root_sm_drv_device;
                while(((struct net_local*)temp->priv)->next_module)
                {
                    temp = ((struct net_local*)temp->priv)->next_module;
                }
                ((struct net_local*)temp->priv)->next_module = dev;
            }


            /* We use the base_addr field for storing the device
             * number and device type for later reference.
             */
            dev->base_addr = lm->dev[i].devtype;

            /*
             * Used in Linux bridge to sent packets back on own port.
             * Use only when it's defined in linux/if.h header file.
             */
#ifdef IFF_802_11_WLAN
            if (dev->base_addr == LMAC_DEVTYPE_WLAN)
                dev->priv_flags |= IFF_802_11_WLAN;
#endif

#ifdef CONFIG_8827_DEBUG
            if (lm->dev[i].devtype == LMAC_DEVTYPE_LAN)
                dbg_8827_set_dev(dev);
#endif

            /* Initialize the device structure. */
            dev->priv = kmalloc(sizeof(struct net_local), GFP_KERNEL);
            if (dev->priv == NULL)
            {
                printk("ERROR: Could not allocate interface specific data\n");
                kfree(dev);
                return -ENOMEM;
            }

            memset(dev->priv, 0, sizeof(struct net_local));
            lp = (struct net_local *)dev->priv;

            /* add a private host interface spacific structure to the network device for private
             * hif definitions needed by the driver */
            lp->hif_local_data = kmalloc(sizeof(struct shmem_hif_local_data), GFP_KERNEL);
            if (lp->hif_local_data == NULL)
            {
                printk(KERN_ERR "ERROR: Could not allocate host interface specific data %lu\n", sizeof(struct shmem_hif_local_data));
                kfree(dev->priv);
                kfree(dev);
                return -ENOMEM;
            }
            hif_lp = (struct shmem_hif_local_data*)lp->hif_local_data;
            memset(hif_lp, 0, sizeof(struct shmem_hif_local_data));

#ifdef WDS_SUPPORT
            lp->wdsp = kmalloc(sizeof(struct wds_priv), GFP_KERNEL );
            if (lp->wdsp == NULL)
            {
                printk(KERN_ERR "ERROR: Could not allocate host interface specific data %lu\n", sizeof(struct wds_priv));
                kfree(hif_lp);
                kfree(dev->priv);
                kfree(dev);
                return -ENOMEM;
            }
            memset(lp->wdsp, 0, sizeof(struct wds_priv));
#endif

#ifdef VSSDEV_SUPPORT
            lp->vssdev = kmalloc(sizeof(struct vss_priv), GFP_KERNEL);

            if ( lp->vssdev == NULL)
            {
                printk(KERN_ERR "ERROR: Could not allocate host interface specific data for VSS %lu\n", sizeof(struct vss_priv));
#ifdef WDS_SUPPORT
                kfree(lp->wdsp);
#endif
                kfree(hif_lp);
                kfree(dev->priv);
                kfree(dev);
                return -ENOMEM;
            }
            memset(lp->vssdev, 0, sizeof(struct vss_priv));
#endif

            switch(lm->dev[i].devtype)
            {
            case LMAC_DEVTYPE_LAN:
            case LMAC_DEVTYPE_WAN: // notice fall through
#ifdef DEBUG
                printk(KERN_INFO "Found %s in lm_link->dev[%d] struct:\n",
                       ((lm->dev[i].devtype == LMAC_DEVTYPE_LAN) ? "LMAC_DEVTYPE_LAN" : "LMAC_DEVTYPE_WAN"), i);
                printk(KERN_INFO "rx handle: %p tx handle: %p\n",
                       (void *)lm->dev[i].rx,  (void *)lm->dev[i].tx);
#endif
                dev->open               = &sm_drv_shmem_open;
                dev->stop               = &sm_drv_shmem_close;
                dev->hard_start_xmit    = &sm_drv_shmem_transmit;
                dev->get_stats          = &sm_drv_statistics;
                dev->do_ioctl           = &sm_drv_ioctl;
#ifdef HAVE_TX_TIMEOUT
                dev->watchdog_timeo     = SM_DRV_TX_TIMEOUT;
                dev->tx_timeout         = &sm_drv_tx_timeout;
#endif
#ifdef HAVE_SET_MAC_ADDR
                dev->set_mac_address    = &sm_drv_shmem_set_mac_addr;
#endif

                hif_lp->request_handler = &sm_drv_shmem_handle_requests;

                mac_address = pda_get_mac_address();
                if (mac_address != NULL)
                {
                    memcpy(dev->dev_addr, mac_address, ETH_ALEN);
#ifdef DEBUG
                    printk(KERN_INFO "Macaddress = %s\n", hwaddr2string(mac_address));
#endif
                }

            break;
            case LMAC_DEVTYPE_WLAN:
#ifdef DEBUG
                printk(KERN_INFO "Found LMAC_DEVTYPE_WLAN in lm_link->dev[%d] struct:\n", i);
                printk(KERN_INFO "rx handle: %p tx handle: %p\n",
                            (void *)lm->dev[i].rx,  (void *)lm->dev[i].tx);
#endif

				/* allocate a memory area for initdata for the WLAN device only */
				lp->sm_initdata = (struct s_sm_initdata *) kmalloc(sizeof(struct s_sm_initdata), GFP_KERNEL );
				if( !lp->sm_initdata )
				{
	                printk(KERN_ERR "ERROR: Could not allocate host interface specific data %lu\n", sizeof(struct shmem_hif_local_data));
					kfree(lp->hif_local_data);
	                kfree(dev->priv);
	                kfree(dev);
	                return -ENOMEM;
				}
				
				/* copy the initdata to the device needed for UMAC instance creation in wlan_init() 
				 * when the WLAN device is opened 
				 */
	            memcpy(lp->sm_initdata, &sm_initdata, sizeof(struct s_sm_initdata));

                dev->open               = &sm_drv_shmem_open;
                dev->stop               = &sm_drv_close;
                dev->hard_start_xmit    = &sm_drv_transmit;
                dev->get_stats          = &sm_drv_statistics;
                dev->do_ioctl           = &sm_drv_ioctl;
#ifdef HAVE_TX_TIMEOUT
                dev->watchdog_timeo     = SM_DRV_TX_TIMEOUT;
                dev->tx_timeout         = &sm_drv_tx_timeout;
#endif

                hif_lp->request_handler = &sm_drv_trigger;

            break;
            default:
                printk(KERN_INFO "Unknown devtype: lm_link->dev[%d]: %d\n", i, lm->dev[i].devtype);
            break;
            }
            dev->irq = IRQ_SOFINT;
            spin_lock_init(&lp->sm_lock);

            spin_lock_init(&hif_lp->shmem_lock);
            init_waitqueue_head(&lp->conf_waitq);
            init_waitqueue_head(&lp->getresp_waitq);
            /* Init the task queue */
            lp->tqueue.sync = 0;
            lp->tqueue.routine = (void *)(void*)sm_drv_shmem_bh;
            lp->tqueue.data = dev;
            /* Init the timer */
            init_timer(&lp->softmac_timer);
            lp->softmac_timer.function = driver_timer_expired;
            lp->softmac_timer.data = (unsigned long)dev;
            lp->device_state = DEVSTATE_IDLE;
            hif_lp->dev_link = (struct s_device_link*)&lm->dev[i];
            /* Copy descriptor data */
            memcpy(&lp->sm_descr, &sm_descr, sizeof(struct s_sm_descr));
#ifdef DEBUG
            printk(KERN_INFO "===================================================================\n");
#endif
            /* Fill in the fields of the device structure with ethernet values. */
            ether_setup(dev);
#ifdef NETLINK_SUPPORT
            mgt_indication_handler ( DEV_NETWORK, dev->name, 0, sm_drv_mgt_indication );
#endif
        }
    }
    return t;
}

static int wlan_init( struct net_device *dev )
{
    struct net_local *lp = dev->priv;
    struct s_sm_setup setup;
    struct s_pda *pda;
    int32_t callb_mask;
    int i;

    spin_lock_bh(&lp->sm_lock);

    DEBUG(DBG_CALLS, "wlan_init\n");

    setup.mode = lp->sm_mode = boot_mode;
    setup.rx_align = 0;                 // FIXME: optimal RX alignment for Linux???
    setup.max_sta = DEV_MAX_STA;
    setup.max_bss = DEV_MAX_BSS;
    for( i = 0; i < 8; i++ )
        setup.depth[i] = 32;

    /* get the pda */
    pda = pda_load();

	/* allocate a memory region for the UMAC context */
	lp->sm_context = (uint32_t *) kmalloc( lp->sm_descr.context_size, GFP_ATOMIC );
	if( !lp->sm_context	)
	{
		printk(KERN_ALERT "Fatal Error: UMAC Context Memory could not be allocated\n" );
		return -1;
	}

    callb_mask = prism_softmac_create( lp->sm_context, &setup, pda, lp->sm_initdata);
    if(callb_mask < 0) {
        printk(KERN_ERR "%s: Fatal Error: could not create SoftMAC (%d)\n", driver_name, callb_mask);
        lp->sm_descr.mtu = 0;
    } else {
        sm_drv_psm_fsm(dev, PSMEVENT_BOOT);
        sm_drv_psm_fsm(dev, PSMEVENT_IFUP);
    }

	/* free the initdata memory region */
	kfree( lp->sm_initdata );

    spin_unlock_bh(&lp->sm_lock);
    return 0;
}

static int sm_drv_shmem_open(struct net_device *dev)
{
    int retval = 0;
    struct net_local *lp = dev->priv;
#ifdef WDS_SUPPORT
    struct wds_priv *wdsp = lp->wdsp;
#endif

    DEBUG(DBG_CALLS, "sm_drv_shmem_open for %s \n", dev->name);

    /* Nothing to do here, when IRQ are enabled queues will be filled automatic */

    /* Register IRQ. */
    /* When the root device has got it's IRQ field set to something */
    /* our modules has already activated the irq and we should not */
    /* request the same IRQ again */
    if (nr_registered_irq == 0)
    {
        retval = request_irq(dev->irq, &sm_drv_shmem_interrupt, SA_SHIRQ | SA_INTERRUPT,
                                 dev->name, dev);
        if (retval)
        {
            printk("%s: unable to get IRQ %d (retval=%d).\n",
                   dev->name, dev->irq, retval);
            //unregister_irq(dev);
            return -EBUSY;
        }
    }
    nr_registered_irq++;

    MOD_INC_USE_COUNT;

#ifdef WDS_SUPPORT
    open_wds_links(wdsp);
#endif

    if( dev->base_addr == LMAC_DEVTYPE_WLAN )
        retval = wlan_init( dev );
    else
    {
        /* Ethernet Devices */
        sm_drv_psm_fsm(dev, PSMEVENT_BOOT);

        /* Generate Soft irq to fill queues */
        uIRQ->Soft = IntCtlSoftGenerate;

        sm_drv_psm_fsm(dev, PSMEVENT_IFUP);
    }

    netif_start_queue(dev);

    return retval;
}

static int sm_drv_shmem_close(struct net_device *dev)
{
#ifdef WDS_SUPPORT
    struct net_local *lp = dev->priv;
    struct wds_priv *wdsp = lp->wdsp;
#endif

    DEBUG(DBG_CALLS, "sm_drv_shmem_close \n");

    sm_drv_psm_fsm(dev, PSMEVENT_IFDOWN);

#ifdef WDS_SUPPORT
    close_wds_links(wdsp);
#endif

    netif_stop_queue(dev);

    /* Dispatching the IRQ for the different devices is done
     * in the local net interrupt function,
     * so we free the IRQ only for the last device.
     */

    if (nr_registered_irq == 1)
        free_irq(dev->irq, dev);

    nr_registered_irq--;

    MOD_DEC_USE_COUNT;

    return 0;
}



static int sm_drv_shmem_transmit(struct sk_buff *skb, struct net_device *dev)
{
    struct s_sm_frame *framep;
    struct net_local *lp = dev->priv;
    struct shmem_hif_local_data *hif_lp = (struct shmem_hif_local_data*)lp->hif_local_data;
    int32_t ret_val;

    spin_lock_bh(&lp->sm_lock);

    DEBUG(DBG_CALLS, "sm_drv_shmem_transmit\n");

again:
    if(lp->queued_tx_frame) {
        framep = lp->queued_tx_frame;
    } else {
#ifdef WDS_SUPPORT
        framep = skb_to_frame(dev, skb, 0);
#else
        framep = skb_to_frame(dev, skb);
#endif
        if(!framep) {
            printk(KERN_ERR "sm_drv_shmem_transmit: Could not allocate frame for skb\n");
            dev_kfree_skb(skb);
            lp->stats.tx_errors++;
            goto out;
        }
    }
    ret_val = hif_lp->dev_link->tx((void**)&framep);

    if(ret_val < 0) {
        if(ret_val == SM_EOVERFLOW) {
            DEBUG(DBG_TRACE, "sm_drv_shmem_transmit: Overflow, stopping TX queue\n");

            /* We have to accept the packet, otherwise it gets lost. So we
             * temporarily store it and stop the queue. We retry this packet
             * once we have a sm_frame_tx_done
             */
            lp->queued_tx_frame = framep;
            netif_stop_queue(dev);
        } else {
            printk(KERN_WARNING "sm_drv_shmem_transmit: sm_frame_tx returned error %d\n", ret_val);

            /* a normal frame failed, increment the parents device error counter */
            lp->stats.tx_errors++;

            /* Free the frame and the sk_buff */
            frame_skb_free(dev, framep);
            if(lp->queued_tx_frame)
            {
                lp->queued_tx_frame = NULL;
            }
        }
        goto out;
    }

    dev->trans_start = jiffies;

    /* If we transmitted a queued frame, now try to transmit the current frame */
    if(lp->queued_tx_frame) {
        lp->queued_tx_frame = NULL;
        goto again;
    }

out:
    spin_unlock_bh(&lp->sm_lock);
    return 0;
}

static void sm_drv_shmem_interrupt(int irq, void *dev_id, struct pt_regs *regs)
{
    struct net_device *dev = dev_id;

    uIRQ->Soft = 0;         /* remove soft irq */

    sm_drv_psm_fsm(dev, PSMEVENT_RUN_BH);
}

static void sm_drv_shmem_bh(struct net_device *dev_unused)
{
    struct net_device *dev;     /* from our own linked list */
    struct net_local *lp;
    struct shmem_hif_local_data *hif_lp;

    /* Lock the SoftMAC to protect against re-entrancy */
    spin_lock_bh(&module_sm_lock);

    DEBUG(DBG_BH, "Enter Bottom Halve\n");

    /* Walk through our list of devices */
    for( dev=root_sm_drv_device; dev; dev=lp->next_module )
    {
        lp = dev->priv;

        /* Handle the requests of active/booting devices */
        if( lp->device_state == DEVSTATE_ACTIVE || lp->device_state == DEVSTATE_BOOTING )
        {
            hif_lp = (struct shmem_hif_local_data *)lp->hif_local_data;

            DEBUG(DBG_BH, "%s:  hif_lp->dev_link->requests : %08x\n", dev->name, hif_lp->dev_link->requests );

            /* Always do this once ! */
            do
            {
                hif_lp->request_handler( dev );
            } while( hif_lp->dev_link->requests );

        }
    }
    if (driver_debug & DBG_LMAC)
        sm_shmem_lmac_debug();

#ifdef CONFIG_8827_DEBUG
    dbg_8827_poll(0);
#endif

    DEBUG(DBG_BH, "Exit Bottom Halve\n");

    spin_unlock_bh(&module_sm_lock);
}

#define DEBUG_MESSAGE_SIZE      4       /* No. words in a message */

__inline void sm_shmem_lmac_debug(void)
{
    const struct s_lmac_link *lm = *(const struct s_lmac_link **)0x14;
    struct s_debug_buf *lm_debug = lm->debug.buf;
	uint32_t wrap = lm->debug.size - 1;
    static unsigned long last_produce = 0;

	while ( (last_produce & wrap) != lm_debug->p )
    {
        /* Sprintf the string and arguments */
        //sprintf( buffer, (const char *) lm_debug->q[last_produce],
        //        lm_debug->q[last_produce+1],
        //        lm_debug->q[last_produce+2],
        //        lm_debug->q[last_produce+3] );
        /* Write this to the console */
        //DEBUG(DBG_LMAC, "LMAC> %s", buffer);
        DEBUG(DBG_LMAC, (char *)lm_debug->q[last_produce], lm_debug->q[last_produce+1],
                        lm_debug->q[last_produce+2], lm_debug->q[last_produce+3] );

        /* Increment the pointer (format plus 3 args). */
       last_produce = (last_produce + DEBUG_MESSAGE_SIZE) & wrap;
    }

}

static void sm_drv_shmem_handle_requests( struct net_device *dev )
{
    struct net_local *lp = dev->priv;
    struct shmem_hif_local_data *hif_lp = (struct shmem_hif_local_data*)lp->hif_local_data;
    struct s_sm_frame *framep;
    int error = 0;

    DEBUG(DBG_BH, "%s: sm_drv_shmem_handle_requests\n", dev->name);


    if (hif_lp->dev_link->requests & LMAC_REQUEST_RX)
    {
        DEBUG(DBG_BH, "Handle LMAC_REQUEST_RX...");

        /* Since the rx handle supports adding a new
         * frame before returning the rx request we
         * can add a new frame for all rx requests.
         */
        framep = frame_skb_alloc(dev, lp->sm_descr.mtu, 2);
        if(!framep) {
            printk(KERN_ERR "%s: Cannot allocate frame for RX Queue\n", dev->name);
        }

        if( (error = hif_lp->dev_link->rx((void**)&framep)) != 0)
        {
            /* somehow the lmac couldn't add the frame lets request rx
             * w/o a new frame
             */
            if (framep != NULL && hif_lp->dev_link->requests & LMAC_REQUEST_RX)
            {
                /*
                 * This is kind of stange we tried to receive a frame but the
                 * frame to add couldn't be added in the queue.
                 * We try to receive the frame with out adding a new RX frame then.!!!
                 */
                DEBUG(DBG_BH, "%s: Failed to add a frame on LMAC_REQUEST_RX try rx w/o frame add!\n",
                        dev->name);
                frame_skb_free(dev, framep);
                framep = NULL;
                if( (error = hif_lp->dev_link->rx((void**)&framep)) != 0)
                {
                    printk(KERN_ERR "%s: Fake LMAC_REQUEST_RX !!!!\n", dev->name);
                }
            }
        }
        /* Frame received ? */
        if (framep)
            sm_drv_shmem_receive(dev, framep);
    }
    if (hif_lp->dev_link->requests & LMAC_REQUEST_ADD)
    {
        DEBUG(DBG_BH, "Handle LMAC_REQUEST_ADD...");

        framep = frame_skb_alloc(dev, lp->sm_descr.mtu, 2);
        if(!framep) {
            printk(KERN_ERR "%s: Cannot allocate frame for RX Queue 2\n", dev->name);
        }
        /* Add the frame */
        if( (error = hif_lp->dev_link->rx((void**)&framep)) != 0)
        {
            printk(KERN_ERR "%s: Frame add failed..retuned %d framep %p..\n", dev->name, error, framep);
            frame_skb_free(dev, framep);
            framep = NULL;
        }
        else
        {
            /* Did the device received a frame ? */
            if (framep != NULL)
                sm_drv_shmem_receive(dev, framep);
        }
    }
    if (hif_lp->dev_link->requests & LMAC_REQUEST_RETURN )
    {
        DEBUG(DBG_BH, "Handle LMAC_REQUEST_RETURN...");

        framep = NULL;
        hif_lp->dev_link->tx((void**)&framep);
        if (framep != NULL)
            sm_drv_shmem_return(dev, framep);
    }
    if (hif_lp->dev_link->requests & LMAC_REQUEST_DEBUG)
    {
        /* Whats up? */
    }
    if (hif_lp->dev_link->requests & LMAC_REQUEST_ABORT)
    {
        /* Reset the system critical error */
        printk(KERN_ERR "Device %s requested abort!\n", dev->name);

        //ERROR_RESET_NOW();
    }


}

#define MAX_TRAP_SIZE 32

static void sm_drv_shmem_receive(struct net_device *dev, struct s_sm_frame *framep)
{
    struct sk_buff *skb;
    struct net_local *lp = (struct net_local *) dev->priv;

    if (framep->flags & LM_ETH_FLAG_CONTROL)
    {
        static long mpdu[MAX_TRAP_SIZE];

        DEBUG(DBG_BH, "%s: Handle CONTROL frame...\n", dev->name);

        if (framep->flags & LM_ETH_FLAG_TRAP)
        {
#ifdef LINKSTATE_DEBUG
            int i;
#endif
            if(framep->length * 4 > MAX_TRAP_SIZE)
            {
                printk("sm_drv_shmem_receive: TRAP length too big!\n");
                frame_skb_free(dev, framep);
                return;
            }

            memcpy((char *)mpdu, framep->data, framep->length);

            if (mpdu[0] == LM_OID_ETHLINKSTATE)
            {
                if (mpdu[1] == 0)
                {
                    netif_carrier_off (dev);
                    printk(KERN_INFO "%s: Linkstate 0 Mbps, cable removed\n", dev->name);
                }
                else
                {
                    netif_carrier_on (dev);

                    if ( (mpdu[1] & ETH_LINKSTATE_100MBPS_MASK) == ETH_LINKSTATE_100MBPS_MASK )
                    {
                        if ( (mpdu[1] & ETH_LINKSTATE_FD_MASK) == ETH_LINKSTATE_FD_MASK )
                            printk(KERN_INFO "%s: Linkstate 100 Mbps Full Duplex\n", dev->name);
                        else
                            printk(KERN_INFO "%s: Linkstate 100 Mbps Half Duplex\n", dev->name);
                    }
                    else
                    {
                        if ( (mpdu[1] & ETH_LINKSTATE_FD_MASK) == ETH_LINKSTATE_FD_MASK )
                            printk(KERN_INFO "%s: Linkstate 10 Mbps Full Duplex\n", dev->name);
                        else
                            printk(KERN_INFO "%s: Linkstate 10 Mbps Half Duplex\n", dev->name);

                    }
                }
            }
            else
            {
                printk(KERN_WARNING "%s: Received unknown OID: 0x%08lx\n", dev->name, mpdu[0]);
            }

#ifdef LINKSTATE_DEBUG
            printk("%s: Received LMAC TRAP OID: %08lx\n", dev->name,  mpdu[0]);
            for(i = 0 ; i < framep->length ; i++ )
            {
                printk("%02x ", framep->data[i]);
            }
            printk("\n");
#endif
        }
        frame_skb_free(dev, framep);
    }
    /* Check if returned frame sizes are valid before put frames in the queue */
    else if (framep->length > 0 && framep->length < 1569)
    {
        DEBUG(DBG_BH, "%s: Handle DATA frame...", dev->name);

#ifdef CONFIG_8827_DEBUG

        if (dbg_8827_hdr_check(framep, dev) == 1)
        {
            frame_skb_free(dev, framep);
            return;
        }
#endif

        if( framep->flags & SM_FRAME_RXFAILED ) {
            lp->stats.rx_errors++;
        } else {
            dev->last_rx = jiffies;
            lp->stats.rx_packets++;
            lp->stats.rx_bytes += framep->length;
        }

        // get the skb from the frame
        skb = frame_to_skb( dev, framep );
        if( skb ) {
            skb->dev = dev;

            // set minimal skb parameters and deliver the network packet
            skb->protocol = eth_type_trans( skb, dev );
            skb->priority = -1;
//            skb->ip_summed = CHECKSUM_NONE;
            netif_rx( skb );
        }
    }
    else
    {
        printk(KERN_WARNING "%s: Handle DATA frame length invalid (%d)....\n", dev->name, framep->length);
        frame_skb_free(dev, framep);
        lp->stats.rx_dropped++;
    }
}

static void sm_drv_shmem_return(struct net_device *dev, struct s_sm_frame *framep)
{
    struct net_local *lp = (struct net_local *) dev->priv;

    lp->stats.tx_packets++;
    lp->stats.tx_bytes += framep->length;

    netif_wake_queue(dev);

    frame_skb_free(dev, framep);
}

