/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, w;hether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *;
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#define __KERNEL_SYSCALLS__

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/string.h>
#include <linux/usb.h>
#include <asm/uaccess.h>

#include "sm_drv.h"
#include "sm_drv_usb.h"
#include "version_info.h"

#ifdef NETLINK_SUPPORT
#include "sm_drv_netlink.h"
#endif

static void usb_rx_callback(struct urb *urb);
static void usb_tx_callback(struct urb *urb);
static int sm_drv_usb_upload_firmware(struct net_device *dev, int load_fw);
static inline void ep_rxdata_get_p(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_rxdata **rxdata);
static inline void ep_rxdata_get_c(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_rxdata **rxdata);
static inline void ep_rxdata_get_f(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_rxdata **rxdata);
static inline void ep_rx_produce(struct usb_hif_local_data *hif_lp, int endpoint);
static inline void ep_rx_consume(struct usb_hif_local_data *hif_lp, int endpoint);
static inline void ep_rx_free(struct usb_hif_local_data *hif_lp, int endpoint);
static inline int ep_rx_pspace(struct usb_hif_local_data *hif_lp, int endpoint);
static inline int ep_rx_cspace(struct usb_hif_local_data *hif_lp, int endpoint);
static inline int ep_rx_rspace(struct usb_hif_local_data *hif_lp, int endpoint);
static inline void ep_txdata_get_p(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_txdata **txdata);
static inline void ep_txdata_get_c(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_txdata **txdata);
static inline void ep_tx_produce(struct usb_hif_local_data *hif_lp, int endpoint);
static inline void ep_tx_consume(struct usb_hif_local_data *hif_lp, int endpoint);
static inline int ep_tx_pspace(struct usb_hif_local_data *hif_lp, int endpoint);
static inline int ep_tx_cspace(struct usb_hif_local_data *hif_lp, int endpoint);

#define DRIVER_NAME     "Prism SoftMAC USB"
char driver_name[64] = DRIVER_NAME;

#define HIF_LP(__lp)    ((struct usb_hif_local_data *)__lp->hif_local_data)


/******************************************************************************
 *   Support Functions
 ******************************************************************************/

/*
 * Add one packet for an IN endpoint.
 */
static void sm_drv_usb_add_rx_packet(struct net_device *dev, int endpoint)
{
    struct net_local *lp = dev->priv;
    struct usb_hif_local_data *hif_lp = HIF_LP(lp);
    struct s_ic_msg *ic_msg;
    struct s_sm_frame *frame;
    struct s_rxdata *rxdata;
    struct urb *recv_urb;

    frame = frame_skb_alloc(dev, lp->sm_descr.mtu, lp->sm_descr.rxoffset);
    if(!frame) {
        printk(KERN_ERR "Cannot allocate frame for RX IN endpoint %d\n", endpoint);
        return;
    }

    /* Our ic_msg is embedded in the frame */
    ic_msg = FRAME_ICMSG(frame);
    ic_msg->frame = frame;

    /* Get a pointer to rxdata at the produce pointer */
    ep_rxdata_get_p(hif_lp, endpoint, &rxdata);

    /* Setup receive URB on endpoint. If possible, we recycle URBs */
    recv_urb = rxdata->rx_urb;
    if(!recv_urb) {
        recv_urb = usb_alloc_urb(0);
        if(!recv_urb) {
            printk(KERN_ERR "Cannot allocate URB for RX IN endpoint %d\n", endpoint);
            frame_skb_free(dev, frame);
            return;
        }
        rxdata->rx_urb = recv_urb;
    }
    rxdata->ic_msg = ic_msg;

    FILL_BULK_URB(recv_urb, hif_lp->udev,
              usb_rcvbulkpipe(hif_lp->udev, endpoint),
              frame->data, frame->length,
              usb_rx_callback, hif_lp);

    if(usb_submit_urb(recv_urb) < 0) {
        printk(KERN_ERR "Cannot Submit URB for RX IN endpoint %d\n", endpoint);
        frame_skb_free(dev, frame);
    } else {
        ep_rx_produce(hif_lp, endpoint);
    }
}

/*
 * Cancel all pending RX packets
 */
static void sm_drv_usb_cancel_rx_packets(struct net_device *dev, int endpoint)
{
    struct net_local *lp = dev->priv;
    struct usb_hif_local_data *hif_lp = HIF_LP(lp);

    DEBUG(DBG_CALLS, "sm_drv_usb_cancel_rx_packets: endpoint %d\n", endpoint);

    while(ep_rx_cspace(hif_lp, endpoint) > 0) {
        struct s_rxdata *rxdata;

        ep_rxdata_get_c(hif_lp, endpoint, &rxdata);
        usb_unlink_urb(rxdata->rx_urb);
    }
}

/*
 * Free all RX URBs and associated frames
 */
static void sm_drv_usb_free_rx_packets(struct net_device *dev, int endpoint)
{
    struct net_local *lp = dev->priv;
    struct usb_hif_local_data *hif_lp = HIF_LP(lp);
    struct s_ep_rxinfo *ep_rxinfo;
    unsigned long flags;
    int i;

    DEBUG(DBG_CALLS, "sm_drv_usb_free_rx_packets: endpoint %d\n", endpoint);

    ep_rxinfo = &(hif_lp->ep_rxinfo[endpoint - 1]);

    spin_lock_irqsave(&hif_lp->lock, flags);
    ep_rxinfo->p = ep_rxinfo->c = ep_rxinfo->f = 0;

    /* Free up all URBs and associated ic_msg for this endpoint */
    for(i = 0; i < USB_MAX_RX_PACKETS; i++) {
        if(ep_rxinfo->rxdata[i].rx_urb) {
            usb_free_urb(ep_rxinfo->rxdata[i].rx_urb);
            ep_rxinfo->rxdata[i].rx_urb = NULL;

            if(ep_rxinfo->rxdata[i].ic_msg) {
                frame_skb_free(dev, ep_rxinfo->rxdata[i].ic_msg->frame);
                ep_rxinfo->rxdata[i].ic_msg = NULL;
            }
        }
    }
    spin_unlock_irqrestore(&hif_lp->lock, flags);
}

/*
 * Allocate a TX descriptor and TX URB
 */
static int sm_drv_usb_alloc_tx_urb(struct s_txdata *txdata)
{
    struct urb *tx_descr_urb;
    struct urb *tx_urb;

    tx_descr_urb = usb_alloc_urb(0);
    if(!tx_descr_urb) {
        return -1;
    }
    tx_descr_urb->transfer_buffer = kmalloc(sizeof(uint32_t), GFP_ATOMIC);
    if(!tx_descr_urb->transfer_buffer) {
        usb_free_urb(tx_descr_urb);
        return -1;
    }

    tx_urb = usb_alloc_urb(0);
    if(!tx_urb) {
        kfree(tx_descr_urb->transfer_buffer);
        usb_free_urb(tx_descr_urb);
        return -1;
    }

    txdata->tx_descr_urb = tx_descr_urb;
    txdata->tx_urb = tx_urb;

    return 0;
}

/*
 * Cancel all pending TX packets
 */
static void sm_drv_usb_cancel_tx_packets(struct net_device *dev, int endpoint)
{
    struct net_local *lp = dev->priv;
    struct usb_hif_local_data *hif_lp = HIF_LP(lp);
    struct s_ep_txinfo *ep_txinfo;
    unsigned long flags;
    int i;

    DEBUG(DBG_CALLS, "sm_drv_usb_cancel_tx_packets: endpoint %d\n", endpoint);

    spin_lock_irqsave(&hif_lp->lock, flags);

    /* First unlink all active URBs and free associated frame/skb */
    while(ep_tx_cspace(hif_lp, endpoint) > 0) {
        struct s_txdata *txdata;

        ep_txdata_get_c(hif_lp, endpoint, &txdata);
        usb_unlink_urb(txdata->tx_descr_urb);
        usb_unlink_urb(txdata->tx_urb);

        if (txdata->ic_msg_flags & IC_FLAG_FREE) {
            if (txdata->ic_msg->frame)
                driver_frame_free((uint32_t)dev, txdata->ic_msg->frame);
            else
                driver_free((uint32_t)dev, txdata->ic_msg);
        }
    }

    /* Then free all TX and TX descriptor URBs */
    ep_txinfo = &(hif_lp->ep_txinfo[endpoint - 1]);
    ep_txinfo->p = ep_txinfo->c = ep_txinfo->f = 0;
    for(i = 0; i < USB_MAX_RX_PACKETS; i++) {
        if(ep_txinfo->txdata[i].tx_descr_urb) {
            usb_free_urb(ep_txinfo->txdata[i].tx_descr_urb);
            ep_txinfo->txdata[i].tx_descr_urb = NULL;
        }
        if(ep_txinfo->txdata[i].tx_urb) {
            usb_free_urb(ep_txinfo->txdata[i].tx_urb);
            ep_txinfo->txdata[i].tx_urb = NULL;
        }
    }

    spin_unlock_irqrestore(&hif_lp->lock, flags);
}

/******************************************************************************
 *   USB Interconnect Handling (Bottom halve and helpers)
 ******************************************************************************/

/* Callback functions are called in Interrupt context */
static void usb_rx_callback(struct urb *urb)
{
    struct usb_hif_local_data *hif_lp = (struct usb_hif_local_data *)urb->context;

    /* increment consume and trigger bottom halve */
    ep_rx_consume(hif_lp, usb_pipeendpoint(urb->pipe));

    sm_drv_psm_fsm(hif_lp->netdev, PSMEVENT_RUN_BH);
}

static void usb_tx_callback(struct urb *urb)
{
    struct usb_hif_local_data *hif_lp = (struct usb_hif_local_data *)urb->context;
    struct s_txdata *txdata;
    int endpoint = usb_pipeendpoint(urb->pipe);

    /* Free the ic_msg and if needed the associated frame
     * The ic_msg is only valid when the IC_FLAG_FREE flag was not set
     * on the original ic_msg. Otherwise, it may be freed already by the UMAC
     * and we must not touch it
     */
    ep_txdata_get_c(hif_lp, endpoint, &txdata);

    if (txdata->ic_msg_flags & IC_FLAG_FREE) {
        if (txdata->ic_msg->frame)
            driver_frame_free((uint32_t)hif_lp->netdev, txdata->ic_msg->frame);
        else
            driver_free((uint32_t)hif_lp->netdev, txdata->ic_msg);
    }

    /* increment consume and trigger bottom halve */
    ep_tx_consume(hif_lp, endpoint);

    sm_drv_psm_fsm(hif_lp->netdev, PSMEVENT_RUN_BH);
}


static void sm_drv_usb_bh(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    struct usb_hif_local_data *hif_lp = HIF_LP(lp);
    int32_t callb_mask = SM_IC;
    int ep;

    /* This must be done outside the spin lock */
    if (lp->sm_descr.mtu == 0) {
        DEBUG(DBG_BH, "Bottom Halve: SoftMAC not initialized\n");
        sm_drv_down(dev);
        return;
    }

    DEBUG(DBG_BH, "Running Bottom Halve\n");

    /* Get the SoftMAC spinlock */
    spin_lock_bh(&lp->sm_lock);

    /*
     * check all RX endpoints in priority order
     *
     * [X]-[X]-[X]-[E]-[E]-[E]
     *  f           c
     *  p
     * f: points to next frame to pass to UMAC
     * c: points to next frame that will be filled with RX packet
     * p: points to next frame to fill with new empty packet
     */
    for(ep = 3; ep > 0; ep--) {

check_rx_again:
        /* Check if we received any frames from the LMAC */
        if(ep_rx_rspace(hif_lp, ep) > 0) {
            struct s_rxdata *rxdata;
            struct s_ic_msg *ic_msg;

            DEBUG(DBG_BH, "Received frame from endpoint %d\n", ep);

            ep_rxdata_get_f(hif_lp, ep, &rxdata);

            ic_msg = rxdata->ic_msg;
            rxdata->ic_msg = NULL;

            if(ep > 1)
                ic_msg->channel = IC_CHANNEL_CTRL;
            else
                ic_msg->channel = IC_CHANNEL_DATA;

            ic_msg->address = 0;    // Not used
            ic_msg->data    = ic_msg->frame->data;
            ic_msg->length  = rxdata->rx_urb->actual_length;
            ic_msg->flags   = 0;

            ep_rx_free(hif_lp, ep);

            DEBUG(DBG_IC, "ic_message_handle(%d, %x, %d, %x, %p)\n",
                  ic_msg->channel, ic_msg->flags, ic_msg->length,
                  ic_msg->address, ic_msg->data);

            callb_mask = ic_message_handle((uint32_t)dev, ic_msg);

            if(callb_mask < 0) {
                printk(KERN_WARNING "ic_message_handle returned error %d\n", callb_mask);
            }

            goto check_rx_again;
        }

        /* Add empty packets to the queue */
        while(ep_rx_pspace(hif_lp, ep) > 0) {
            sm_drv_usb_add_rx_packet(dev, ep);
        }
    }

again:
    /* See if the UMAC has ic messages pending for us to send */
    if(callb_mask & SM_IC) {
        int endpoint, ret;
        struct s_ic_msg *ic_msg;
        uint32_t ic_mask;
        uint32_t lmac_addr;
        uint32_t pipe;

        ic_mask = 0;
        if( ep_tx_pspace(hif_lp, 1) > 0)
            ic_mask |= IC_MASK_FRAME;
        if( ep_tx_pspace(hif_lp, 2) > 0)
            ic_mask |= IC_MASK_CTRL;

        if(ic_mask)
        {
            struct s_txdata *txdata;

            callb_mask = ic_message_query((uint32_t)dev, ic_mask, &ic_msg);
            if(!ic_msg)
                goto no_ic_msg;

            DEBUG(DBG_IC, "ic_message_query(%d, %x, %d, %x, %p)\n",
               ic_msg->channel, ic_msg->flags, ic_msg->length, ic_msg->address, ic_msg->data );

            /* Endpoint 2 is used for high priority messages */
    #if 0
            if(ic_msg->channel == IC_CHANNEL_CTRL) {
                endpoint = 2;
            } else {
                endpoint = 1;
            }
    #else
            /* During bring-up, only use endpoint 1 */
            endpoint = 1;
    #endif

            ep_txdata_get_p(hif_lp, endpoint, &txdata);

            /* We save the ic_msg flags here because we need to know if we
             * can free the ic_msg after the LMAC has received it (check on
             * IC_FLAG_FREE in sm_drv_pci_frag_rx).
             * It can happen that the frame/ic_msg is freed by the UMAC
             * before we can examine the ic_msg->flags in "sm_drv_pci_frag_rx".
             */
            txdata->ic_msg_flags = ic_msg->flags;
            txdata->ic_msg = ic_msg;

            /*
             * For transferring an ic_msg, we have to send a tx_descriptor
             * packet containing the LMAC address followed by a packet with the
             * actual data.
             * The URBs are not freed after the associated packet is transmitted
             * so we can reuse them.
             */
            if(!txdata->tx_descr_urb) {
                if(sm_drv_usb_alloc_tx_urb(txdata) < 0) {
                    printk(KERN_ERR "Cannot allocate TX URB\n");
                    goto no_ic_msg;
                }
            }

            lmac_addr = cpu_to_le32(ic_msg->address);
            memcpy(txdata->tx_descr_urb->transfer_buffer, &lmac_addr, sizeof(lmac_addr));

            pipe = usb_sndbulkpipe(hif_lp->udev, endpoint);

            /* Transfer TX descriptor. The descriptor has no callback,
             * it is handled in the callback handler of the actual TX packet */
            FILL_BULK_URB(txdata->tx_descr_urb, hif_lp->udev, pipe,
                      txdata->tx_descr_urb->transfer_buffer, sizeof(lmac_addr),
                      NULL, NULL);

            ret = usb_submit_urb(txdata->tx_descr_urb);
            if(ret < 0) {
                printk(KERN_ERR "Failed to submit tx_descr_urb %d\n", endpoint);
                goto no_ic_msg;
            }

            /* Transfer TX packet */
            FILL_BULK_URB(txdata->tx_urb, hif_lp->udev,
                      pipe,
                      ic_msg->data, ic_msg->length,
                      usb_tx_callback, hif_lp);

            ret = usb_submit_urb(txdata->tx_urb);
            if(ret < 0) {
                printk(KERN_ERR "Failed to submit tx_urb %d\n", endpoint);
                usb_unlink_urb(txdata->tx_descr_urb);
                goto no_ic_msg;
            }
            ep_tx_produce(hif_lp, endpoint);

            goto again;
        }
    }
no_ic_msg:

    handle_sm_callback(dev, callb_mask);

    spin_unlock_bh(&lp->sm_lock);

    DEBUG(DBG_BH, "EXIT Bottom Halve\n");
}

/******************************************************************************
 *   Initialization and Firmware Upload
 ******************************************************************************/

/*
 * Initialization Call stack:
 *   sm_drv_usb_probe
 *     sm_drv_up (in sm_drv.c)
 *       sm_drv_usb_up
 *         sm_drv_usb_upload_firmware
 *
 * The "sm_drv_usb_upload_firmware" functions sends the firmware file to the
 * device and then returns. Note that the firmware is not started at that time.
 * We first have to wait for the "OK" to come back from the device and then
 * actually start the firmware with the "g" command.
 * Both checking on "OK" and sending the "g" command is done in the
 * "upload_callback" function. After the "g" command is sent, the
 * "sm_drv_usb_initialize" function is called.
 *
 *   upload_callback
 *     if "OK" then send "g" command
 *   upload_callback
 *     sm_drv_usb_initialize
 */

int sm_drv_usb_up(struct net_device *dev)
{
    if (sm_drv_usb_upload_firmware(dev, 1) < 0) {
        printk("ERROR: failed to upload the firmware \n");
        return -1;
    }

    return 0;
}

int sm_drv_usb_down(struct net_device *dev)
{
    int endpoint;

    /* Cancel and Free RX packets for endpoint 1, 2 and 3 */
    for(endpoint = 1; endpoint <= 3; endpoint++) {
        sm_drv_usb_cancel_rx_packets(dev, endpoint);
        sm_drv_usb_free_rx_packets(dev, endpoint);
    }

    /* Cancel and Free TX packets for endpoint 1 and 2 */
    for(endpoint = 1; endpoint <= 2; endpoint++) {
        sm_drv_usb_cancel_tx_packets(dev, endpoint);
    }

    return 0;
}

void sm_drv_usb_cli(struct net_device *dev)
{
    /* Nothing to do. Change so this can be NULL pointer */
}

static void sm_drv_usb_initialize(struct net_device *dev)
{
    struct net_local *lp = dev->priv;
    struct s_sm_setup setup;
    struct s_sm_descr *sm_descr;
    int32_t callb_mask;
    int i, endpoint;

    spin_lock_bh(&lp->sm_lock);

    DEBUG(DBG_CALLS, "sm_drv_usb_initialize\n");

    sm_descr = sm_describe(&lp->lm_descr);

    /* make local copy of sm_descriptor. */
    memcpy( &lp->sm_descr, sm_descr, sizeof( *sm_descr ) );

    setup.mode = lp->sm_mode;
    setup.rx_align = 0;
    setup.max_sta = DEV_MAX_STA;
    setup.max_bss = DEV_MAX_BSS;
    for(i = 0; i < 8; i++)
        setup.depth[i] = 8;

    /* Our dev pointer is the SoftMAC handle */
    callb_mask = sm_create((uint32_t)dev, &setup, &lp->lm_descr, NULL);

    if(callb_mask < 0) {
        printk(KERN_ERR "Fatal Error: could not create SoftMAC (%d)\n", callb_mask);
        lp->sm_descr.mtu = 0;
    } else {
        sm_drv_psm_fsm(dev, PSMEVENT_BOOT);
    }

    /* Setup RX packets for endpoint 1, 2 and 3 */
    for(endpoint = 1; endpoint <= 3; endpoint++) {
        struct usb_hif_local_data *hif_lp = HIF_LP(lp);

        while(ep_rx_pspace(hif_lp, endpoint) > 0) {
            sm_drv_usb_add_rx_packet(dev, endpoint);
        }
    }

    /* Run the bottom halve to get everything started */
    sm_drv_psm_fsm(dev, PSMEVENT_RUN_BH);

    spin_unlock_bh(&lp->sm_lock);
}


void upload_callback(struct urb *urb)
{
    struct net_device *dev = (struct net_device *)urb->context;
    struct net_local *lp = dev->priv;
    struct usb_hif_local_data *hif_lp = HIF_LP(lp);
    int ret;

    if(hif_lp->upload_state == UPLOAD_STATE_UPLOADING) {
        char *buffer = urb->transfer_buffer;

        /* Check if upload was successful */
        if(!strncmp(buffer, "ERROR", 5)) {
            hif_lp->upload_state = UPLOAD_STATE_IDLE;
            printk(KERN_ERR "FW Upload not successful: (%s)\n", buffer);
            kfree(buffer);
            usb_free_urb(urb);
        } else if(!strncmp(buffer, "OK", 2)) {
            int chars;
            hif_lp->upload_state = UPLOAD_STATE_STARTING_FW;

            /* Send "g [addr]" command to start the firmware
             * NOTE: don't use \n to terminate command
             */
            chars = sprintf(buffer, "g %x\r", FIRMWARE_ADDRESS_3887);

            /* We reuse the URB in which we received the response */
            FILL_BULK_URB(urb, hif_lp->udev,
                      usb_sndbulkpipe(hif_lp->udev, 1),
                      buffer, chars,
                      upload_callback, dev);

            ret = usb_submit_urb(urb);
            if(ret < 0) {
                printk(KERN_ERR "Failed to submit URB for FW start %d\n", ret);
            }
        } else {
            printk("FW Upload: Received %s\n", buffer);

            /* We resubmit the URB for the next chars from the bootrom */
            FILL_BULK_URB(urb, hif_lp->udev,
                      usb_rcvbulkpipe(hif_lp->udev, 1),
                      urb->transfer_buffer, hif_lp->ep1_max_packet_size,
                      upload_callback, dev);

            ret = usb_submit_urb(urb);
            if(ret < 0) {
                printk(KERN_WARNING "Failed to submit urb for FW upload %d\n", ret);
            }
        }

    } else if (hif_lp->upload_state == UPLOAD_STATE_STARTING_FW) {
        kfree(urb->transfer_buffer);
        usb_free_urb(urb);
        sm_drv_usb_initialize(dev);
        hif_lp->upload_state = UPLOAD_STATE_RUNNING;
    } else {
        printk(KERN_WARNING "upload_callback in unexpected state %d, %s\n",
               hif_lp->upload_state, (char *)urb->transfer_buffer);
    }
}

char *get_lmac_descr(struct usb_hif_local_data *hif_lp, char *buffer)
{
    char *src, *dst, *ret;
    int i;

    src = buffer;
    ret = dst = kmalloc(hif_lp->ep1_max_packet_size, GFP_KERNEL);

    for(i = 0; i < hif_lp->ep1_max_packet_size; i++) {
        if(*src != 0x7D) {
            *dst++ = *src++;
        } else {
            src++;
            *dst++ = (*src++)^0x20;
        }
    }

    return ret;
}


/*
 * Upload the firmware. Note that we currently only support firmware files
 * in the .x2 format.
 */
static int sm_drv_usb_upload_firmware(struct net_device *dev, int load_fw)
{
    struct net_local *lp = dev->priv;
    struct usb_hif_local_data *hif_lp = HIF_LP(lp);
    struct urb *read_urb;
    struct s_lm_descr *lm_descr = NULL;
    int ifp, ret = -1;
    int actual_length;
    unsigned long bcount;
    unsigned int pipe;
    mm_segment_t fs;
    char filename[256];
    char *buffer;
    void *read_buffer;

    if (hif_lp->udev->descriptor.idProduct == USBPROD_ID_3887) {
        strcpy(filename, FIRMWARE_FILE_3887);
    } else {
        printk("Unsupported device %d\n", hif_lp->udev->descriptor.idProduct);
        return -1;
    }

    DEBUG(DBG_CALLS, "sm_drv_usb_upload_firmware: file %s, load %d\n", filename, load_fw);

    /* for file opening temporarily tell the kernel I am not a user for
     * memory management segment access */
    fs = get_fs();
    set_fs(KERNEL_DS);

    if (ifp = open( filename, O_RDONLY, 0 ), ifp < 0) {
        printk(KERN_ERR "failed to open file %s\n", filename);
        set_fs(fs);
        return -1;
    }

    /* Determine the maximum packet size we can send over endpoint 1 */
    pipe = usb_sndbulkpipe(hif_lp->udev, 1);
    hif_lp->ep1_max_packet_size = usb_maxpacket (hif_lp->udev, pipe, usb_pipeout(pipe));

    /* We assume kmalloc gives us an aligned buffer! */
    buffer = kmalloc(hif_lp->ep1_max_packet_size, GFP_KERNEL);
    if(!buffer) {
        printk(KERN_WARNING "Failed to allocate buffer for FW upload\n");
        return -1;
    }

    /* 1. Reset device by sending a 0x7E character */
    ret = usb_bulk_msg(hif_lp->udev, pipe,
                       "\x7e", 1, &actual_length, USB_TIMEOUT);
    if(ret < 0) {
        printk(KERN_WARNING "Failed to reset device for FW upload %d\n", ret);
        goto out_cleanup_buffer;
    }

    /* We only need to reset the device, so don't upload the FW */
    if(!load_fw)
        goto out_cleanup_buffer;

    /* Setup read URB on endpoint 1 to receive "OK" string after firmware upload */
    hif_lp->upload_state = UPLOAD_STATE_UPLOADING;

    read_urb = usb_alloc_urb(0);
    read_buffer = kmalloc(hif_lp->ep1_max_packet_size, GFP_KERNEL);

    FILL_BULK_URB(read_urb, hif_lp->udev,
              usb_rcvbulkpipe(hif_lp->udev, 1),
              read_buffer, hif_lp->ep1_max_packet_size,
              upload_callback, dev);

    ret = usb_submit_urb(read_urb);
    if(ret < 0) {
        printk(KERN_WARNING "Failed to submit read_urb for FW upload %d\n", ret);
        goto out_cleanup_urb;
    }

    /* 2. Send "<" command to device */
    ret = usb_bulk_msg(hif_lp->udev, pipe,
                       "<\r", 2, &actual_length, USB_TIMEOUT);
    if(ret < 0) {
        printk(KERN_WARNING "Failed to give < command for FW upload %d\n", ret);
        goto out_unlink_urb;
    }

    /* 3. Send the firmware file in .x2 format to the device
     * enter a loop which reads data blocks from the file and writes them
     * to the USB device via Endpoint 1 */
    do {
        unsigned long length;

        length = 0;
        /* read a block of data until buffer is full or end of file */
        do {
            bcount = read(ifp, &buffer[length], hif_lp->ep1_max_packet_size - length);
            length += bcount;
        } while ((length != hif_lp->ep1_max_packet_size) && (bcount != 0));

        /* Check magic and find LMAC description (first block must contain LMAC descriptor) */
        if( lm_descr == NULL ) {
            unsigned long magic = le32_to_cpu(*(unsigned long *)buffer);
            char *lm_descr_p;

            if(magic != X2MAGIC) {
                printk(KERN_ERR "Firmware file is not a valid .X2 file %lx\n", magic);
                close(ifp);
                set_fs(fs);
                goto out_cleanup_buffer;
            }

            lm_descr_p = get_lmac_descr(hif_lp, buffer);
            lm_descr = sm_parse_lmac( lm_descr_p );
            if( lm_descr == NULL ) {
                printk(KERN_ERR "firmware image does not contain LMAC description\n");

                close(ifp);
                set_fs(fs);
                goto out_cleanup_buffer;
            }

            /* no processing needed done on parse result, but need to keep a copy */
            memcpy( &lp->lm_descr, lm_descr, sizeof(struct s_lm_descr) );
            kfree(lm_descr_p);
        }

        ret = usb_bulk_msg(hif_lp->udev, pipe,
                           buffer, length, &actual_length, USB_TIMEOUT);
        if(ret < 0) {
            printk(KERN_WARNING "Failed to send FW file %d length %ld\n", ret, length);
            goto out_unlink_urb;
        }
    } while (bcount != 0);

    ret = 0;
    close(ifp);
    set_fs(fs);

    /* Now we have to wait for the "OK" or "ERROR" response from the device. This will
     * be handled in the "upload_callback" function.
     * Note that no timeout is implemented, so we cannot detect a "No response" condition.
     */

out_cleanup_buffer:
    kfree(buffer);
    return ret;

out_unlink_urb:
    usb_unlink_urb(read_urb);
out_cleanup_urb:
    kfree(buffer);
    usb_free_urb(read_urb);
    kfree(read_buffer);
    return -1;

}

static void *sm_drv_usb_probe(struct usb_device *udev, unsigned int ifnum,
                              const struct usb_device_id *id)
{
    struct net_local *lp;
    struct usb_hif_local_data *usb_lp = NULL;

    struct usb_interface *interface;

    DEBUG(DBG_CALLS, "sm_drv_usb_probe Vendor ID %x, Product ID %x\n",
          udev->descriptor.idVendor, udev->descriptor.idProduct);

    /* See if the device offered us matches what we can accept */
    if ((udev->descriptor.idVendor != USBVENDOR_GSPN) ||
        (udev->descriptor.idProduct != USBPROD_ID_3887)) {
            return NULL;
    }

    /* allocate memory for our device state and intialize it */
    usb_lp = kmalloc (sizeof(struct usb_hif_local_data), GFP_KERNEL);
    if (!usb_lp) {
            printk(KERN_ERR "Cannot allocate USB local data");
            return NULL;
    }
    memset(usb_lp, 0, sizeof(struct usb_hif_local_data));

    interface = &udev->actconfig->interface[ifnum];
    usb_lp->udev = udev;
    usb_lp->interface = interface;

    /* Create the Network device instance that will interface with the kernel Network stack */
    usb_lp->netdev = sm_drv_netdev_create(NULL, 0, 0);

    if(!usb_lp->netdev)
        goto err_out;

    lp = usb_lp->netdev->priv;

    /* Instantiate the Host Interface specific handlers */
    lp->hif_up      = &sm_drv_usb_up;
    lp->hif_down    = &sm_drv_usb_down;
    lp->hif_cli     = &sm_drv_usb_cli;  // Needed???
    lp->hif_local_data = usb_lp;            /* point back to USB local data */

    spin_lock_init(&usb_lp->lock);

    /* Init our Bottom halve handler */
    lp->tqueue.sync = 0;
    lp->tqueue.routine = (void *)sm_drv_usb_bh;
    lp->tqueue.data = usb_lp->netdev;

    /* Initially, we startup as client.
     * note: sm_drv_up calls our 'sm_drv_usb_up' function
     */
    if (sm_drv_up(usb_lp->netdev, SM_MODE_CLIENT) < 0) {
        kfree(lp);
        goto err_out;
    }

    DEBUG(DBG_ALL, "Prism USB Driver attached\n");

    return usb_lp;

err_out:
    kfree(usb_lp);
    return NULL;
}

static void sm_drv_usb_disconnect(struct usb_device *udev, void *ptr)
{
    struct usb_hif_local_data *usb_lp = (struct usb_hif_local_data *)ptr;

    sm_drv_down(usb_lp->netdev);

    /* unregister the network device */
    unregister_netdev(usb_lp->netdev);
}

/******************************************************************************
 *   Queue Support Functions
 ******************************************************************************/

/* Get rxdata struct at the produce pointer */
static inline void ep_rxdata_get_p(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_rxdata **rxdata)
{
    struct s_ep_rxinfo *ep_rxinfo;

    ep_rxinfo = &(hif_lp->ep_rxinfo[endpoint - 1]);
    *rxdata = &(ep_rxinfo->rxdata[ep_rxinfo->p & (USB_MAX_RX_PACKETS - 1)]);
}

/* Get rxdata struct at the consume pointer */
static inline void ep_rxdata_get_c(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_rxdata **rxdata)
{
    struct s_ep_rxinfo *ep_rxinfo;

    ep_rxinfo = &(hif_lp->ep_rxinfo[endpoint - 1]);
    *rxdata = &(ep_rxinfo->rxdata[ep_rxinfo->c & (USB_MAX_RX_PACKETS - 1)]);
}

/* Get rxdata struct at the free pointer */
static inline void ep_rxdata_get_f(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_rxdata **rxdata)
{
    struct s_ep_rxinfo *ep_rxinfo;

    ep_rxinfo = &(hif_lp->ep_rxinfo[endpoint - 1]);
    *rxdata = &(ep_rxinfo->rxdata[ep_rxinfo->f & (USB_MAX_RX_PACKETS - 1)]);
}

/* Increase RX produce pointer */
static inline void ep_rx_produce(struct usb_hif_local_data *hif_lp, int endpoint)
{
    hif_lp->ep_rxinfo[endpoint - 1].p++;
}

/* Increase RX consume pointer */
static inline void ep_rx_consume(struct usb_hif_local_data *hif_lp, int endpoint)
{
    hif_lp->ep_rxinfo[endpoint - 1].c++;
}

/* Increase RX free pointer */
static inline void ep_rx_free(struct usb_hif_local_data *hif_lp, int endpoint)
{
    hif_lp->ep_rxinfo[endpoint - 1].f++;
}

/* Returns the number of empty RX packets that can be produced/added */
static inline int ep_rx_pspace(struct usb_hif_local_data *hif_lp, int endpoint)
{
    struct s_ep_rxinfo *ep_rxinfo;
    int space;
    unsigned long flags;

    ep_rxinfo = &(hif_lp->ep_rxinfo[endpoint - 1]);

    spin_lock_irqsave(&hif_lp->lock, flags);
    space = USB_MAX_RX_PACKETS - (ep_rxinfo->p - ep_rxinfo->f);
    spin_unlock_irqrestore(&hif_lp->lock, flags);

    return space;
}

/* Returns the number of empty RX packets in the queue */
static inline int ep_rx_cspace(struct usb_hif_local_data *hif_lp, int endpoint)
{
    struct s_ep_rxinfo *ep_rxinfo;
    int space;
    unsigned long flags;

    ep_rxinfo = &(hif_lp->ep_rxinfo[endpoint - 1]);

    spin_lock_irqsave(&hif_lp->lock, flags);
    space = ep_rxinfo->p - ep_rxinfo->c;
    spin_unlock_irqrestore(&hif_lp->lock, flags);

    return space;
}

/* Returns the number of RX packets that are received from the LMAC */
static inline int ep_rx_rspace(struct usb_hif_local_data *hif_lp, int endpoint)
{
    struct s_ep_rxinfo *ep_rxinfo;
    int space;
    unsigned long flags;

    ep_rxinfo = &(hif_lp->ep_rxinfo[endpoint - 1]);

    spin_lock_irqsave(&hif_lp->lock, flags);
    space = ep_rxinfo->c - ep_rxinfo->f;
    spin_unlock_irqrestore(&hif_lp->lock, flags);

    return space;
}

/* Get txdata struct at the produce pointer */
static inline void ep_txdata_get_p(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_txdata **txdata)
{
    struct s_ep_txinfo *ep_txinfo;

    ep_txinfo = &(hif_lp->ep_txinfo[endpoint - 1]);
    *txdata = &(ep_txinfo->txdata[ep_txinfo->p & (USB_MAX_RX_PACKETS - 1)]);
}

/* Get txdata struct at the consume pointer */
static inline void ep_txdata_get_c(struct usb_hif_local_data *hif_lp, int endpoint,
                            struct s_txdata **txdata)
{
    struct s_ep_txinfo *ep_txinfo;

    ep_txinfo = &(hif_lp->ep_txinfo[endpoint - 1]);
    *txdata = &(ep_txinfo->txdata[ep_txinfo->c & (USB_MAX_RX_PACKETS - 1)]);
}

/* Increase TX produce pointer */
static inline void ep_tx_produce(struct usb_hif_local_data *hif_lp, int endpoint)
{
    hif_lp->ep_txinfo[endpoint - 1].p++;
}

/* Increase TX consume pointer */
static inline void ep_tx_consume(struct usb_hif_local_data *hif_lp, int endpoint)
{
    hif_lp->ep_txinfo[endpoint - 1].c++;
}

/* Returns number of TX frames that can be produced */
static inline int ep_tx_pspace(struct usb_hif_local_data *hif_lp, int endpoint)
{
    struct s_ep_txinfo *ep_txinfo;
    int space;
    unsigned long flags;

    ep_txinfo = &(hif_lp->ep_txinfo[endpoint - 1]);

    spin_lock_irqsave(&hif_lp->lock, flags);
    space = USB_MAX_TX_PACKETS - (ep_txinfo->p - ep_txinfo->c);
    spin_unlock_irqrestore(&hif_lp->lock, flags);

    return space;
}

/* Returns number of TX frames that can be consumed */
static inline int ep_tx_cspace(struct usb_hif_local_data *hif_lp, int endpoint)
{
    struct s_ep_txinfo *ep_txinfo;
    int space;
    unsigned long flags;

    ep_txinfo = &(hif_lp->ep_txinfo[endpoint - 1]);

    spin_lock_irqsave(&hif_lp->lock, flags);
    space = (ep_txinfo->p - ep_txinfo->c);
    spin_unlock_irqrestore(&hif_lp->lock, flags);

    return space;
}

/******************************************************************************
 *   Module Init
 ******************************************************************************/

/* table of devices that work with this driver */
static struct usb_device_id sm_drv_usb_table [] = {
        { USB_DEVICE(USBVENDOR_GSPN, USBPROD_ID_3887) },
        { }
};

MODULE_DEVICE_TABLE (usb, sm_drv_usb_table);

/* usb specific object needed to register this driver with the usb subsystem */
static struct usb_driver sm_drv_usb_driver = {
        name:           DRIVER_NAME,
        probe:          sm_drv_usb_probe,
        disconnect:     sm_drv_usb_disconnect,
        id_table:       sm_drv_usb_table,
        /* We are only a network device, so no char device support */
        fops:           NULL,
        minor:          0,
        ioctl:          NULL,
};

static int __init sm_drv_usb_init_module( void )
{
    if (usb_register(&sm_drv_usb_driver) < 0) {
        printk(KERN_WARNING "Could not register SoftMAC USB Driver\n");
        return -1;
    }

#ifdef NETLINK_SUPPORT
    mgt_initialize();
#endif

    DEBUG(DBG_ALL, "Loaded SoftMAC USB driver, version %s\n", VERSIONID);

    return 0;
}

static void __exit sm_drv_usb_cleanup_module( void )
{

#ifdef NETLINK_SUPPORT
    mgt_cleanup();
#endif

    usb_deregister(&sm_drv_usb_driver);

    DEBUG(DBG_ALL, "Unloaded SoftMAC USB driver, version %s\n", VERSIONID);
}

module_init(sm_drv_usb_init_module);
module_exit(sm_drv_usb_cleanup_module);
