/*  $Header$
 *
 * IMPORTANT NOTICE -- READ CAREFULLY: This License For Customer Use of
 * Conexant Software ("LICENSE") is the agreement which governs use of the
 * software of Conexant Corporation and its subsidiaries ("Conexant") downloadable
 * herefrom, including computer software and associated printed materials
 * ("SOFTWARE").  By downloading, installing, copying, or otherwise using the
 * SOFTWARE, you agree to be bound by the terms of this LICENSE.  If you do not
 * agree to the terms of this LICENSE, do not download the SOFTWARE.
 *
 * RECITALS
 * The Conexant SOFTWARE is intended to be used with products incorporating
 * Conexant's PRISM® wireless local area network (WLAN) IC chipsets.  The
 * SOFTWARE is protected by copyright laws and international copyright treaties, as
 * well as other intellectual property laws and treaties.  The SOFTWARE is not sold,
 * and instead is only licensed for use, strictly in accordance with this document.
 * This LICENSE does not cover the PRISM WLAN IC chipsets, or any intellectual
 * property rights therein.  This agreement sets forth the terms and conditions of
 * the SOFTWARE LICENSE only.
 *
 * 1.  DEFINITIONS
 *
 * 1.1  Customer.  Customer means the entity or individual that downloads the
 * SOFTWARE.
 *
 * 2.  GRANT OF LICENSE
 *
 * 2.1  Rights and Limitations of Grant.  CONEXANT hereby grants Customer the
 * following non-exclusive, non-transferable right to use the SOFTWARE, with the
 * following limitations:
 *
 * 2.1.1  Rights.  Customer may install and use one copy of the SOFTWARE on a
 * single computer, and except for making one back-up copy of the Software, may
 * not otherwise copy the SOFTWARE.  This LICENSE of SOFTWARE may not be
 * shared or used concurrently on different computers.
 *
 * 2.1.2  Linux Exception.  Notwithstanding the foregoing terms of Section 2.1.1,
 * SOFTWARE designed exclusively for use on the Linux operating system may be
 * (1) copied and redistributed, and (2) modified solely to the extent such software
 * is provided in source code format;  binary, or object code format, files shall not
 * be modified in any way (except for unzipping of compressed files).
 *
 * 2.1.3  Limitations.
 * No Reverse Engineering.  Customer may not reverse engineer, decompile, or
 * disassemble the SOFTWARE, nor attempt in any other manner to obtain the
 * source code unless it is expressly provided hereunder.
 * No Separation of Components.  The SOFTWARE is licensed as a single product.
 * Its component parts may not be separated for use on more than one computer,
 * nor otherwise used separately from the other parts.
 *
 * No Rental.  Customer may not rent or lease the SOFTWARE to someone else.
 *
 * 3.  TERMINATION
 *
 * This LICENSE will automatically terminate if Customer fails to comply with any of
 * the terms and conditions herein.  In such event, Customer must destroy all
 * copies of the SOFTWARE and all of its component parts.
 *
 * 4.  COPYRIGHT
 *
 * All title and copyrights in and to the SOFTWARE (including but not limited to all
 * images, photographs, animations, video, audio, music, text, and other
 * information incorporated into the SOFTWARE), any accompanying written
 * materials, and any copies of the SOFTWARE, are owned or licensed by
 * CONEXANT.  The SOFTWARE is protected by copyright laws and international
 * treaty provisions.  Accordingly, Customer is required to treat the SOFTWARE like
 * any other copyrighted material, except as otherwise allowed pursuant to this
 * LICENSE and that it may make one copy of the SOFTWARE solely for backup or
 * archive purposes.  User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential legends
 * placed upon, contained within or associated with the Software, and shall include
 * all such unaltered copyright, trademark, credits, other proprietary notices or
 * confidential legends on or in every copy of the Software.
 *
 * 5.  APPLICABLE LAW
 *
 * This agreement shall be deemed to have been made in, and shall be construed
 * pursuant to, the laws of the State of California.
 *
 * 6.  DISCLAIMER OF WARRANTIES AND LIMITATION ON LIABILITY
 *
 * 6.1  No Warranties.  CONEXANT AND ITS LICENSORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
 * PURPOSE.   TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE
 * SOFTWARE IS PROVIDED "AS IS" AND CONEXANT AND ITS LICENSORS DISCLAIM
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 * LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, GOOD TITLE AND NON-INFRINGEMENT.
 * There is no guarantee that this SOFTWARE is free of errors including, but not
 * limited to, bugs, defects, interrupted operation, or unexpected results. Any use
 * of this SOFTWARE is at user's own risk.
 *
 * 6.2  (a) CONEXANT and its LICENSORS shall not be responsible for any loss or
 * damage to users, customers, or any third parties for any reason whatsoever, and
 * CONEXANT AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY ACTUAL,
 * DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR
 * OTHER LEGAL THEORY OF LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * (b) User agrees to hold CONEXANT and its licensors harmless from any liability,
 * loss, cost, damage or expense, including attorney's fees, as a result of any claims
 * which may be made by any person, including but not limited to User, its agents
 * and employees, its customers, or any third parties that arise out of or result from
 * the manufacture, delivery, actual or alleged ownership, performance, use,
 * operation or possession of the software furnished hereunder, whether such
 * claims are based on negligence, breach of contract, absolute liability or any other
 * legal theory.
 *
 * 7.  MISCELLANEOUS
 *
 * The United Nations Convention on Contracts for the International Sale of Goods is
 * specifically disclaimed.  If any provision of this LICENSE is inconsistent with, or cannot
 * be fully enforced under, the law, such provision will be construed as limited to the extent
 * necessary to be consistent with and fully enforceable under the law.  This agreement is
 * the final, complete and exclusive agreement between the parties relating to the subject
 * matter hereof, and supersedes all prior or contemporaneous understandings and
 * agreements relating to such subject matter, w;hether oral or written.  Customer agrees that
 * it will not ship, transfer or export the SOFTWARE into any country, or use the
 * SOFTWARE in any manner, prohibited by the United States Bureau of Export
 * Administration or any export laws, restrictions or regulations.  This LICENSE may only
 * be modified in writing signed by an authorized officer of Conexant.
 *;
 * Copyright (C) 2003 Conexant Americas Inc. All Rights Reserved.
 *
 */

#include <linux/version.h>
#ifdef MODULE
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/module.h>
#else
#define MOD_INC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#include <linux/init.h>
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/string.h>
#include <linux/poll.h>

#include "sm_drv.h"
#include "sm_drv_vss.h"


/******************************************************************************

 *   Virtual Service Set functions

 ******************************************************************************/

/**********************************************************************

 *  add_vss_device

 *

 *  DESCRIPTION: Routine to create and add the VSS device.

 *

 *  PARAMETERS:  struct net_device *dev - Parent device
 
 *               struct vss_priv *vssp - VSS local structure 

 *               int vssid             - VSS Id

 *

 *  RETURN:      < 1 : Failure

 *                0  : Success

 *

 **********************************************************************/

int add_vss_device (struct net_device *dev, struct vss_priv *vssp,
					int vssid)

{

    int err = 0;

    int i=0;

    struct net_device *vss_dev;

	char ifname[32];


    DEBUG( DBG_VSS, "add_vss_device \n");


    if ( ( dev == NULL ) || ( vssp == NULL ) )

    {

        DEBUG( DBG_VSS, "add_vss_device (%lx, %lx) wrong parameter(s)!\n",

            (unsigned long)dev, (unsigned long)vssp );

        return -1;

    }

    if (vssp->current_nof_devs == MAX_VSS_DEVICES)

    {

        /* Max number of devices reached */

        DEBUG( DBG_VSS, "add_vss_device: max number of VSS devices (%d) reached!\n", MAX_VSS_DEVICES);

        return -3;

    }

    /* Check if this vss id is already in the list*/
	for (i=0 ; i< MAX_VSS_DEVICES; i++)
    {
		if( (vssp->vss_dev[i]) && 
            (((struct vss_dev_local*)(vssp->vss_dev[i]->priv))->vssid == vssid) )
		{
			DEBUG( DBG_VSS, "add_vss_device: Device %d exists\n", vssid);

            return -3;
		}
	}
   
    /* Find an empty field to add VSS device */

    for (i=0 ; i< MAX_VSS_DEVICES; i++)

    {
        if (vssp->vss_dev[i] == NULL)

        {

            /* We have found an empty structure
             * So we can actualy create a new device for this link
             */

            sprintf(ifname, "vss%s.%d", dev->name, vssid );

            if ( !(vssp->vss_dev[i] = dev_alloc(ifname, &err) ) )

            {

                DEBUG( DBG_VSS,"add_vss_device: dev_alloc() for VSS failed!\n");

                return -6;

            }

            /* Get a pointer to this VSS device */

            vss_dev = vssp->vss_dev[i];


            /* May be overridden by piggyback drivers */

            ether_setup(vss_dev);


            /* Initialize the device priv structure. */

            vss_dev->priv = kmalloc(sizeof(struct vss_dev_local), GFP_KERNEL);

            if (vss_dev->priv == NULL) {

                return -7;

            }

            memset(vss_dev->priv, 0, sizeof(struct vss_dev_local));

            /* Set the parent device for this VSS device */

            ((struct vss_dev_local*)(vss_dev->priv))->parent_dev = dev;



            /* Set VSS Id in priv structure*/
			((struct vss_dev_local*)(vss_dev->priv))->vssid = vssid;

                        
            /* Override the network functions we need to use */

            vss_dev->open                       = vss_dev_open;

            vss_dev->stop                       = vss_dev_close;

            vss_dev->get_stats                  = vss_dev_get_stats;

            vss_dev->hard_start_xmit            = vss_dev_send_packet;

            vss_dev->do_ioctl                   = vss_dev_ioctl;


            /* Make ifconfig display some details */

            vss_dev->base_addr = 0;

            /*
             * Used in Linux bridge to sent packets back on own port.
             * Use only when it's defined in linux/if.h header file.
             */
#ifdef IFF_802_11_WLAN
            vss_dev->priv_flags |= IFF_802_11_WLAN;
#endif

            err = register_netdevice(vss_dev);

            if (err)

            {

                DEBUG( DBG_VSS,"add_vss_device: register_netdev() for VSS failed!\n");

                return -8;

            }

            DEBUG(DBG_VSS, "add_vss_device: registered device: %s\n", vss_dev->name);


            /* Bring the device up, when the root device is UP... */

            if (dev->flags & IFF_UP)

            {

                err = dev_open(vss_dev);

                if (err)

                {
                    DEBUG(DBG_VSS, "add_vss_device: dev_open() for VSS failed!\n");

                    return -9;

                 }
                 DEBUG(DBG_VSS, "add_vss_device: bringing up device: %s\n", vss_dev->name);

            }

            else

            {

                DEBUG(DBG_VSS, "add_vss_device: NOT bringing up device: %s, cause root device isn't up yet...\n", 
					  vss_dev->name);

            }

            vssp->current_nof_devs++;

            return 0;

        }

    }
    return -13;

}


/**********************************************************************

 *  del_vss_device

 *

 *  DESCRIPTION: Routine to delete the VSS device.

 *

 *  PARAMETERS:  struct net_device *dev - Parent device
 
 *               struct vss_priv *vssp - VSS local structure 

 *               int vssid - VSS Identifier

 *

 *  RETURN:      < 1 : Failure

 *                0  : Success

 *

 **********************************************************************/

int del_vss_device (struct net_device *dev, struct vss_priv *vssp, int vssid)
{

    int err = 0;

    int i = 0;


    struct net_device *vss_dev;



    DEBUG( DBG_VSS, "del_vss_device \n");


    if ( ( dev == NULL ) || ( vssp == NULL ) )

    {

        printk( KERN_INFO "del_vss_device(%lx, %lx) wrong parameter(s)!\n",

               (unsigned long)dev, (unsigned long)vssp);

        return -1;

    }

    /* Look for the VSS device with the specified VSS ID */

    for (i=0 ; i< MAX_VSS_DEVICES; i++)

    {

        if( (vssp->vss_dev[i]) && 
            (((struct vss_dev_local*)(vssp->vss_dev[i]->priv))->vssid == vssid) )
        {

            vss_dev = (struct net_device *)vssp->vss_dev[i];

            /* Bring the device down */

            err = dev_close (vss_dev);

            if (err)

            {

                printk( KERN_INFO "del_vss_device: dev_close() for VSS failed!\n");

                return err;

            }

            /* No need to lock cause the net_ioctl is already locked */

            err = unregister_netdevice(vss_dev);

            if (err != 0)

            {

                printk( KERN_INFO "del_vss_device: VSS device could not be unregistered!\n");

                return err;

            }

            kfree(vss_dev->priv);

            kfree(vss_dev);

            vssp->current_nof_devs--;

            vssp->vss_dev[i] = NULL;

            DEBUG(DBG_VSS, "del_vss_device: VSS device removed succesfully\n");

            return err;

        }

    }

    printk( KERN_INFO "del_vss_device: No such device found\n");

    return -1;

}

/**********************************************************************
 *  del_all_vss_devices
 *
 *  DESCRIPTION: Routine to delete all the VSS devices.
 *
 *  PARAMETERS:  struct vss_priv *vssp - VSS local structure
 *               
 *  RETURN:      < 1 : Failure
 *                0  : Success
 *
 **********************************************************************/
int del_all_vss_devices(struct vss_priv *vssp)
{
    int err, i;
    struct net_device *vss_dev;

    DEBUG( DBG_VSS, "del_all_vss_devices \n");

    if ( vssp == NULL )
    {
        printk( KERN_INFO "del_all_vss_devices(%p) wrong parameter(s)!\n", vssp);
        return -1;
    }

    for (i=0 ; i< MAX_VSS_DEVICES; i++)
    {
        if( vssp->vss_dev[i])
        {
            vss_dev = (struct net_device *)vssp->vss_dev[i];

	    /* Bring the device down */
            err = dev_close (vss_dev);

            if (err)
            {
                printk( KERN_INFO "del_all_vss_devices: dev_close() for VSS failed!\n");
                continue;
            }

            /* No need to lock cause the net_ioctl is already locked */
            err = unregister_netdevice(vss_dev);

            if (err != 0)
            {
                printk( KERN_INFO "del_all_vss_devices: VSS device could not be unregistered!\n");
                continue;
            }

            kfree(vss_dev->priv);
            kfree(vss_dev);
            vssp->current_nof_devs--;
            vssp->vss_dev[i] = NULL;

            DEBUG(DBG_VSS, "del_all_vss_devices: VSS device removed succesfully\n");
        }
    }

    return 0;
}



/**********************************************************************

 *  open_vss_devices

 *

 *  DESCRIPTION: Routine to open all the VSS devices created on the

 *               wireless interface

 *

 *  PARAMETERS:  struct vss_priv *vssp - VSS local structure 
 
 *

 *  RETURN:      < 1 : Failure

 *                0  : Success

 *

 **********************************************************************/

int open_vss_devices(struct vss_priv *vssp)

{

    int i;

    DEBUG(DBG_VSS, "open_vss_devices \n");


    if ( vssp == NULL ) {

        DEBUG( DBG_VSS, "open_vss_devices: no resources");

        return -1;

    }

    /* Bring the associated VSS devices up and RUNNING. */

    DEBUG(DBG_VSS, "Open all associated VSS devices: ");


    for (i = 0; i < MAX_VSS_DEVICES; i++)

    {
        if (vssp->vss_dev[i] == NULL)
            continue;

        dev_open(vssp->vss_dev[i]);
    }

    DEBUG(DBG_VSS, "\n");

    return 0;
}


/**********************************************************************

 *  close_vss_devices

 *

 *  DESCRIPTION: Routine to close all the VSS devices.

 *

 *  PARAMETERS:  struct vss_priv *vssp - VSS local structure 
 
 *

 *  RETURN:      < 1 : Failure

 *                0  : Success

 *

 **********************************************************************/

int close_vss_devices (struct vss_priv *vssp)

{

    int i;


    DEBUG(DBG_VSS, "close_vss_devices \n");

    if ( vssp == NULL ) {

        DEBUG( DBG_VSS, "close_vss_devices: no resources");

        return -1;

    }

    
    for (i = 0; i < MAX_VSS_DEVICES; i++)

    {

        if (vssp->vss_dev[i] == NULL)
            continue;

        dev_close(vssp->vss_dev[i]);	
    }

    DEBUG(DBG_VSS, "\n");

    return 0;

}

inline int check_skb_for_vss(struct sk_buff *skb, uint8_t *vssid)
{
    /* If this skb came from a VSS device, the
     * skb->cb field will be filled with a VSS id.
     * Due to the reason the cb field is free to use, the VSS id
     * will be packed in the following keys "VSSL"vssid".
     */

    if(*(long*)&skb->cb[0] == cpu_to_le32(0x4c535356)) /* VSSL */
    {
        *(vssid) = skb->cb[4];
        /* Make the VSS data invalid */
        *(long*)&skb->cb[0] = 0;

        return(1);      /* VSS is available */
    }
    
    return(0);          /* VSS is unavailable */
}



/**********************************************************************

 *  vss_find_device

 *

 *  DESCRIPTION: Routine to find the VSS device corresponding to VSS ID.

 *

 *  PARAMETERS:  int vssid - VSS Identifier
 
 *               struct vss_priv *vssp - VSS local structure 

 *  RETURN:      struct net_device * : Device found

 *               NULL  : Failure

 *

 **********************************************************************/

struct net_device *vss_find_device (int vssid, struct vss_priv *vssp )
{

    int i=0;

    if ( vssp == NULL ) {

        DEBUG(DBG_VSS, "vss_find_device: vss_priv not found, returning NULL\n");

        return NULL;

    }

    for (i=0; i < MAX_VSS_DEVICES; i++)

    {

        if (vssp->vss_dev[i] == NULL)

            continue;

        if (((struct vss_dev_local*)(vssp->vss_dev[i]->priv))->vssid == vssid)

        {

            DEBUG(DBG_VSS, "vss_find_device: vssid found, returning dev->name: %s\n",

                   vssp->vss_dev[i]->name);

            return ((struct net_device*)vssp->vss_dev[i]);

        }

    }

    DEBUG(DBG_VSS, "vss_find_device: No VSS device of Id %d found, returning NULL\n", vssid);
           
    return NULL;

}

/**********************************************************************

 *  vss_dev_open

 *

 *  DESCRIPTION: Routine to open a VSS device.

 *

 *  PARAMETERS:  struct net_device * : VSS Device
 
 
 *  RETURN:      < 1: Failure

 *               0  : Success

 *

 **********************************************************************/
int vss_dev_open(struct net_device *dev)

{

    int err = 0;


    DEBUG(DBG_VSS, "vss_dev_open \n");


    netif_start_queue(dev);


    return err;

}


/**********************************************************************

 *  vss_dev_send_packet

 *

 *  DESCRIPTION: Routine to transmit a packet from VSS to the network.

 *

 *  PARAMETERS:  struct sk_buff *skb : Data buffer

 *               struct net_device * : VSS Device
 
 *  RETURN:      < 1: Failure

 *               0  : Success

 *

 **********************************************************************/

int vss_dev_send_packet(struct sk_buff *skb, struct net_device *dev)
{

    struct vss_dev_local *vss_local = (struct vss_dev_local *)dev->priv;

    DEBUG(DBG_VSS, "vss_dev_send_packet\n");

    if (vss_local == NULL)
    {
        printk("vss_dev_send_packet: NULL pointer detected\n");
        return 0;
    }

    if ((vss_local->parent_dev->flags & IFF_UP) && (dev->flags & IFF_UP))
    {
	/* Mark the frame as VSS, and set the vssid. */
        memcpy(skb->cb, "VSSL", 4);
        skb->cb[4] = vss_local->vssid;

        /* Set the "transmit" dev in this skb */
        skb->dev = vss_local->parent_dev;
        
        /* Move this skb to the "transmit" devices queue */
        if(dev_queue_xmit(skb) < 0)
        {
            DEBUG( DBG_VSS, "vss_dev_send_packet: dev_queue_xmit failed\n");
        }

        /* Update stats for this device */
        vss_local->stats.tx_packets++;
        vss_local->stats.tx_bytes += skb->len;
    }

    return 0;

}


/**********************************************************************

 *  vss_dev_close

 *

 *  DESCRIPTION: Routine to close the VSS device.

 *

 *  PARAMETERS:  struct net_device * : VSS Device

 *               
 
 *  RETURN:      < 1: Failure

 *               0  : Success

 *

 **********************************************************************/

int vss_dev_close(struct net_device *dev)

{

    int err = 0;

    DEBUG(DBG_VSS, "vss_dev_close \n");

    netif_stop_queue(dev);

    return err;

}


/**********************************************************************

 *  vss_dev_get_stats

 *

 *  DESCRIPTION: Gets the statistics for the VSS device.

 *

 *  PARAMETERS:  struct net_device *dev - VSS device to get statistics from.

 *

 *  RETURN:      pointer to net_device_stats struct.

 *

 **********************************************************************/

struct net_device_stats* vss_dev_get_stats (struct net_device *dev)

{

    struct vss_dev_local *vss_local = (struct vss_dev_local *)dev->priv;

    struct net_device_stats *stats = &vss_local->stats;



    DEBUG(DBG_VSS, "vss_dev_get_stats \n");

    return stats;

}



/**********************************************************************

 *  vss_dev_ioctl

 *

 *  DESCRIPTION: Ioctl for VSS devices are NOT supported.

 *

 *  PARAMETERS:  struct net_device *dev - vss device

 *               struct ifreq      *ifr - ioctl request

 *               int    cmd         - request type

 *

 *  RETURN:      -EINVAL.

 *

 **********************************************************************/

int vss_dev_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd)

{
    return -EINVAL;
}
