/*  $Header$
 *
 *  Copyright (C) 2003 Intersil Americas Inc.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License.
 * 
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _PRISMIOCTL_H
#define _PRISMIOCTL_H

#include <stdint.h>
#include <smoid2.h>

/* ioctl interface */
#define SOFTMACIOCTL                    SIOCDEVPRIVATE

#define SMIOC_IFRESET                   1
#define SMIOC_CARDRESET                 2
#define SMIOC_GETOID                    3
#define SMIOC_SETOID                    4

struct s_softmac_ioctl {
    unsigned long cmd;
    unsigned long oid;
    unsigned long len;
    char *data;
};

/* Getting/Setting OIDs through the ioctl interface */
extern int prismioctl_open(void);
extern int prismioctl_close(void);
extern int get_prismioctl(char *ifname, unsigned int oid, void *data, int data_len);
extern int set_prismioctl(char *ifname, unsigned int oid, void *data, int data_len);

extern char *prismioctl_version(void);

#endif /* _PRISMIOCTL_H */
