/*  $Header$
 *
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License.
 * 
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _PRISMOIDS_H
#define _PRISMOIDS_H


#include <linux/types.h>
#include <linux/netlink.h>
#include <linux/isil_netlink.h>
#include "smoid2.h"


struct netlink_handle
{
	int			fd;
	struct sockaddr_nl	local;
	__u32			seq;
};

/* Getting/Setting OIDs */
extern int prismoid_open(void);
extern int prismoid_close(void);
extern int get_prismoid(char *ifname, unsigned int oid, void *data, int data_len);
extern int set_prismoid(char *ifname, unsigned int oid, void *data, int data_len);

/*
 * Prism Traps.
 * When a prismtraps link is opened, a bitmask of trapgroups as defined in the file
 * include/linux/isil_netlink.h should be passed for all traps that an application
 * wants to receive.
 */
extern int prismtraps_open(struct netlink_handle *netlink_h, __u32 trapgroup);
extern int prismtraps_close(struct netlink_handle *netlink_h);
extern int prismtraps_decode(struct netlink_handle *netlink_h, __u32 *trapoid,
			__u32 *devid, char **trapdata, __u32 *data_len);

extern char *prismoids_version(void);

#endif /* _PRISMOIDS_H */
